using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Summary description for AlumniMenu
/// </summary>
/// 

namespace AlumniMenu
{
    public class AlumniMenu : Menu
    {
        public AlumniMenu()
            : base()
        {

        }

        protected override void Render(HtmlTextWriter writer)
        {            
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "alumniMenu");
            writer.RenderBeginTag(HtmlTextWriterTag.Menu);
            RenderOneLevelItems(writer, this.Items);
            writer.RenderEndTag();
        }

        private void RenderOneLevelItems(HtmlTextWriter writer, MenuItemCollection currentItems)
        {            
            for (int i = 0; i < currentItems.Count; i++)
            {
                MenuItem item = currentItems[i];               
                writer.RenderBeginTag(HtmlTextWriterTag.Li);
                writer.AddAttribute(HtmlTextWriterAttribute.Href, item.NavigateUrl);
                writer.AddAttribute(HtmlTextWriterAttribute.Title, item.ToolTip);
                writer.RenderBeginTag(HtmlTextWriterTag.A);
                writer.Write(item.Text);
                writer.RenderEndTag();
                writer.RenderEndTag();
                if (item.ChildItems.Count > 0)
                {
                    RenderOneLevelItems(writer, item.ChildItems);
                }
            }            
        }
    }

}
