using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class BlacklistSpravaBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( BlacklistSprava blacklistSprava )
    {
        BlacklistSpravaDAL.Delete( blacklistSprava );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( BlacklistSprava blacklistSprava )
    {
        BlacklistSpravaDAL.Insert( blacklistSprava );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<BlacklistSprava> Select()
    {
        return BlacklistSpravaDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static BlacklistSprava SelectById( int id )
    {
        return BlacklistSpravaDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<BlacklistSprava> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( BlacklistSpravaDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return BlacklistSpravaDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( BlacklistSprava blacklistSprava )
    {
        BlacklistSpravaDAL.Update( blacklistSprava );
    }

    private static List<BlacklistSprava> PagedAndSorted( List<BlacklistSprava> blacklistSpravaList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<BlacklistSprava> result = new List<BlacklistSprava>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            blacklistSpravaList.Sort( new ObjectComparer<BlacklistSprava>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = blacklistSpravaList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( blacklistSpravaList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
