using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class JazykBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Jazyk jazyk )
    {
        JazykDAL.Delete( jazyk );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Jazyk jazyk )
    {
        JazykDAL.Insert( jazyk );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Jazyk> Select()
    {
        return JazykDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Jazyk SelectById( int id )
    {
        return JazykDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Jazyk> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( JazykDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return JazykDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Jazyk jazyk )
    {
        JazykDAL.Update( jazyk );
    }

    private static List<Jazyk> PagedAndSorted( List<Jazyk> jazykList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Jazyk> result = new List<Jazyk>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            jazykList.Sort( new ObjectComparer<Jazyk>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = jazykList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( jazykList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
