using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class OdvetvieBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Odvetvie odvetvie )
    {
        OdvetvieDAL.Delete( odvetvie );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Odvetvie odvetvie )
    {
        OdvetvieDAL.Insert( odvetvie );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Odvetvie> Select()
    {
        return OdvetvieDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Odvetvie SelectById( int id )
    {
        return OdvetvieDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Odvetvie> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( OdvetvieDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return OdvetvieDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Odvetvie odvetvie )
    {
        OdvetvieDAL.Update( odvetvie );
    }

    private static List<Odvetvie> PagedAndSorted( List<Odvetvie> odvetvieList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Odvetvie> result = new List<Odvetvie>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            odvetvieList.Sort( new ObjectComparer<Odvetvie>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = odvetvieList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( odvetvieList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
