using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class OperaciaBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Operacia operacia )
    {
        OperaciaDAL.Delete( operacia );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Operacia operacia )
    {
        OperaciaDAL.Insert( operacia );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Operacia> Select()
    {
        return OperaciaDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Operacia SelectById( int id )
    {
        return OperaciaDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Operacia> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( OperaciaDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return OperaciaDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Operacia operacia )
    {
        OperaciaDAL.Update( operacia );
    }

    private static List<Operacia> PagedAndSorted( List<Operacia> operaciaList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Operacia> result = new List<Operacia>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            operaciaList.Sort( new ObjectComparer<Operacia>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = operaciaList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( operaciaList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
