using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class PrispevokBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Prispevok prispevok )
    {
        PrispevokDAL.Delete( prispevok );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Prispevok prispevok )
    {
        PrispevokDAL.Insert( prispevok );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Prispevok> Select()
    {
        return PrispevokDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Prispevok SelectById( int id )
    {
        return PrispevokDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Prispevok> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( PrispevokDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return PrispevokDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Prispevok prispevok )
    {
        PrispevokDAL.Update( prispevok );
    }

    private static List<Prispevok> PagedAndSorted( List<Prispevok> prispevokList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Prispevok> result = new List<Prispevok>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            prispevokList.Sort( new ObjectComparer<Prispevok>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = prispevokList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( prispevokList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
