using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class ProjektBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Projekt projekt )
    {
        ProjektDAL.Delete( projekt );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Projekt projekt )
    {
        ProjektDAL.Insert( projekt );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Projekt> Select()
    {
        return ProjektDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Projekt SelectById( int id )
    {
        return ProjektDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Projekt> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( ProjektDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return ProjektDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Projekt projekt )
    {
        ProjektDAL.Update( projekt );
    }

    private static List<Projekt> PagedAndSorted( List<Projekt> projektList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Projekt> result = new List<Projekt>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            projektList.Sort( new ObjectComparer<Projekt>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = projektList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( projektList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
