using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class StatBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Stat stat )
    {
        StatDAL.Delete( stat );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Stat stat )
    {
        StatDAL.Insert( stat );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Stat> Select()
    {
        return StatDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Stat SelectById( int id )
    {
        return StatDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Stat> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( StatDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return StatDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Stat stat )
    {
        StatDAL.Update( stat );
    }

    private static List<Stat> PagedAndSorted( List<Stat> statList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Stat> result = new List<Stat>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            statList.Sort( new ObjectComparer<Stat>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = statList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( statList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
