using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class StudiumBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Studium studium )
    {
        StudiumDAL.Delete( studium );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Studium studium )
    {
        StudiumDAL.Insert( studium );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Studium> Select()
    {
        return StudiumDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Studium SelectById( int id )
    {
        return StudiumDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Studium> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( StudiumDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return StudiumDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Studium studium )
    {
        StudiumDAL.Update( studium );
    }

    private static List<Studium> PagedAndSorted( List<Studium> studiumList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Studium> result = new List<Studium>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            studiumList.Sort( new ObjectComparer<Studium>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = studiumList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( studiumList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
