using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class TypSpravyBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( TypSpravy typSpravy )
    {
        TypSpravyDAL.Delete( typSpravy );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( TypSpravy typSpravy )
    {
        TypSpravyDAL.Insert( typSpravy );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<TypSpravy> Select()
    {
        return TypSpravyDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static TypSpravy SelectById( int id )
    {
        return TypSpravyDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<TypSpravy> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( TypSpravyDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return TypSpravyDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( TypSpravy typSpravy )
    {
        TypSpravyDAL.Update( typSpravy );
    }

    private static List<TypSpravy> PagedAndSorted( List<TypSpravy> typSpravyList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<TypSpravy> result = new List<TypSpravy>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            typSpravyList.Sort( new ObjectComparer<TypSpravy>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = typSpravyList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( typSpravyList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
