using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;

[System.ComponentModel.DataObject]
public partial class ZamestnanieBLL
{
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public static void Delete( Zamestnanie zamestnanie )
    {
        ZamestnanieDAL.Delete( zamestnanie );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public static void Insert( Zamestnanie zamestnanie )
    {
        ZamestnanieDAL.Insert( zamestnanie );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
    public static List<Zamestnanie> Select()
    {
        return ZamestnanieDAL.Select();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static Zamestnanie SelectById( int id )
    {
        return ZamestnanieDAL.SelectById( id );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static List<Zamestnanie> SelectPagedSorted( int maximumRows, int startRowIndex, string sortExpression )
    {
        return PagedAndSorted( ZamestnanieDAL.Select(), maximumRows, startRowIndex, sortExpression );
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
    public static int SelectCount()
    {
        return ZamestnanieDAL.SelectCount();
    }

    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public static void Update( Zamestnanie zamestnanie )
    {
        ZamestnanieDAL.Update( zamestnanie );
    }

    private static List<Zamestnanie> PagedAndSorted( List<Zamestnanie> zamestnanieList, int maximumRows, int startRowIndex, string sortExpression )
    {
        List<Zamestnanie> result = new List<Zamestnanie>();

        if ( sortExpression != String.Empty )
        {
            string[] sortOptions = sortExpression.Split( new char[] { ' ' } );
            zamestnanieList.Sort( new ObjectComparer<Zamestnanie>( sortOptions[0], ( sortOptions.GetLength(0) == 1 ? "ASC" : sortOptions[1] ) ) );
        }

        int currentIndex = startRowIndex;
        int pageIndex = 0;
        int totalRecords = zamestnanieList.Count;

        while ( pageIndex < maximumRows && currentIndex < totalRecords )
        {
            result.Add( zamestnanieList[currentIndex] );

            currentIndex++;
            pageIndex++;
        }

        return result;
    }
}
