using System;
using System.Data;
using System.Configuration;

public partial class Kurz
{
    private int id;
    private string nazov;
    private DateTime? datumOd;
    private DateTime? datumDo;
    private string poznamka;
    private int osobaId;

    public Kurz() {}

    public Kurz( int id, string nazov, int osobaId )
    {
        this.id = id;
        this.nazov = nazov;
        this.datumOd = null;
        this.datumDo = null;
        this.poznamka = null;
        this.osobaId = osobaId;
    }

    public Kurz( int id, string nazov, DateTime? datumOd, DateTime? datumDo, string poznamka, 
        int osobaId
    )
    {
        this.id = id;
        this.nazov = nazov;
        this.datumOd = datumOd;
        this.datumDo = datumDo;
        this.poznamka = poznamka;
        this.osobaId = osobaId;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public string Nazov
    {
        get { return nazov; }
        set { nazov = value; }
    }
    public DateTime? DatumOd
    {
        get { return datumOd; }
        set { datumOd = value; }
    }
    public DateTime? DatumDo
    {
        get { return datumDo; }
        set { datumDo = value; }
    }
    public string Poznamka
    {
        get { return poznamka; }
        set { poznamka = value; }
    }
    public int OsobaId
    {
        get { return osobaId; }
        set { osobaId = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        nazov = reader.GetString(1);

        if ( reader.IsDBNull(2) ) datumOd = null;
        else datumOd = reader.GetDateTime(2);

        if ( reader.IsDBNull(3) ) datumDo = null;
        else datumDo = reader.GetDateTime(3);

        if ( reader.IsDBNull(4) ) poznamka = null;
        else poznamka = reader.GetString(4);

        osobaId = reader.GetInt32(5);
    }
}
