using System;
using System.Data;
using System.Configuration;

public partial class Osoba
{
    private int id;
    private int typOsobyId;
    private string konto;
    private bool kontoAktivne;
    private string heslo;
    private DateTime? poslednePrihlasenie;
    private string poslednaIp;
    private string meno;
    private string tituly;
    private string priezvisko;
    private string rodnePriezvisko;
    private string statnaPrislusnost;
    private string materinskyJazyk;
    private string telefon;
    private string mobil;
    private string fax;
    private string msn;
    private string email;
    private string web;
    private string pohlavie;
    private DateTime datumNarodenia;
    private int? rokAbsolvovania;
    private string zivotopisIne;
    private string icq;
    private string skype;
    private string socialneZrucnosti;
    private string organizacneZrucnosti;
    private string technickeZrucnosti;
    private string pocitacoveZrucnosti;
    private string umeleckeZrucnosti;
    private string dalsieZrucnosti;
    private string vodicskyPreukaz;

    public Osoba() {}

    public Osoba( int id, int typOsobyId, string konto, bool kontoAktivne, string heslo, 
        string meno, string priezvisko, string email, DateTime datumNarodenia
    )
    {
        this.id = id;
        this.typOsobyId = typOsobyId;
        this.konto = konto;
        this.kontoAktivne = kontoAktivne;
        this.heslo = heslo;
        this.poslednePrihlasenie = null;
        this.poslednaIp = null;
        this.meno = meno;
        this.tituly = null;
        this.priezvisko = priezvisko;
        this.rodnePriezvisko = null;
        this.statnaPrislusnost = null;
        this.materinskyJazyk = null;
        this.telefon = null;
        this.mobil = null;
        this.fax = null;
        this.msn = null;
        this.email = email;
        this.web = null;
        this.pohlavie = null;
        this.datumNarodenia = datumNarodenia;
        this.rokAbsolvovania = null;
        this.zivotopisIne = null;
        this.icq = null;
        this.skype = null;
        this.socialneZrucnosti = null;
        this.organizacneZrucnosti = null;
        this.technickeZrucnosti = null;
        this.pocitacoveZrucnosti = null;
        this.umeleckeZrucnosti = null;
        this.dalsieZrucnosti = null;
        this.vodicskyPreukaz = null;
    }

    public Osoba( int id, int typOsobyId, string konto, bool kontoAktivne, string heslo, 
        DateTime? poslednePrihlasenie, string poslednaIp, string meno, string tituly, 
        string priezvisko, string rodnePriezvisko, string statnaPrislusnost, string materinskyJazyk, 
        string telefon, string mobil, string fax, string msn, string email, string web, 
        string pohlavie, DateTime datumNarodenia, int? rokAbsolvovania, string zivotopisIne, 
        string icq, string skype, string socialneZrucnosti, string organizacneZrucnosti, 
        string technickeZrucnosti, string pocitacoveZrucnosti, string umeleckeZrucnosti, 
        string dalsieZrucnosti, string vodicskyPreukaz
    )
    {
        this.id = id;
        this.typOsobyId = typOsobyId;
        this.konto = konto;
        this.kontoAktivne = kontoAktivne;
        this.heslo = heslo;
        this.poslednePrihlasenie = poslednePrihlasenie;
        this.poslednaIp = poslednaIp;
        this.meno = meno;
        this.tituly = tituly;
        this.priezvisko = priezvisko;
        this.rodnePriezvisko = rodnePriezvisko;
        this.statnaPrislusnost = statnaPrislusnost;
        this.materinskyJazyk = materinskyJazyk;
        this.telefon = telefon;
        this.mobil = mobil;
        this.fax = fax;
        this.msn = msn;
        this.email = email;
        this.web = web;
        this.pohlavie = pohlavie;
        this.datumNarodenia = datumNarodenia;
        this.rokAbsolvovania = rokAbsolvovania;
        this.zivotopisIne = zivotopisIne;
        this.icq = icq;
        this.skype = skype;
        this.socialneZrucnosti = socialneZrucnosti;
        this.organizacneZrucnosti = organizacneZrucnosti;
        this.technickeZrucnosti = technickeZrucnosti;
        this.pocitacoveZrucnosti = pocitacoveZrucnosti;
        this.umeleckeZrucnosti = umeleckeZrucnosti;
        this.dalsieZrucnosti = dalsieZrucnosti;
        this.vodicskyPreukaz = vodicskyPreukaz;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public int TypOsobyId
    {
        get { return typOsobyId; }
        set { typOsobyId = value; }
    }
    public string Konto
    {
        get { return konto; }
        set { konto = value; }
    }
    public bool KontoAktivne
    {
        get { return kontoAktivne; }
        set { kontoAktivne = value; }
    }
    public string Heslo
    {
        get { return heslo; }
        set { heslo = value; }
    }
    public DateTime? PoslednePrihlasenie
    {
        get { return poslednePrihlasenie; }
        set { poslednePrihlasenie = value; }
    }
    public string PoslednaIp
    {
        get { return poslednaIp; }
        set { poslednaIp = value; }
    }
    public string Meno
    {
        get { return meno; }
        set { meno = value; }
    }
    public string Tituly
    {
        get { return tituly; }
        set { tituly = value; }
    }
    public string Priezvisko
    {
        get { return priezvisko; }
        set { priezvisko = value; }
    }
    public string RodnePriezvisko
    {
        get { return rodnePriezvisko; }
        set { rodnePriezvisko = value; }
    }
    public string StatnaPrislusnost
    {
        get { return statnaPrislusnost; }
        set { statnaPrislusnost = value; }
    }
    public string MaterinskyJazyk
    {
        get { return materinskyJazyk; }
        set { materinskyJazyk = value; }
    }
    public string Telefon
    {
        get { return telefon; }
        set { telefon = value; }
    }
    public string Mobil
    {
        get { return mobil; }
        set { mobil = value; }
    }
    public string Fax
    {
        get { return fax; }
        set { fax = value; }
    }
    public string Msn
    {
        get { return msn; }
        set { msn = value; }
    }
    public string Email
    {
        get { return email; }
        set { email = value; }
    }
    public string Web
    {
        get { return web; }
        set { web = value; }
    }
    public string Pohlavie
    {
        get { return pohlavie; }
        set { pohlavie = value; }
    }
    public DateTime DatumNarodenia
    {
        get { return datumNarodenia; }
        set { datumNarodenia = value; }
    }
    public int? RokAbsolvovania
    {
        get { return rokAbsolvovania; }
        set { rokAbsolvovania = value; }
    }
    public string ZivotopisIne
    {
        get { return zivotopisIne; }
        set { zivotopisIne = value; }
    }
    public string Icq
    {
        get { return icq; }
        set { icq = value; }
    }
    public string Skype
    {
        get { return skype; }
        set { skype = value; }
    }
    public string SocialneZrucnosti
    {
        get { return socialneZrucnosti; }
        set { socialneZrucnosti = value; }
    }
    public string OrganizacneZrucnosti
    {
        get { return organizacneZrucnosti; }
        set { organizacneZrucnosti = value; }
    }
    public string TechnickeZrucnosti
    {
        get { return technickeZrucnosti; }
        set { technickeZrucnosti = value; }
    }
    public string PocitacoveZrucnosti
    {
        get { return pocitacoveZrucnosti; }
        set { pocitacoveZrucnosti = value; }
    }
    public string UmeleckeZrucnosti
    {
        get { return umeleckeZrucnosti; }
        set { umeleckeZrucnosti = value; }
    }
    public string DalsieZrucnosti
    {
        get { return dalsieZrucnosti; }
        set { dalsieZrucnosti = value; }
    }
    public string VodicskyPreukaz
    {
        get { return vodicskyPreukaz; }
        set { vodicskyPreukaz = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        typOsobyId = reader.GetInt32(1);

        konto = reader.GetString(2);

        kontoAktivne = reader.GetBoolean(3);

        heslo = reader.GetString(4);

        if ( reader.IsDBNull(5) ) poslednePrihlasenie = null;
        else poslednePrihlasenie = reader.GetDateTime(5);

        if ( reader.IsDBNull(6) ) poslednaIp = null;
        else poslednaIp = reader.GetString(6);

        meno = reader.GetString(7);

        if ( reader.IsDBNull(8) ) tituly = null;
        else tituly = reader.GetString(8);

        priezvisko = reader.GetString(9);

        if ( reader.IsDBNull(10) ) rodnePriezvisko = null;
        else rodnePriezvisko = reader.GetString(10);

        if ( reader.IsDBNull(11) ) statnaPrislusnost = null;
        else statnaPrislusnost = reader.GetString(11);

        if ( reader.IsDBNull(12) ) materinskyJazyk = null;
        else materinskyJazyk = reader.GetString(12);

        if ( reader.IsDBNull(13) ) telefon = null;
        else telefon = reader.GetString(13);

        if ( reader.IsDBNull(14) ) mobil = null;
        else mobil = reader.GetString(14);

        if ( reader.IsDBNull(15) ) fax = null;
        else fax = reader.GetString(15);

        if ( reader.IsDBNull(16) ) msn = null;
        else msn = reader.GetString(16);

        email = reader.GetString(17);

        if ( reader.IsDBNull(18) ) web = null;
        else web = reader.GetString(18);

        if ( reader.IsDBNull(19) ) pohlavie = null;
        else pohlavie = reader.GetString(19);

        datumNarodenia = reader.GetDateTime(20);

        if ( reader.IsDBNull(21) ) rokAbsolvovania = null;
        else rokAbsolvovania = reader.GetInt32(21);

        if ( reader.IsDBNull(22) ) zivotopisIne = null;
        else zivotopisIne = reader.GetString(22);

        if ( reader.IsDBNull(23) ) icq = null;
        else icq = reader.GetString(23);

        if ( reader.IsDBNull(24) ) skype = null;
        else skype = reader.GetString(24);

        if ( reader.IsDBNull(25) ) socialneZrucnosti = null;
        else socialneZrucnosti = reader.GetString(25);

        if ( reader.IsDBNull(26) ) organizacneZrucnosti = null;
        else organizacneZrucnosti = reader.GetString(26);

        if ( reader.IsDBNull(27) ) technickeZrucnosti = null;
        else technickeZrucnosti = reader.GetString(27);

        if ( reader.IsDBNull(28) ) pocitacoveZrucnosti = null;
        else pocitacoveZrucnosti = reader.GetString(28);

        if ( reader.IsDBNull(29) ) umeleckeZrucnosti = null;
        else umeleckeZrucnosti = reader.GetString(29);

        if ( reader.IsDBNull(30) ) dalsieZrucnosti = null;
        else dalsieZrucnosti = reader.GetString(30);

        if ( reader.IsDBNull(31) ) vodicskyPreukaz = null;
        else vodicskyPreukaz = reader.GetString(31);
    }
}
