using System;
using System.Data;
using System.Configuration;

public partial class Prispevok
{
    private int id;
    private string text;
    private DateTime cas;
    private int temaId;
    private int osobaId;
    private string predmet;

    public Prispevok() {}

    public Prispevok( int id, string text, DateTime cas, int temaId, int osobaId )
    {
        this.id = id;
        this.text = text;
        this.cas = cas;
        this.temaId = temaId;
        this.osobaId = osobaId;
        this.predmet = null;
    }

    public Prispevok( int id, string text, DateTime cas, int temaId, int osobaId, 
        string predmet
    )
    {
        this.id = id;
        this.text = text;
        this.cas = cas;
        this.temaId = temaId;
        this.osobaId = osobaId;
        this.predmet = predmet;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public string Text
    {
        get { return text; }
        set { text = value; }
    }
    public DateTime Cas
    {
        get { return cas; }
        set { cas = value; }
    }
    public int TemaId
    {
        get { return temaId; }
        set { temaId = value; }
    }
    public int OsobaId
    {
        get { return osobaId; }
        set { osobaId = value; }
    }
    public string Predmet
    {
        get { return predmet; }
        set { predmet = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        text = reader.GetString(1);

        cas = reader.GetDateTime(2);

        temaId = reader.GetInt32(3);

        osobaId = reader.GetInt32(4);

        if ( reader.IsDBNull(5) ) predmet = null;
        else predmet = reader.GetString(5);
    }
}
