using System;
using System.Data;
using System.Configuration;

public partial class Projekt
{
    private int id;
    private int osobaId;
    private int? jobId;
    private int? studiumId;
    private string nazov;
    private string abstrakt;
    private string veduci;
    private string klucoveSlova;
    private DateTime datumVypracovania;
    private string wwwOdkaz;
    private string poznamka;

    public Projekt() {}

    public Projekt( int id, int osobaId, string nazov, string klucoveSlova, DateTime datumVypracovania )
    {
        this.id = id;
        this.osobaId = osobaId;
        this.jobId = null;
        this.studiumId = null;
        this.nazov = nazov;
        this.abstrakt = null;
        this.veduci = null;
        this.klucoveSlova = klucoveSlova;
        this.datumVypracovania = datumVypracovania;
        this.wwwOdkaz = null;
        this.poznamka = null;
    }

    public Projekt( int id, int osobaId, int? jobId, int? studiumId, string nazov, 
        string abstrakt, string veduci, string klucoveSlova, DateTime datumVypracovania, 
        string wwwOdkaz, string poznamka
    )
    {
        this.id = id;
        this.osobaId = osobaId;
        this.jobId = jobId;
        this.studiumId = studiumId;
        this.nazov = nazov;
        this.abstrakt = abstrakt;
        this.veduci = veduci;
        this.klucoveSlova = klucoveSlova;
        this.datumVypracovania = datumVypracovania;
        this.wwwOdkaz = wwwOdkaz;
        this.poznamka = poznamka;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public int OsobaId
    {
        get { return osobaId; }
        set { osobaId = value; }
    }
    public int? JobId
    {
        get { return jobId; }
        set { jobId = value; }
    }
    public int? StudiumId
    {
        get { return studiumId; }
        set { studiumId = value; }
    }
    public string Nazov
    {
        get { return nazov; }
        set { nazov = value; }
    }
    public string Abstrakt
    {
        get { return abstrakt; }
        set { abstrakt = value; }
    }
    public string Veduci
    {
        get { return veduci; }
        set { veduci = value; }
    }
    public string KlucoveSlova
    {
        get { return klucoveSlova; }
        set { klucoveSlova = value; }
    }
    public DateTime DatumVypracovania
    {
        get { return datumVypracovania; }
        set { datumVypracovania = value; }
    }
    public string WwwOdkaz
    {
        get { return wwwOdkaz; }
        set { wwwOdkaz = value; }
    }
    public string Poznamka
    {
        get { return poznamka; }
        set { poznamka = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        osobaId = reader.GetInt32(1);

        if ( reader.IsDBNull(2) ) jobId = null;
        else jobId = reader.GetInt32(2);

        if ( reader.IsDBNull(3) ) studiumId = null;
        else studiumId = reader.GetInt32(3);

        nazov = reader.GetString(4);

        if ( reader.IsDBNull(5) ) abstrakt = null;
        else abstrakt = reader.GetString(5);

        if ( reader.IsDBNull(6) ) veduci = null;
        else veduci = reader.GetString(6);

        klucoveSlova = reader.GetString(7);

        datumVypracovania = reader.GetDateTime(8);

        if ( reader.IsDBNull(9) ) wwwOdkaz = null;
        else wwwOdkaz = reader.GetString(9);

        if ( reader.IsDBNull(10) ) poznamka = null;
        else poznamka = reader.GetString(10);
    }
}
