using System;
using System.Data;
using System.Configuration;

public partial class Registracia
{
    private int id;
    private string email;
    private string heslo;
    private string meno;
    private string priezvisko;
    private DateTime datumNarodenia;
    private int? rokAbsolvovania;
    private int typRegistracieId;

    public Registracia() {}

    public Registracia( int id, string email, string heslo, string meno, string priezvisko, 
        DateTime datumNarodenia, int typRegistracieId
    )
    {
        this.id = id;
        this.email = email;
        this.heslo = heslo;
        this.meno = meno;
        this.priezvisko = priezvisko;
        this.datumNarodenia = datumNarodenia;
        this.rokAbsolvovania = null;
        this.typRegistracieId = typRegistracieId;
    }

    public Registracia( int id, string email, string heslo, string meno, string priezvisko, 
        DateTime datumNarodenia, int? rokAbsolvovania, int typRegistracieId
    )
    {
        this.id = id;
        this.email = email;
        this.heslo = heslo;
        this.meno = meno;
        this.priezvisko = priezvisko;
        this.datumNarodenia = datumNarodenia;
        this.rokAbsolvovania = rokAbsolvovania;
        this.typRegistracieId = typRegistracieId;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public string Email
    {
        get { return email; }
        set { email = value; }
    }
    public string Heslo
    {
        get { return heslo; }
        set { heslo = value; }
    }
    public string Meno
    {
        get { return meno; }
        set { meno = value; }
    }
    public string Priezvisko
    {
        get { return priezvisko; }
        set { priezvisko = value; }
    }
    public DateTime DatumNarodenia
    {
        get { return datumNarodenia; }
        set { datumNarodenia = value; }
    }
    public int? RokAbsolvovania
    {
        get { return rokAbsolvovania; }
        set { rokAbsolvovania = value; }
    }
    public int TypRegistracieId
    {
        get { return typRegistracieId; }
        set { typRegistracieId = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        email = reader.GetString(1);

        heslo = reader.GetString(2);

        meno = reader.GetString(3);

        priezvisko = reader.GetString(4);

        datumNarodenia = reader.GetDateTime(5);

        if ( reader.IsDBNull(6) ) rokAbsolvovania = null;
        else rokAbsolvovania = reader.GetInt32(6);

        typRegistracieId = reader.GetInt32(7);
    }
}
