using System;
using System.Data;
using System.Configuration;

public partial class Sprava
{
    private int id;
    private int odosielatelId;
    private int prijemcaId;
    private DateTime cas;
    private string predmet;
    private string text;
    private bool precitana;
    private bool odosielatelKos;
    private bool prijemcaKos;
    private bool odosielatelZmazana;
    private bool prijemcaZmazana;
    private bool notifikovat;
    private int typSpravyId;

    public Sprava() {}

    public Sprava( int id, int odosielatelId, int prijemcaId, DateTime cas, bool precitana, 
        bool odosielatelKos, bool prijemcaKos, bool odosielatelZmazana, bool prijemcaZmazana, 
        bool notifikovat, int typSpravyId
    )
    {
        this.id = id;
        this.odosielatelId = odosielatelId;
        this.prijemcaId = prijemcaId;
        this.cas = cas;
        this.predmet = null;
        this.text = null;
        this.precitana = precitana;
        this.odosielatelKos = odosielatelKos;
        this.prijemcaKos = prijemcaKos;
        this.odosielatelZmazana = odosielatelZmazana;
        this.prijemcaZmazana = prijemcaZmazana;
        this.notifikovat = notifikovat;
        this.typSpravyId = typSpravyId;
    }

    public Sprava( int id, int odosielatelId, int prijemcaId, DateTime cas, string predmet, 
        string text, bool precitana, bool odosielatelKos, bool prijemcaKos, bool odosielatelZmazana, 
        bool prijemcaZmazana, bool notifikovat, int typSpravyId
    )
    {
        this.id = id;
        this.odosielatelId = odosielatelId;
        this.prijemcaId = prijemcaId;
        this.cas = cas;
        this.predmet = predmet;
        this.text = text;
        this.precitana = precitana;
        this.odosielatelKos = odosielatelKos;
        this.prijemcaKos = prijemcaKos;
        this.odosielatelZmazana = odosielatelZmazana;
        this.prijemcaZmazana = prijemcaZmazana;
        this.notifikovat = notifikovat;
        this.typSpravyId = typSpravyId;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public int OdosielatelId
    {
        get { return odosielatelId; }
        set { odosielatelId = value; }
    }
    public int PrijemcaId
    {
        get { return prijemcaId; }
        set { prijemcaId = value; }
    }
    public DateTime Cas
    {
        get { return cas; }
        set { cas = value; }
    }
    public string Predmet
    {
        get { return predmet; }
        set { predmet = value; }
    }
    public string Text
    {
        get { return text; }
        set { text = value; }
    }
    public bool Precitana
    {
        get { return precitana; }
        set { precitana = value; }
    }
    public bool OdosielatelKos
    {
        get { return odosielatelKos; }
        set { odosielatelKos = value; }
    }
    public bool PrijemcaKos
    {
        get { return prijemcaKos; }
        set { prijemcaKos = value; }
    }
    public bool OdosielatelZmazana
    {
        get { return odosielatelZmazana; }
        set { odosielatelZmazana = value; }
    }
    public bool PrijemcaZmazana
    {
        get { return prijemcaZmazana; }
        set { prijemcaZmazana = value; }
    }
    public bool Notifikovat
    {
        get { return notifikovat; }
        set { notifikovat = value; }
    }
    public int TypSpravyId
    {
        get { return typSpravyId; }
        set { typSpravyId = value; }
    }

    #endregion

    public void ValuesFromReader(int id, IDataReader reader)
    {
        this.id = id;

        odosielatelId = reader.GetInt32(1);

        prijemcaId = reader.GetInt32(2);

        cas = reader.GetDateTime(3);

        if (reader.IsDBNull(4)) predmet = null;
        else predmet = reader.GetString(4);

        if (reader.IsDBNull(5)) text = null;
        else text = reader.GetString(5);

        precitana = reader.GetBoolean(6);

        odosielatelKos = reader.GetBoolean(7);

        prijemcaKos = reader.GetBoolean(8);

        odosielatelZmazana = reader.GetBoolean(9);

        prijemcaZmazana = reader.GetBoolean(10);

        notifikovat = reader.GetBoolean(11);

        typSpravyId = reader.GetInt32(12);
    }
}
