using System;
using System.Data;
using System.Configuration;

public partial class Studium
{
    private int id;
    private int osobaId;
    private int skolaId;
    private int? smerId;
    private decimal stupen;
    private decimal? osobneCislo;
    private DateTime datumOd;
    private DateTime? datumDo;
    private decimal? prospech;
    private string fakulta;
    private string odbor;
    private decimal? typSkoly;
    private string ziskanyTitul;

    public Studium() {}

    public Studium( int id, int osobaId, int skolaId, decimal stupen, DateTime datumOd )
    {
        this.id = id;
        this.osobaId = osobaId;
        this.skolaId = skolaId;
        this.smerId = null;
        this.stupen = stupen;
        this.osobneCislo = null;
        this.datumOd = datumOd;
        this.datumDo = null;
        this.prospech = null;
        this.fakulta = null;
        this.odbor = null;
        this.typSkoly = null;
        this.ziskanyTitul = null;
    }

    public Studium( int id, int osobaId, int skolaId, int? smerId, decimal stupen, 
        decimal? osobneCislo, DateTime datumOd, DateTime? datumDo, decimal? prospech, 
        string fakulta, string odbor, decimal? typSkoly, string ziskanyTitul
    )
    {
        this.id = id;
        this.osobaId = osobaId;
        this.skolaId = skolaId;
        this.smerId = smerId;
        this.stupen = stupen;
        this.osobneCislo = osobneCislo;
        this.datumOd = datumOd;
        this.datumDo = datumDo;
        this.prospech = prospech;
        this.fakulta = fakulta;
        this.odbor = odbor;
        this.typSkoly = typSkoly;
        this.ziskanyTitul = ziskanyTitul;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public int OsobaId
    {
        get { return osobaId; }
        set { osobaId = value; }
    }
    public int SkolaId
    {
        get { return skolaId; }
        set { skolaId = value; }
    }
    public int? SmerId
    {
        get { return smerId; }
        set { smerId = value; }
    }
    public decimal Stupen
    {
        get { return stupen; }
        set { stupen = value; }
    }
    public decimal? OsobneCislo
    {
        get { return osobneCislo; }
        set { osobneCislo = value; }
    }
    public DateTime DatumOd
    {
        get { return datumOd; }
        set { datumOd = value; }
    }
    public DateTime? DatumDo
    {
        get { return datumDo; }
        set { datumDo = value; }
    }
    public decimal? Prospech
    {
        get { return prospech; }
        set { prospech = value; }
    }
    public string Fakulta
    {
        get { return fakulta; }
        set { fakulta = value; }
    }
    public string Odbor
    {
        get { return odbor; }
        set { odbor = value; }
    }
    public decimal? TypSkoly
    {
        get { return typSkoly; }
        set { typSkoly = value; }
    }
    public string ZiskanyTitul
    {
        get { return ziskanyTitul; }
        set { ziskanyTitul = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        osobaId = reader.GetInt32(1);

        skolaId = reader.GetInt32(2);

        if ( reader.IsDBNull(3) ) smerId = null;
        else smerId = reader.GetInt32(3);

        stupen = reader.GetDecimal(4);

        if ( reader.IsDBNull(5) ) osobneCislo = null;
        else osobneCislo = reader.GetDecimal(5);

        datumOd = reader.GetDateTime(6);

        if ( reader.IsDBNull(7) ) datumDo = null;
        else datumDo = reader.GetDateTime(7);

        if ( reader.IsDBNull(8) ) prospech = null;
        else prospech = reader.GetDecimal(8);

        if ( reader.IsDBNull(9) ) fakulta = null;
        else fakulta = reader.GetString(9);

        if ( reader.IsDBNull(10) ) odbor = null;
        else odbor = reader.GetString(10);

        if ( reader.IsDBNull(11) ) typSkoly = null;
        else typSkoly = reader.GetDecimal(11);

        if ( reader.IsDBNull(12) ) ziskanyTitul = null;
        else ziskanyTitul = reader.GetString(12);
    }
}
