using System;
using System.Data;
using System.Configuration;

public partial class Tema
{
    private int id;
    private string nazov;
    private string popis;
    private DateTime cas;
    private bool jeVerejna;
    private int osobaId;
    private int? nadtema;

    public Tema() {}

    public Tema( int id, string nazov, DateTime cas, bool jeVerejna, int osobaId )
    {
        this.id = id;
        this.nazov = nazov;
        this.popis = null;
        this.cas = cas;
        this.jeVerejna = jeVerejna;
        this.osobaId = osobaId;
        this.nadtema = null;
    }

    public Tema( int id, string nazov, string popis, DateTime cas, bool jeVerejna, 
        int osobaId, int? nadtema
    )
    {
        this.id = id;
        this.nazov = nazov;
        this.popis = popis;
        this.cas = cas;
        this.jeVerejna = jeVerejna;
        this.osobaId = osobaId;
        this.nadtema = nadtema;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public string Nazov
    {
        get { return nazov; }
        set { nazov = value; }
    }
    public string Popis
    {
        get { return popis; }
        set { popis = value; }
    }
    public DateTime Cas
    {
        get { return cas; }
        set { cas = value; }
    }
    public bool JeVerejna
    {
        get { return jeVerejna; }
        set { jeVerejna = value; }
    }
    public int OsobaId
    {
        get { return osobaId; }
        set { osobaId = value; }
    }
    public int? Nadtema
    {
        get { return nadtema; }
        set { nadtema = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        nazov = reader.GetString(1);

        if ( reader.IsDBNull(2) ) popis = null;
        else popis = reader.GetString(2);

        cas = reader.GetDateTime(3);

        jeVerejna = reader.GetBoolean(4);

        osobaId = reader.GetInt32(5);

        if ( reader.IsDBNull(6) ) nadtema = null;
        else nadtema = reader.GetInt32(6);
    }
}
