using System;
using System.Data;
using System.Configuration;

public partial class Zamestnanie
{
    private int id;
    private int osobaId;
    private int? poziciaOdvetvieId;
    private DateTime datumOd;
    private DateTime? datumDo;
    private string nazovFirmy;
    private string poznamka;

    public Zamestnanie() {}

    public Zamestnanie( int id, int osobaId, DateTime datumOd, string nazovFirmy )
    {
        this.id = id;
        this.osobaId = osobaId;
        this.poziciaOdvetvieId = null;
        this.datumOd = datumOd;
        this.datumDo = null;
        this.nazovFirmy = nazovFirmy;
        this.poznamka = null;
    }

    public Zamestnanie( int id, int osobaId, int? poziciaOdvetvieId, DateTime datumOd, 
        DateTime? datumDo, string nazovFirmy, string poznamka
    )
    {
        this.id = id;
        this.osobaId = osobaId;
        this.poziciaOdvetvieId = poziciaOdvetvieId;
        this.datumOd = datumOd;
        this.datumDo = datumDo;
        this.nazovFirmy = nazovFirmy;
        this.poznamka = poznamka;
    }

    #region Properties

    public int Id
    {
        get { return id; }
        set { id = value; }
    }
    public int OsobaId
    {
        get { return osobaId; }
        set { osobaId = value; }
    }
    public int? PoziciaOdvetvieId
    {
        get { return poziciaOdvetvieId; }
        set { poziciaOdvetvieId = value; }
    }
    public DateTime DatumOd
    {
        get { return datumOd; }
        set { datumOd = value; }
    }
    public DateTime? DatumDo
    {
        get { return datumDo; }
        set { datumDo = value; }
    }
    public string NazovFirmy
    {
        get { return nazovFirmy; }
        set { nazovFirmy = value; }
    }
    public string Poznamka
    {
        get { return poznamka; }
        set { poznamka = value; }
    }

    #endregion

    public void ValuesFromReader( int id, IDataReader reader )
    {
        this.id = id;

        osobaId = reader.GetInt32(1);

        if ( reader.IsDBNull(2) ) poziciaOdvetvieId = null;
        else poziciaOdvetvieId = reader.GetInt32(2);

        datumOd = reader.GetDateTime(3);

        if ( reader.IsDBNull(4) ) datumDo = null;
        else datumDo = reader.GetDateTime(4);

        nazovFirmy = reader.GetString(5);

        if ( reader.IsDBNull(6) ) poznamka = null;
        else poznamka = reader.GetString(6);
    }
}
