using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class BlacklistSpravaDAL
{
    private static int maxPocetObmedzeni = 500;
    public static List<BlacklistSprava> SelectByPrijemcaId(int prijemca_id, int limit, int offset, string SortExpression)
    {
        List<BlacklistSprava> blacklistSpravaList = new List<BlacklistSprava>();
        BlacklistSprava blacklistSprava;

        if (SortExpression == null || SortExpression.Length == 0) SortExpression = "odosielatel_konto ASC";

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.blacklist_sprava.*,alumni.osoba.id,alumni.osoba.meno,alumni.osoba.priezvisko "+
                "FROM alumni.blacklist_sprava LEFT OUTER JOIN alumni.osoba "+
                "ON (blacklist_sprava.odosielatel_konto=osoba.konto)"+
                "WHERE prijemca_id = ? ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);

             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

             odbcCommand.Parameters.Add("@limit", OdbcType.Int).Value = limit;

             odbcCommand.Parameters.Add("@offset", OdbcType.Int).Value = offset;

             odbcConnection.Open();

             using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
             {
                 while (odbcDataReader.Read())
                 {
                     blacklistSprava = new BlacklistSprava();

                     blacklistSprava.ValuesFromReader2(odbcDataReader.GetInt32(0), odbcDataReader);

                     blacklistSpravaList.Add(blacklistSprava);
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
         }

         return blacklistSpravaList;
    }

    public static int CountSelectByPrijemcaId(int prijemca_id, int limit, int offset, string SortExpression)
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.blacklist_sprava.id " +
                "FROM alumni.blacklist_sprava " +
                "WHERE prijemca_id=? LIMIT "+maxPocetObmedzeni, odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }

    public static void DeleteByIdsAndPrijemca(int[] ids, int prijemca_id)
    {

        String whereBlst = "(";
        for (int i = 0; i < ids.Length; i++)
        {
            if (i == (ids.Length - 1))
            {
                whereBlst += "blacklist_sprava.id=?)";
            }
            else
            {
                whereBlst += "blacklist_sprava.id=? OR ";
            }
        }

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.blacklist_sprava WHERE "+whereBlst+" AND prijemca_id=?", odbcConnection);

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@blacklist_sprava.id", OdbcType.Int).Value = ids[i];
            }
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void DeleteAllByPrijemca(int prijemca_id)
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.blacklist_sprava WHERE prijemca_id=?", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static int Insert2(BlacklistSprava blst)   //nova polozka do blacklistu
    {

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.blacklist_sprava( " +
            //   "odosielatel_id, prijemca_id, is_skupina) " +
            //   "SELECT osoba.id, ?, ? FROM alumni.osoba "+
            //   "WHERE alumni.osoba.konto = ? AND osoba.id != ? AND alumni.osoba.konto_aktivne = true "+
            //   "AND NOT EXISTS (SELECT id FROM alumni.blacklist_sprava " +
            //   "WHERE blacklist_sprava.odosielatel_id=osoba.id AND blacklist_sprava.prijemca_id=? AND blacklist_sprava.is_skupina=?)", odbcConnection
            //);

            OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.blacklist_sprava( " +
               "odosielatel_konto, prijemca_id, is_skupina) " +
               "SELECT osoba.konto, ?, ? FROM alumni.osoba " +
               "WHERE alumni.osoba.konto = ? AND osoba.id != ? AND alumni.osoba.konto_aktivne = true", odbcConnection
            );

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blst.PrijemcaId;
            odbcCommand.Parameters.Add("@is_skupina", OdbcType.Char).Value = blst.IsSkupina;
            odbcCommand.Parameters.Add("@konto", OdbcType.NVarChar).Value = blst.OdosielatelKonto;
            //    odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blst.PrijemcaId;
            //odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blst.PrijemcaId;
            //odbcCommand.Parameters.Add("@is_skupina", OdbcType.Char).Value = blst.IsSkupina;
            //     odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;

            odbcConnection.Open();
            
            int rows;

            try
            {
                rows = odbcCommand.ExecuteNonQuery();
            }catch(OdbcException oe) {
                rows = oe.ErrorCode;
         //       Console.WriteLine("aaaaaaaaaaaa\n"+oe.Message+"\naaaaaaaaaaaaaaaaa");
                
            }
            

            odbcConnection.Close();

            return rows;
        }
    }

    public static int Insert2TypOsoby(BlacklistSprava blst)   //nova sprava
    {

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id) " +
            //   "SELECT ?, osoba.id, ?, ?, ?, ? FROM alumni.osoba,alumni.typ_osoby WHERE alumni.osoba.typ_osoby_id=alumni.typ_osoby.id AND alumni.typ_osoby.typ = ? AND osoba.id != ? AND alumni.osoba.konto_aktivne = true", odbcConnection
            //);

            OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.blacklist_sprava( " +
               "odosielatel_konto, prijemca_id, is_skupina) " +
               "SELECT ?, ?, ? FROM alumni.typ_osoby " +
               "WHERE alumni.typ_osoby.typ = ?", odbcConnection
            );
            //aj sebe moze
            odbcCommand.Parameters.Add("@konto", OdbcType.NVarChar).Value = blst.OdosielatelKonto;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blst.PrijemcaId;
            odbcCommand.Parameters.Add("@is_skupina", OdbcType.Char).Value = blst.IsSkupina;
            odbcCommand.Parameters.Add("@typ_osoby", OdbcType.NVarChar).Value = blst.OdosielatelKonto.Substring(4);

            odbcConnection.Open();

            int rows;

            try
            {
                rows = odbcCommand.ExecuteNonQuery();
            }
            catch (OdbcException oe)
            {
                rows = oe.ErrorCode;
                //       Console.WriteLine("aaaaaaaaaaaa\n"+oe.Message+"\naaaaaaaaaaaaaaaaa");

            }


            odbcConnection.Close();

            return rows;
        }
    }

    public static int Insert2RokAbsolvovania(BlacklistSprava blst)   //nova sprava
    {

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id) " +
            //   "SELECT ?, osoba.id, ?, ?, ?, ? FROM alumni.osoba,alumni.typ_osoby WHERE alumni.osoba.typ_osoby_id=alumni.typ_osoby.id AND alumni.typ_osoby.typ = ? AND osoba.id != ? AND alumni.osoba.konto_aktivne = true", odbcConnection
            //);

            OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.blacklist_sprava( " +
               "odosielatel_konto, prijemca_id, is_skupina) " +
               "VALUES(?,?,?)", odbcConnection
            );
            //aj sebe moze
            odbcCommand.Parameters.Add("@konto", OdbcType.NVarChar).Value = blst.OdosielatelKonto;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blst.PrijemcaId;
            odbcCommand.Parameters.Add("@is_skupina", OdbcType.Char).Value = blst.IsSkupina;
         //   odbcCommand.Parameters.Add("@typ_osoby", OdbcType.NVarChar).Value = blst.OdosielatelKonto.Substring(4);

            odbcConnection.Open();

            int rows;

            try
            {
                rows = odbcCommand.ExecuteNonQuery();
            }
            catch (OdbcException oe)
            {
                rows = oe.ErrorCode;
                //       Console.WriteLine("aaaaaaaaaaaa\n"+oe.Message+"\naaaaaaaaaaaaaaaaa");

            }


            odbcConnection.Close();

            return rows;
        }
    }

    
}
