using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

/// <summary>
/// Summary description for InstanciaAnketyDAL
/// </summary>
public partial class InstanciaAnketyDAL
{
    public static int SelectAccessesCount(int instanciaAnketyId)
    {
        int accessesCount = -1;

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("select DISTINCT ON (osoba_id) osoba_id from alumni.odpoved where instancia_ankety_id=?", odbcConnection);

            odbcCommand.Parameters.Add("@instancia_ankety_id", OdbcType.Int).Value = instanciaAnketyId;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                if (!odbcDataReader.Read())
                {
                    odbcDataReader.Close();
                    odbcConnection.Close();

                    return -1;
                }

                accessesCount = odbcDataReader.RecordsAffected;

                odbcDataReader.Close();
            }

            odbcConnection.Close();
        }

        return accessesCount;
    }
}
