using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class JazykDAL
{
    public static List<Jazyk> SelectByOsobaId( int osobaId )
    {
        List<Jazyk> jazykList = new List<Jazyk>();
        Jazyk jazyk;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.jazyk WHERE osoba_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     jazyk = new Jazyk();

                     jazyk.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     jazykList.Add( jazyk );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return jazykList;
    }

    public static int SelectCountByOsobaId( int osobaId )
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT COUNT(*) FROM alumni.jazyk WHERE osoba_id = ?", odbcConnection);

            odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

            odbcConnection.Open();

            rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

            odbcConnection.Close();
        }

        return rowCount;
    }
}
