using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class KurzDAL
{
    public static List<Kurz> SelectByOsobaId( int osobaId )
    {
        List<Kurz> kurzList = new List<Kurz>();
        Kurz kurz;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.kurz WHERE osoba_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     kurz = new Kurz();

                     kurz.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     kurzList.Add( kurz );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return kurzList;
    }

    public static int SelectCountByOsobaId( int osobaId )
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT COUNT(*) FROM alumni.kurz WHERE osoba_id = ?", odbcConnection);

            odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

            odbcConnection.Open();

            rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

            odbcConnection.Close();
        }

        return rowCount;
    }
}
