using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class MozneOdpovedeDAL
{
    public static List<MozneOdpovede> SelectByOtazkaId( int otazkaId )
    {
        List<MozneOdpovede> mozneOdpovedeList = new List<MozneOdpovede>();
        MozneOdpovede mozneOdpovede;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.mozne_odpovede WHERE otazka_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@otazka_id", OdbcType.Int).Value = otazkaId;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     mozneOdpovede = new MozneOdpovede();

                     mozneOdpovede.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     mozneOdpovedeList.Add( mozneOdpovede );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return mozneOdpovedeList;
    }
}
