using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class OtazkaDAL
{
    public static List<Otazka> SelectByAnketaId( int anketaId )
    {
        List<Otazka> otazkaList = new List<Otazka>();
        Otazka otazka;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.otazka WHERE anketa_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@anketa_id", OdbcType.Int).Value = anketaId;
             
             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     otazka = new Otazka();

                     otazka.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     otazkaList.Add( otazka );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return otazkaList;
    }

    public static int SelectCountByAnketaId( int anketaId )
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.otazka WHERE anketa_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@anketa_id", OdbcType.Int).Value = anketaId;

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }
}
