using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class PoziciaOdvetvieDAL
{
    public static List<PoziciaOdvetvie> SelectByOdvetiveId( int odvetvieId )
    {
        List<PoziciaOdvetvie> poziciaOdvetvieList = new List<PoziciaOdvetvie>();
        PoziciaOdvetvie poziciaOdvetvie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.pozicia_odvetvie WHERE odvetvie_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@odvetvie_id", OdbcType.Int).Value = odvetvieId;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     poziciaOdvetvie = new PoziciaOdvetvie();

                     poziciaOdvetvie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     poziciaOdvetvieList.Add( poziciaOdvetvie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return poziciaOdvetvieList;
    }
}
