using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;

public partial class ProjektDAL
{
    public static List<Projekt> SelectByOsobaId( int osobaId )
    {
        List<Projekt> projektList = new List<Projekt>();
        Projekt projekt;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.projekt WHERE osoba_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     projekt = (Projekt)HttpContext.Current.Cache["Projekt_" + id.ToString()];

                     if( projekt == null )
                     {
                         projekt = new Projekt();

                         projekt.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Projekt_" + id.ToString()] = projekt;
                     }

                     projektList.Add( projekt );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return projektList;
    }

    public static Projekt SelectByOsobaIdNazov( int osobaId, string nazov )
    {
        Projekt projekt;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.projekt WHERE osoba_id = ? AND nazov = ?", odbcConnection );

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;
             odbcCommand.Parameters.Add("@nazov", OdbcType.Text).Value = nazov;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 projekt = new Projekt();

                 projekt.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return projekt;
    }

    public static int SelectCountByOsobaId( int osobaId )
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.projekt WHERE osoba_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }
}
