using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class RegistraciaDAL
{
    public static Registracia SelectByEmail(string email)
    {
        Registracia registracia;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.registracia WHERE email = ?", odbcConnection );

             odbcCommand.Parameters.Add("@email", OdbcType.NVarChar).Value = email;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 registracia = new Registracia();

                 registracia.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return registracia;
    }
}
