using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.IO;

public partial class SpravaDAL
{
    private static int maxPocetSprav = 500;

    public static List<Sprava> SelectByPrijemca(int prijemca_id) //vypis prijatych sprav s menom odosielatela, s textom spravy - xxx
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.text,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader0(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);

                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByPrijemca2(int prijemca_id)    //vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {

                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader3(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);

                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByPrijemca3(int prijemca_id, int limit, int offset, string SortExpression, bool kos)    // test: vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        //StreamWriter sw = new StreamWriter("C:\\Test.txt");
        //sw.WriteLine(SortExpression);
        //sw.Close();

        if (SortExpression == null || SortExpression.Length == 0) SortExpression = "cas DESC";
        

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT * "+
                "FROM (SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ "+
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.prijemca_kos=? AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY cas DESC LIMIT "+maxPocetSprav+") AS foo ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

      //      odbcCommand.Parameters.Add("@cas", OdbcType.Text).Value = SortExpression;
            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@limit", OdbcType.Int).Value = limit;

            odbcCommand.Parameters.Add("@offset", OdbcType.Int).Value = offset;

            

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {

                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader3(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);

                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static int CountSelectByPrijemca3(int prijemca_id, int limit, int offset, string SortExpression, bool kos)    // test: vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        //Sprava sprava;
        //List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id FROM ONLY alumni.sprava WHERE prijemca_id = ? AND alumni.sprava.prijemca_kos=? AND alumni.sprava.prijemca_zmazana=FALSE LIMIT "+maxPocetSprav, odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            //      odbcCommand.Parameters.Add("@cas", OdbcType.Text).Value = SortExpression;

            

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }

    public static int CountSelectByPrijemca3Precitana(int prijemca_id, bool kos, bool precitana)    // test: vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        //Sprava sprava;
        //List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT * FROM (SELECT alumni.sprava.precitana FROM ONLY alumni.sprava WHERE prijemca_id = ? AND alumni.sprava.prijemca_kos=? AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY cas DESC LIMIT " + maxPocetSprav + ") AS foo WHERE foo.precitana = ?", odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id FROM ONLY alumni.sprava WHERE prijemca_id = ? AND alumni.sprava.precitana = ? AND alumni.sprava.prijemca_kos=? AND alumni.sprava.prijemca_zmazana=FALSE LIMIT " + maxPocetSprav, odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = precitana;

            //      odbcCommand.Parameters.Add("@cas", OdbcType.Text).Value = SortExpression;



            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }

    /*
    public static List<Sprava> SelectByPrijemcaKos(int prijemca_id, int limit, int offset, string SortExpression)    // test: vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        //StreamWriter sw = new StreamWriter("C:\\Test.txt");
        //sw.WriteLine(SortExpression);
        //sw.Close();

        if (SortExpression == null || SortExpression.Length == 0) SortExpression = "cas DESC";


        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT * FROM (SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY cas DESC LIMIT " + maxPocetSprav + ") AS foo ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            //      odbcCommand.Parameters.Add("@cas", OdbcType.Text).Value = SortExpression;

            odbcCommand.Parameters.Add("@limit", OdbcType.Int).Value = limit;

            odbcCommand.Parameters.Add("@offset", OdbcType.Int).Value = offset;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {

                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader3(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);

                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static int CountSelectByPrijemcaKos(int prijemca_id, int limit, int offset, string SortExpression)    // test: vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        //Sprava sprava;
        //List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id FROM ONLY alumni.sprava WHERE prijemca_id = ? AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT " + maxPocetSprav, odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            //      odbcCommand.Parameters.Add("@cas", OdbcType.Text).Value = SortExpression;



            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }


    }*/


   


    /*
    public static List<Sprava> SelectByKos(int vlastnik_id, int limit, int offset, string SortExpression)    // test: vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        //StreamWriter sw = new StreamWriter("C:\\Test.txt");
        //sw.WriteLine(SortExpression);
        //sw.Close();

        if (SortExpression == null || SortExpression.Length == 0) SortExpression = "cas DESC";


        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand(""+
            //    "SELECT * FROM (SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ "+
            //    "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
            //    "WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY cas DESC LIMIT " + maxPocetSprav + ") AS foo ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE LIMIT 500", odbcConnection);
            OdbcCommand odbcCommand = new OdbcCommand("SELECT * "+
                "FROM ((SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.odosielatel_id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.cas,alumni.skupinova_sprava.predmet,alumni.skupinova_sprava.precitana,alumni.skupinova_sprava.odosielatel_kos,alumni.skupinova_sprava.prijemca_kos,alumni.skupinova_sprava.odosielatel_zmazana,alumni.skupinova_sprava.prijemca_zmazana,alumni.skupinova_sprava.notifikovat,alumni.skupinova_sprava.typ_spravy_id,'' as odosielatel_konto,alumni.skupinova_sprava.prijemca_skup as prijemca_konto,'Skupinov sprva' as meno,'' as priezvisko,alumni.typ_spravy.typ " +
                "FROM alumni.skupinova_sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE odosielatel_id = ? AND alumni.skupinova_sprava.prijemca_id=alumni.osoba.id AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.skupinova_sprava.odosielatel_kos=TRUE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,'' as odosielatel_konto,alumni.osoba.konto as prijemca_konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ " +
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=TRUE AND alumni.sprava.odosielatel_zmazana=FALSE "+
          //      "OR (prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.prijemca_kos=TRUE AND alumni.sprava.prijemca_zmazana=FALSE)" +
                "UNION SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto as odosielatel_konto,'' as prijemca_konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ " +
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy " +
                "WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.prijemca_kos=TRUE AND alumni.sprava.prijemca_zmazana=FALSE " +
          //      "UNION SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ "+
          //      "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy " +
                ") ORDER BY cas DESC LIMIT " + maxPocetSprav + ") AS foo ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);


            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = vlastnik_id;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = vlastnik_id;

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = vlastnik_id;

            odbcCommand.Parameters.Add("@limit", OdbcType.Int).Value = limit;

            odbcCommand.Parameters.Add("@offset", OdbcType.Int).Value = offset;


            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {

                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader8(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);

                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static int CountSelectByKos(int vlastnik_id, int limit, int offset, string SortExpression) //odoslane spravy s menom prijemcu, bez textu spravy - odoslane spravy zoznam
    {
        //Sprava sprava;
        //List<Sprava> spravaList = new List<Sprava>();



        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("(SELECT alumni.skupinova_sprava.id "+
                "FROM alumni.skupinova_sprava "+
                "WHERE odosielatel_id = ? AND alumni.skupinova_sprava.odosielatel_kos=TRUE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT alumni.sprava.id "+
                "FROM ONLY alumni.sprava "+
                "WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.odosielatel_kos=TRUE AND alumni.sprava.odosielatel_zmazana=FALSE "+
                "UNION SELECT alumni.sprava.id "+
                "FROM ONLY alumni.sprava "+
                "WHERE prijemca_id = ? AND alumni.sprava.prijemca_kos=TRUE AND alumni.sprava.prijemca_zmazana=FALSE) LIMIT " + maxPocetSprav, odbcConnection);


            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = vlastnik_id;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = vlastnik_id;

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = vlastnik_id;

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }
    */


 /*   public static List<Sprava> SelectByPrijemca2(int prijemca_id, int limit, int offset)    //vypis prijatych sprav s menom odosielatela, bez textu spravy, bez priecinku - zoznam prijatych sprav
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE prijemca_id = ? AND alumni.sprava.odosielatel_id=alumni.osoba.id AND alumni.sprava.prijemca_kos=FALSE AND alumni.sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT ? OFFSET ?", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;
            odbcCommand.Parameters.Add("@limit", OdbcType.Int).Value = limit;
            odbcCommand.Parameters.Add("@offset", OdbcType.Int).Value = offset;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {

                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader3(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);

                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }
    */


    public static List<Sprava> SelectByOdosielatel(int odosielatel_id) //odoslane spravy s menom prijemcu, s textom spravy - xxx
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.text,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE odosielatel_id = ? AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.odosielatel_kos=FALSE AND alumni.sprava.odosielatel_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
     //       odbcCommand.Parameters.Add("@priecinok", OdbcType.Numeric).Value = priecinok;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader2(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByOdosielatel2(int odosielatel_id) //odoslane spravy s menom prijemcu, bez textu spravy - odoslane spravy zoznam
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE odosielatel_id = ? AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.odosielatel_kos=FALSE AND alumni.sprava.odosielatel_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader4(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByOdosielatel3(int odosielatel_id, int limit, int offset, string SortExpression, bool kos) //odoslane spravy s menom prijemcu, bez textu spravy - odoslane spravy zoznam
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        if (SortExpression == null || SortExpression.Length == 0) SortExpression = "cas DESC";
        //StreamWriter sw = new StreamWriter("C:\\Test.txt");
        //sw.WriteLine(SortExpression);
        //sw.Close();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT * "+
                "FROM ((SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.odosielatel_id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.cas,alumni.skupinova_sprava.predmet,alumni.skupinova_sprava.precitana,alumni.skupinova_sprava.odosielatel_kos,alumni.skupinova_sprava.prijemca_kos,alumni.skupinova_sprava.odosielatel_zmazana,alumni.skupinova_sprava.prijemca_zmazana,alumni.skupinova_sprava.notifikovat,alumni.skupinova_sprava.typ_spravy_id,alumni.skupinova_sprava.prijemca_skup as konto,'Skupinov sprva' as meno,'' as priezvisko,alumni.typ_spravy.typ "+
                "FROM alumni.skupinova_sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE odosielatel_id = ? AND alumni.skupinova_sprava.prijemca_id=alumni.osoba.id AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.skupinova_sprava.odosielatel_kos=? AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ "+
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=? AND alumni.sprava.odosielatel_zmazana=FALSE) ORDER BY cas DESC LIMIT "+maxPocetSprav+") AS foo ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@limit", OdbcType.Int).Value = limit;

            odbcCommand.Parameters.Add("@offset", OdbcType.Int).Value = offset;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader4(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static int CountSelectByOdosielatel3(int odosielatel_id, int limit, int offset, string SortExpression, bool kos) //odoslane spravy s menom prijemcu, bez textu spravy - odoslane spravy zoznam
    {
        //Sprava sprava;
        //List<Sprava> spravaList = new List<Sprava>();



        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("(SELECT alumni.skupinova_sprava.id "+
                "FROM alumni.skupinova_sprava "+
                "WHERE odosielatel_id = ? AND alumni.skupinova_sprava.odosielatel_kos=? AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT alumni.sprava.id "+
                "FROM ONLY alumni.sprava "+
                "WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.odosielatel_kos=? AND alumni.sprava.odosielatel_zmazana=FALSE) LIMIT "+maxPocetSprav, odbcConnection);


            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }

    public static Sprava SelectById2(int id, int odosielatel_id)    //vyber (odoslanej) spravy podla id spravy a odosielatela s menom prijemcu - odoslana sprava detail
    {
        Sprava sprava;

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko FROM alumni.sprava,alumni.osoba WHERE sprava.id = ? AND sprava.odosielatel_id = ? AND sprava.prijemca_id=osoba.id AND sprava.odosielatel_kos=FALSE AND sprava.odosielatel_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = id;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                if (!odbcDataReader.Read())
                {
                    odbcDataReader.Close();
                    odbcConnection.Close();

                    return null;
                }

                sprava = new Sprava();

                sprava.ValuesFromReader2(odbcDataReader.GetInt32(0), odbcDataReader);

                odbcDataReader.Close();
            }

            odbcConnection.Close();
        }

        return sprava;
    }

    public static List<Sprava> SelectById3(int[] ids, int odosielatel_id, bool kos)    //vyber (odoslanych) sprav podla id sprav a odosielatela s menom prijemcu - odoslane spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String whereSkupSprava = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    whereSkupSprava += "skupinova_sprava.id=?)";
                }
                else
                {
                    whereSkupSprava += "skupinova_sprava.id=? OR ";
                }
            }

            String whereSprava = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    whereSprava += "sprava.id=?)";
                }
                else
                {
                    whereSprava += "sprava.id=? OR ";
                }
            }

      //      OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ FROM alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE sprava.odosielatel_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.prijemca_id=osoba.id AND sprava.odosielatel_kos=FALSE AND sprava.odosielatel_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);
    //        OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.odosielatel_id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.cas,alumni.skupinova_sprava.predmet,alumni.skupinova_sprava.precitana,alumni.skupinova_sprava.odosielatel_kos,alumni.skupinova_sprava.prijemca_kos,alumni.skupinova_sprava.odosielatel_zmazana,alumni.skupinova_sprava.prijemca_zmazana,alumni.skupinova_sprava.notifikovat,alumni.skupinova_sprava.typ_spravy_id,alumni.skupinova_sprava.prijemca_skup as konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ FROM alumni.skupinova_sprava,alumni.osoba,alumni.typ_spravy WHERE odosielatel_id = ? AND alumni.skupinova_sprava.prijemca_id=alumni.osoba.id AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.skupinova_sprava.odosielatel_kos=FALSE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE UNION SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.cas,alumni.sprava.predmet,alumni.sprava.precitana,alumni.sprava.odosielatel_kos,alumni.sprava.prijemca_kos,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.notifikovat,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.osoba.meno,alumni.osoba.priezvisko,alumni.typ_spravy.typ FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=FALSE AND alumni.sprava.odosielatel_zmazana=FALSE ORDER BY " + SortExpression + " LIMIT ? OFFSET ?", odbcConnection);
            OdbcCommand odbcCommand = new OdbcCommand("(SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.odosielatel_id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.cas,alumni.skupinova_sprava.predmet,alumni.skupinova_sprava.text,alumni.skupinova_sprava.precitana,alumni.skupinova_sprava.odosielatel_kos,alumni.skupinova_sprava.prijemca_kos,alumni.skupinova_sprava.odosielatel_zmazana,alumni.skupinova_sprava.prijemca_zmazana,alumni.skupinova_sprava.notifikovat,alumni.skupinova_sprava.typ_spravy_id,alumni.skupinova_sprava.prijemca_skup as konto,"+
                "alumni.skupinova_sprava.prijemca_skup as meno,'' as priezvisko,typ_spravy.typ "+
                "FROM alumni.skupinova_sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE odosielatel_id = ? AND " + whereSkupSprava + " AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND skupinova_sprava.prijemca_id=osoba.id AND alumni.skupinova_sprava.odosielatel_kos=? AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ "+
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE odosielatel_id = ? AND " + whereSprava + " AND sprava.typ_spravy_id!=2 AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND sprava.prijemca_id=osoba.id AND alumni.sprava.odosielatel_kos=? AND alumni.sprava.odosielatel_zmazana=FALSE) ORDER BY cas DESC LIMIT "+maxPocetSprav, odbcConnection);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@skupinova_sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;
             
            
            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader2(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByIdVymazatOdoslane(int[] ids, int odosielatel_id, bool kos)    //vyber (odoslanych) sprav podla id sprav a odosielatela s menom prijemcu - odoslane spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String whereSkupSprava = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    whereSkupSprava += "skupinova_sprava.id=?)";
                }
                else
                {
                    whereSkupSprava += "skupinova_sprava.id=? OR ";
                }
            }

            String whereSprava = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    whereSprava += "sprava.id=?)";
                }
                else
                {
                    whereSprava += "sprava.id=? OR ";
                }
            }
    //        OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ FROM alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE sprava.odosielatel_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.prijemca_id=osoba.id AND sprava.odosielatel_kos=FALSE AND sprava.odosielatel_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.odosielatel_id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.odosielatel_zmazana,alumni.skupinova_sprava.prijemca_zmazana,alumni.skupinova_sprava.typ_spravy_id,alumni.typ_spravy.typ FROM alumni.skupinova_sprava,alumni.typ_spravy WHERE odosielatel_id = ? AND " + whereSkupSprava + " AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.skupinova_sprava.odosielatel_kos=? AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
            //    "UNION SELECT alumni.sprava.id,alumni.sprava.odosielatel_id,alumni.sprava.prijemca_id,alumni.sprava.odosielatel_zmazana,alumni.sprava.prijemca_zmazana,alumni.sprava.typ_spravy_id,alumni.typ_spravy.typ FROM ONLY alumni.sprava,alumni.typ_spravy WHERE odosielatel_id = ? AND " + whereSprava + " AND sprava.typ_spravy_id!=2 AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=? AND alumni.sprava.odosielatel_zmazana=FALSE", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.prijemca_zmazana,alumni.skupinova_sprava.typ_spravy_id "+
                "FROM alumni.skupinova_sprava "+
                "WHERE odosielatel_id = ? AND " + whereSkupSprava + " AND alumni.skupinova_sprava.odosielatel_kos=? AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT alumni.sprava.id,alumni.sprava.prijemca_zmazana,alumni.sprava.typ_spravy_id "+
                "FROM ONLY alumni.sprava "+
                "WHERE odosielatel_id = ? AND " + whereSprava + " AND sprava.typ_spravy_id!=2 AND alumni.sprava.odosielatel_kos=? AND alumni.sprava.odosielatel_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@skupinova_sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = kos;




            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReaderVymazatOdoslane(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectById4(int[] ids, int prijemca_id, bool kos)    //vyber (prijatych) sprav podla id sprav a prijemcu s menom odosielatela - prijate spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,"+
                "osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ " +
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy " +
                "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.odosielatel_id=osoba.id AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT "+maxPocetSprav, odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader1(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectById4Vymazat(int[] ids, int prijemca_id, bool kos)    //vyber (prijatych) sprav podla id sprav a prijemcu s menom odosielatela - prijate spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ "+
            //    "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
            //    "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.odosielatel_id=osoba.id AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.id,sprava.odosielatel_zmazana,sprava.typ_spravy_id " +
                "FROM ONLY alumni.sprava " +
                "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReaderVymazat(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectById4Precitana(int[] ids, int prijemca_id, bool kos)    //vyber (prijatych) sprav podla id sprav a prijemcu s menom odosielatela - prijate spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ "+
            //    "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
            //    "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.odosielatel_id=osoba.id AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.id,sprava.precitana,sprava.notifikovat " +
                "FROM ONLY alumni.sprava " +
                "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReaderPrecitana(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectById4Notifikovat(int[] ids, int prijemca_id, bool kos)    //vyber (prijatych) sprav podla id sprav a prijemcu s menom odosielatela - prijate spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ "+
            //    "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
            //    "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.odosielatel_id=osoba.id AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.id,sprava.precitana,sprava.notifikovat,sprava.typ_spravy_id " +
                "FROM ONLY alumni.sprava " +
                "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = kos;

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReaderNotifikovat(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectById4BlackList(int[] ids, int prijemca_id)    //vyber (prijatych) sprav podla id sprav a prijemcu s menom odosielatela - prijate spravy detail
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ "+
            //    "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
            //    "WHERE sprava.prijemca_id = ? AND " + where + " AND sprava.typ_spravy_id=typ_spravy.id AND sprava.odosielatel_id=osoba.id AND sprava.prijemca_kos=? AND sprava.prijemca_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.id,osoba.konto " +
                "FROM ONLY alumni.sprava,alumni.osoba " +
                "WHERE sprava.prijemca_id = ? AND sprava.odosielatel_id=osoba.id AND " + where + " AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReaderBlackList(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByIdAndPrijemca(int id, int prijemca_id)    //vyber (prijatej) spravy podla id spravy a prijemcu s menom odosielatela - odpovedat
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {

            OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.id,sprava.odosielatel_id,sprava.cas,sprava.predmet,sprava.text,sprava.typ_spravy_id,osoba.konto,typ_spravy.typ "+
                "FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy "+
                "WHERE sprava.id = ? AND sprava.prijemca_id = ? AND sprava.odosielatel_id=osoba.id AND sprava.typ_spravy_id=typ_spravy.id AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = id;

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;


            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader7(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static List<Sprava> SelectByIdAndOdosielatel(int id, int odosielatel_id)    //vyber (odoslanej) spravy podla id spravy a prijemcu s menom prijemcu - napisat novu
    {
        Sprava sprava;
        List<Sprava> spravaList = new List<Sprava>();

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {

        //    OdbcCommand odbcCommand = new OdbcCommand("SELECT sprava.*,osoba.konto,osoba.meno,osoba.priezvisko,typ_spravy.typ FROM alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE sprava.id = ? AND sprava.odosielatel_id = ? AND sprava.prijemca_id=osoba.id AND sprava.typ_spravy_id=typ_spravy.id AND sprava.odosielatel_zmazana=FALSE ORDER BY alumni.sprava.cas DESC LIMIT 500", odbcConnection);
            //OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.predmet,alumni.skupinova_sprava.text,alumni.skupinova_sprava.typ_spravy_id,alumni.skupinova_sprava.prijemca_skup as konto,alumni.typ_spravy.typ FROM alumni.skupinova_sprava,alumni.typ_spravy WHERE skupinova_sprava.id = ? AND odosielatel_id = ? AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.skupinova_sprava.odosielatel_kos=FALSE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
            //    "UNION SELECT alumni.sprava.id,alumni.sprava.prijemca_id,alumni.sprava.predmet,alumni.sprava.text,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.typ_spravy.typ FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE sprava.id = ? AND odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=FALSE AND alumni.sprava.odosielatel_zmazana=FALSE", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("SELECT alumni.skupinova_sprava.id,alumni.skupinova_sprava.prijemca_id,alumni.skupinova_sprava.predmet,alumni.skupinova_sprava.text,alumni.skupinova_sprava.typ_spravy_id,alumni.skupinova_sprava.prijemca_skup as konto,alumni.typ_spravy.typ FROM alumni.skupinova_sprava,alumni.typ_spravy WHERE skupinova_sprava.id = ? AND odosielatel_id = ? AND alumni.skupinova_sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
                "UNION SELECT alumni.sprava.id,alumni.sprava.prijemca_id,alumni.sprava.predmet,alumni.sprava.text,alumni.sprava.typ_spravy_id,alumni.osoba.konto,alumni.typ_spravy.typ FROM ONLY alumni.sprava,alumni.osoba,alumni.typ_spravy WHERE sprava.id = ? AND odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.prijemca_id=alumni.osoba.id AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_zmazana=FALSE", odbcConnection);


            odbcCommand.Parameters.Add("@skupinova_sprava.id", OdbcType.Int).Value = id;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = id;

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;


            odbcConnection.Open();

            using (OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader())
            {
                while (odbcDataReader.Read())
                {
                    sprava = new Sprava();

                    sprava.ValuesFromReader6(odbcDataReader.GetInt32(0), odbcDataReader);

                    spravaList.Add(sprava);
                }

                odbcDataReader.Close();
            }
            odbcConnection.Close();
        }

        return spravaList;
    }

    public static void UpdatePrecitana(int[] ids, int prijemca_id, bool precitana)  //nastavenie priznaku precitana podla id sprav a prijemcu - prijate spravy detail
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("UPDATE ONLY alumni.sprava SET precitana = ? WHERE sprava.prijemca_id = ? AND " + where, odbcConnection
            );

            odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = precitana;

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void UpdatePrecitanaNotifikovat(int[] ids, int prijemca_id, bool precitana, bool notifikovat)  //nastavenie priznaku precitana a notifikacie podla id sprav a prijemcu - prijate spravy zoznam -> vyber spravy
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("UPDATE ONLY alumni.sprava SET precitana = ?, notifikovat = ? WHERE sprava.prijemca_id = ? AND " + where, odbcConnection
            );
            
            odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = precitana;
            odbcCommand.Parameters.Add("@notifikovat", OdbcType.Char).Value = notifikovat;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void UpdateNotifikovat(int[] ids, int prijemca_id, bool notifikovat)  //nastavenie priznaku precitana a notifikacie podla id sprav a prijemcu - prijate spravy zoznam -> vyber spravy
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("UPDATE ONLY alumni.sprava SET notifikovat = ? WHERE sprava.prijemca_id = ? AND " + where, odbcConnection
            );
            odbcCommand.Parameters.Add("@notifikovat", OdbcType.Char).Value = notifikovat;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void UpdateKosOdosielatel(int[] ids, int odosielatel_id, bool odosielatel_kos) //nastavenie priznaku kosa odoslanych sprav podla id sprav a odosielatela - odoslane spravy zoznam -> akcia do kosa
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }

            OdbcCommand odbcCommand = new OdbcCommand("UPDATE alumni.sprava "+
                "SET odosielatel_kos = ? "+
                "WHERE sprava.odosielatel_id = ? AND " + where, odbcConnection);
            odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = odosielatel_kos;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
   //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void UpdateKosPrijemca(int[] ids, int prijemca_id, bool prijemca_kos) //nastavenie priznaku kos prijatych sprav podla id sprav a prijemcu - prijate spravy zoznam -> akcia do kosa
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("UPDATE ONLY alumni.sprava "+
                "SET prijemca_kos = ? "+
                "WHERE sprava.prijemca_id = ? AND " + where, odbcConnection
            );
            odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = prijemca_kos;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;
            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void UpdateZmazanaOdosielatel(int[] ids, int odosielatel_id, bool odosielatel_zmazana) //nastavenie priznaku zmazana odoslanych sprav podla id sprav a odosielatela - odoslane spravy zoznam -> akcia zmazat
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("UPDATE ONLY alumni.sprava SET odosielatel_zmazana = ? "+
                "WHERE sprava.odosielatel_id = ? AND sprava.typ_spravy_id !=2 AND " + where, odbcConnection

            );
            odbcCommand.Parameters.Add("@odosielatel_zmazana", OdbcType.Char).Value = odosielatel_zmazana;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void UpdateZmazanaPrijemca(int[] ids, int prijemca_id, bool prijemca_zmazana) //nastavenie priznaku zmazana prijatych sprav podla id sprav a prijemcu - prijate spravy zoznam -> akcia zmazat
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("UPDATE ONLY alumni.sprava "+
                "SET prijemca_zmazana = ? "+
                "WHERE sprava.prijemca_id = ? AND " + where, odbcConnection
            );
            odbcCommand.Parameters.Add("@prijemca_zmazana", OdbcType.Char).Value = prijemca_zmazana;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;
            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void DeletePrijemca(int[] ids, int prijemca_id) //
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
            OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM ONLY alumni.sprava "+
                "WHERE sprava.prijemca_id = ? AND "+where, odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }
            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void DeleteOdosielatel(int[] ids, int odosielatel_id) //
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            String where = "(";
            for (int i = 0; i < ids.Length; i++)
            {
                if (i == (ids.Length - 1))
                {
                    where += "sprava.id=?)";
                }
                else
                {
                    where += "sprava.id=? OR ";
                }


            }
        //    OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.sprava WHERE sprava.odosielatel_id = ? AND " + where, odbcConnection);

            //OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.sprava WHERE "+where+" AND sprava.id IN "+
            //"(SELECT alumni.skupinova_sprava.id FROM alumni.skupinova_sprava WHERE odosielatel_id = ? AND alumni.skupinova_sprava.odosielatel_kos=FALSE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE "+
            //"UNION SELECT alumni.sprava.id FROM ONLY alumni.sprava,alumni.typ_spravy WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=FALSE AND alumni.sprava.odosielatel_zmazana=FALSE)", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.sprava WHERE " + where + " AND sprava.id IN " +
            "(SELECT alumni.skupinova_sprava.id FROM alumni.skupinova_sprava WHERE odosielatel_id = ? AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
            "UNION SELECT alumni.sprava.id FROM ONLY alumni.sprava,alumni.typ_spravy WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_zmazana=FALSE)", odbcConnection);
            //bez kosa

            for (int i = 0; i < ids.Length; i++)
            {
                odbcCommand.Parameters.Add("@sprava.id", OdbcType.Int).Value = ids[i];
            }

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void VysypatKosOdosielatel(int odosielatel_id) //
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
           
            //    OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.sprava WHERE sprava.odosielatel_id = ? AND " + where, odbcConnection);

            //OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.sprava WHERE "+where+" AND sprava.id IN "+
            //"(SELECT alumni.skupinova_sprava.id FROM alumni.skupinova_sprava WHERE odosielatel_id = ? AND alumni.skupinova_sprava.odosielatel_kos=FALSE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE "+
            //"UNION SELECT alumni.sprava.id FROM ONLY alumni.sprava,alumni.typ_spravy WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=FALSE AND alumni.sprava.odosielatel_zmazana=FALSE)", odbcConnection);

            OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM alumni.sprava WHERE sprava.id IN " +
            "(SELECT alumni.skupinova_sprava.id FROM alumni.skupinova_sprava WHERE odosielatel_id = ? AND alumni.skupinova_sprava.odosielatel_kos=TRUE AND alumni.skupinova_sprava.odosielatel_zmazana=FALSE " +
            "UNION SELECT alumni.sprava.id FROM ONLY alumni.sprava,alumni.typ_spravy WHERE odosielatel_id = ? AND sprava.typ_spravy_id!=2 AND sprava.prijemca_zmazana=TRUE AND alumni.sprava.typ_spravy_id=alumni.typ_spravy.id AND alumni.sprava.odosielatel_kos=TRUE AND alumni.sprava.odosielatel_zmazana=FALSE)", odbcConnection);
            

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;
            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            OdbcCommand odbcCommand2 = new OdbcCommand("UPDATE ONLY alumni.sprava SET odosielatel_zmazana = TRUE " +
                "WHERE sprava.odosielatel_id = ? AND sprava.typ_spravy_id !=2 AND sprava.prijemca_zmazana=FALSE AND alumni.sprava.odosielatel_kos=TRUE AND alumni.sprava.odosielatel_zmazana=FALSE", odbcConnection);

            odbcCommand2.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = odosielatel_id;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();
            odbcCommand2.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static void VysypatKosPrijemca(int prijemca_id) //nastavenie priznaku kos prijatych sprav podla id sprav a prijemcu - prijate spravy zoznam -> akcia do kosa
    {
        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {

            OdbcCommand odbcCommand = new OdbcCommand("DELETE FROM ONLY alumni.sprava " +
                "WHERE sprava.prijemca_id = ? AND sprava.prijemca_kos=TRUE AND (sprava.typ_spravy_id=2 or sprava.odosielatel_zmazana=TRUE)  AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            OdbcCommand odbcCommand2 = new OdbcCommand("UPDATE ONLY alumni.sprava " +
                "SET prijemca_zmazana = TRUE " +
                "WHERE sprava.prijemca_id = ? AND sprava.prijemca_kos=TRUE AND sprava.typ_spravy_id !=2 AND sprava.odosielatel_zmazana=FALSE AND sprava.prijemca_zmazana=FALSE", odbcConnection);

            odbcCommand2.Parameters.Add("@prijemca_id", OdbcType.Int).Value = prijemca_id;

            //         odbcCommand.Parameters.Add("@sprava.priecinok", OdbcType.Decimal).Value = priecinok;

            odbcConnection.Open();

            odbcCommand.ExecuteNonQuery();
            odbcCommand2.ExecuteNonQuery();

            odbcConnection.Close();
        }
    }

    public static int Insert2(Sprava sprava)   //nova sprava
    {
        //using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        //{
        //    OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
        //       "odosielatel_id, prijemca_id, cas, predmet, text)" +
        //       "VALUES (?, ?, ?, ?, ?)", odbcConnection
        //    );

        //    odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
        //    odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
        //    odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
        //    odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
        //    odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);

        //    odbcConnection.Open();

        //    odbcCommand.ExecuteNonQuery();
            
        //    odbcConnection.Close();
        //}

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text) " +
            //   "SELECT ?, osoba.id, ?, ?, ? FROM alumni.osoba "+
            //   "WHERE osoba.konto = ? AND osoba.id != ? AND osoba.konto_aktivne = true "+
            //   "AND NOT EXISTS (SELECT id FROM alumni.blacklist_sprava " +
            //   "WHERE blacklist_sprava.odosielatel_id=? AND blacklist_sprava.prijemca_id=osoba.id)", odbcConnection
            //);
            
            OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
               "odosielatel_id, prijemca_id, cas, predmet, text) " +
               "SELECT ?, osoba_prijemca.id, ?, ?, ? FROM alumni.osoba AS osoba_prijemca "+
               "WHERE osoba_prijemca.konto = ? AND osoba_prijemca.id != ? AND osoba_prijemca.konto_aktivne = true "+
               "AND NOT EXISTS "+
               "(SELECT * FROM alumni.blacklist_sprava,alumni.osoba AS osoba_odosielatel,alumni.typ_osoby AS typ " +
               "WHERE blacklist_sprava.prijemca_id=osoba_prijemca.id AND osoba_odosielatel.typ_osoby_id=typ.id AND osoba_odosielatel.id=? "+
               "AND (blacklist_sprava.odosielatel_konto=osoba_odosielatel.konto AND blacklist_sprava.is_skupina=FALSE "+
               "OR blacklist_sprava.odosielatel_konto='rok:'||osoba_odosielatel.rok_absolvovania AND blacklist_sprava.is_skupina=TRUE "+
               "OR blacklist_sprava.odosielatel_konto='typ:'||typ.typ AND blacklist_sprava.is_skupina=TRUE)"+
               ")", odbcConnection
            );

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
            odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
            odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
            odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);
            odbcCommand.Parameters.Add("@konto", OdbcType.NVarChar).Value = sprava.PrijemcaKonto;
        //    odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
       //     odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();
            
            odbcConnection.Close();

            return rows;
        }
    }

    public static int Insert2TypOsoby(Sprava sprava, string typOsoby)   //nova sprava
    {
        //using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        //{
        //    OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
        //       "odosielatel_id, prijemca_id, cas, predmet, text)" +
        //       "VALUES (?, ?, ?, ?, ?)", odbcConnection
        //    );

        //    odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
        //    odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
        //    odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
        //    odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
        //    odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);

        //    odbcConnection.Open();

        //    odbcCommand.ExecuteNonQuery();

        //    odbcConnection.Close();
        //}

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id) " +
            //   "SELECT ?, osoba.id, ?, ?, ?, ? FROM alumni.osoba,alumni.typ_osoby WHERE alumni.osoba.typ_osoby_id=alumni.typ_osoby.id AND alumni.typ_osoby.typ = ? AND osoba.id != ? AND alumni.osoba.konto_aktivne = true", odbcConnection
            //);

            OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
               "odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id) " +
               "SELECT ?, osoba_prijemca.id, ?, ?, ?, ? FROM alumni.osoba AS osoba_prijemca,alumni.typ_osoby " +
               "WHERE osoba_prijemca.typ_osoby_id=alumni.typ_osoby.id AND alumni.typ_osoby.typ = ? AND osoba_prijemca.konto_aktivne = true " +
               "AND NOT EXISTS " +
               "(SELECT * FROM alumni.blacklist_sprava,alumni.osoba AS osoba_odosielatel,alumni.typ_osoby AS typ " +
               "WHERE blacklist_sprava.prijemca_id=osoba_prijemca.id AND osoba_odosielatel.typ_osoby_id=typ.id AND osoba_odosielatel.id=? " +
               "AND (blacklist_sprava.odosielatel_konto=osoba_odosielatel.konto AND blacklist_sprava.is_skupina=FALSE " +
               "OR blacklist_sprava.odosielatel_konto='rok:'||osoba_odosielatel.rok_absolvovania AND blacklist_sprava.is_skupina=TRUE " +
               "OR blacklist_sprava.odosielatel_konto='typ:'||typ.typ AND blacklist_sprava.is_skupina=TRUE)" +
               ")", odbcConnection
            );
            //aj sebe moze

            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text) " +
            //   "SELECT ?, osoba_prijemca.id, ?, ?, ? FROM alumni.osoba AS osoba_prijemca " +
            //   "WHERE osoba_prijemca.konto = ? AND osoba_prijemca.id != ? AND osoba_prijemca.konto_aktivne = true " +
            //   "AND NOT EXISTS " +
            //   "(SELECT * FROM alumni.blacklist_sprava,alumni.osoba AS osoba_odosielatel,alumni.typ_osoby AS typ " +
            //   "WHERE blacklist_sprava.prijemca_id=osoba_prijemca.id AND osoba_odosielatel.typ_osoby_id=typ.id AND osoba_odosielatel.id=? " +
            //   "AND (blacklist_sprava.odosielatel_konto=osoba_odosielatel.konto AND blacklist_sprava.is_skupina=FALSE " +
            //   "OR blacklist_sprava.odosielatel_konto='rok:'||osoba_odosielatel.rok_absolvovania AND blacklist_sprava.is_skupina=TRUE " +
            //   "OR blacklist_sprava.odosielatel_konto='typ:'||typ.typ AND blacklist_sprava.is_skupina=TRUE)" +
            //   ")", odbcConnection
            //);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
            odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
            odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
            odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);
            odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = sprava.TypSpravyId;
            odbcCommand.Parameters.Add("@typ_osoby", OdbcType.NVarChar).Value = typOsoby;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
          //aj sebe moze  odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            if (rows > 0) 
            {

            odbcCommand = new OdbcCommand("INSERT INTO alumni.skupinova_sprava( " +
               "id, odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id, prijemca_skup) " +
               "VALUES (nextval('alumni.sprava_id_seq'), ?, ?, ?, ?, ?, ?, ?)", odbcConnection
            );
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
            odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.OdosielatelId;
            odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
            odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
            odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);
            odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = sprava.TypSpravyId;
            odbcCommand.Parameters.Add("@prijemca_skup", OdbcType.NVarChar).Value = sprava.PrijemcaKonto;
            }

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }

    public static int Insert2RokAbsolvovania(Sprava sprava, int rokAbsolvovania)   //nova sprava
    {
        //using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        //{
        //    OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
        //       "odosielatel_id, prijemca_id, cas, predmet, text)" +
        //       "VALUES (?, ?, ?, ?, ?)", odbcConnection
        //    );

        //    odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
        //    odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
        //    odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
        //    odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
        //    odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);

        //    odbcConnection.Open();

        //    odbcCommand.ExecuteNonQuery();

        //    odbcConnection.Close();
        //}

        using (OdbcConnection odbcConnection = new OdbcConnection(ConfigurationManager.ConnectionStrings["alumni"].ConnectionString))
        {
            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id) " +
            //   "SELECT ?, osoba.id, ?, ?, ?, ? FROM alumni.osoba,alumni.typ_osoby WHERE alumni.osoba.typ_osoby_id=alumni.typ_osoby.id AND alumni.typ_osoby.typ = ? AND osoba.id != ? AND alumni.osoba.konto_aktivne = true", odbcConnection
            //);

            OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
               "odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id) " +
               "SELECT ?, osoba_prijemca.id, ?, ?, ?, ? FROM alumni.osoba AS osoba_prijemca " +
               "WHERE osoba_prijemca.rok_absolvovania = ? AND osoba_prijemca.konto_aktivne = true " +
               "AND NOT EXISTS " +
               "(SELECT * FROM alumni.blacklist_sprava,alumni.osoba AS osoba_odosielatel,alumni.typ_osoby AS typ " +
               "WHERE blacklist_sprava.prijemca_id=osoba_prijemca.id AND osoba_odosielatel.typ_osoby_id=typ.id AND osoba_odosielatel.id=? " +
               "AND (blacklist_sprava.odosielatel_konto=osoba_odosielatel.konto AND blacklist_sprava.is_skupina=FALSE " +
               "OR blacklist_sprava.odosielatel_konto='rok:'||osoba_odosielatel.rok_absolvovania AND blacklist_sprava.is_skupina=TRUE " +
               "OR blacklist_sprava.odosielatel_konto='typ:'||typ.typ AND blacklist_sprava.is_skupina=TRUE)" +
               ")", odbcConnection
            );
            //aj sebe moze

            //OdbcCommand odbcCommand = new OdbcCommand("INSERT INTO alumni.sprava( " +
            //   "odosielatel_id, prijemca_id, cas, predmet, text) " +
            //   "SELECT ?, osoba_prijemca.id, ?, ?, ? FROM alumni.osoba AS osoba_prijemca " +
            //   "WHERE osoba_prijemca.konto = ? AND osoba_prijemca.id != ? AND osoba_prijemca.konto_aktivne = true " +
            //   "AND NOT EXISTS " +
            //   "(SELECT * FROM alumni.blacklist_sprava,alumni.osoba AS osoba_odosielatel,alumni.typ_osoby AS typ " +
            //   "WHERE blacklist_sprava.prijemca_id=osoba_prijemca.id AND osoba_odosielatel.typ_osoby_id=typ.id AND osoba_odosielatel.id=? " +
            //   "AND (blacklist_sprava.odosielatel_konto=osoba_odosielatel.konto AND blacklist_sprava.is_skupina=FALSE " +
            //   "OR blacklist_sprava.odosielatel_konto='rok:'||osoba_odosielatel.rok_absolvovania AND blacklist_sprava.is_skupina=TRUE " +
            //   "OR blacklist_sprava.odosielatel_konto='typ:'||typ.typ AND blacklist_sprava.is_skupina=TRUE)" +
            //   ")", odbcConnection
            //);

            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
            odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
            odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
            odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);
            odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = sprava.TypSpravyId;
            odbcCommand.Parameters.Add("@rok_absolvovania", OdbcType.Int).Value = rokAbsolvovania;
            odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
            //aj sebe moze  odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;

            odbcConnection.Open();

            int rows = odbcCommand.ExecuteNonQuery();

            if (rows > 0)
            {

                odbcCommand = new OdbcCommand("INSERT INTO alumni.skupinova_sprava( " +
                   "id, odosielatel_id, prijemca_id, cas, predmet, text, typ_spravy_id, prijemca_skup) " +
                   "VALUES (nextval('alumni.sprava_id_seq'), ?, ?, ?, ?, ?, ?, ?)", odbcConnection
                );
                odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
                odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.OdosielatelId;
                odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
                odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = (sprava.Predmet == null ? null : sprava.Predmet);
                odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = (sprava.Text == null ? null : sprava.Text);
                odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = sprava.TypSpravyId;
                odbcCommand.Parameters.Add("@prijemca_skup", OdbcType.NVarChar).Value = sprava.PrijemcaKonto;
            }

            odbcCommand.ExecuteNonQuery();

            odbcConnection.Close();

            return rows;
        }
    }
}
