using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;
using System.Data.Odbc;

public partial class StudiumDAL
{
    public static List<Studium> SelectByOsobaId( int osobaId )
    {
        List<Studium> studiumList = new List<Studium>();
        Studium studium;

        using (OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString) )
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT * FROM alumni.studium WHERE osoba_id = ?", odbcConnection);

            odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

            odbcConnection.Open();

            using( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
            {
                while( odbcDataReader.Read() )
                {
                    studium = new Studium();

                    studium.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                    studiumList.Add( studium );
                }

                odbcDataReader.Close();
            }

            odbcConnection.Close();
        }

        return studiumList;
    }

    public static int SelectCountByOsobaId( int osobaId )
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.studium WHERE osoba_id = ?", odbcConnection);

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }
}
