using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class ZamestnanieDAL
{
    public static List<Zamestnanie> SelectByOsobaId(int osobaId)
    {
        List<Zamestnanie> zamestnanieList = new List<Zamestnanie>();
        Zamestnanie zamestnanie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.zamestnanie WHERE osoba_id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     zamestnanie = new Zamestnanie();

                     zamestnanie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     zamestnanieList.Add( zamestnanie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return zamestnanieList;
    }

    public static int SelectCountByOsobaId( int osobaId )
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
            OdbcCommand odbcCommand = new OdbcCommand("SELECT COUNT(*) FROM alumni.zamestnanie WHERE osoba_id = ?", odbcConnection);

            odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = osobaId;

            odbcConnection.Open();

            rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

            odbcConnection.Close();
        }

        return rowCount;
    }
}
