using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class AnketaDAL
{
    public static void Delete( Anketa anketa )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.anketa WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = anketa.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Anketa_" + anketa.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Anketa anketa )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.anketa( " +
                "nazov, mozno_upravit ) " +
                "VALUES (?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = anketa.Nazov;
             odbcCommand.Parameters.Add("@mozno_upravit", OdbcType.Char).Value = anketa.MoznoUpravit;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Anketa> Select()
    {
        List<Anketa> anketaList = new List<Anketa>();
        Anketa anketa;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.anketa", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     anketa = (Anketa)HttpContext.Current.Cache["Anketa_" + id.ToString()];

                     if( anketa == null )
                     {
                         anketa = new Anketa();

                         anketa.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Anketa_" + id.ToString()] = anketa;
                     }

                     anketaList.Add( anketa );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return anketaList;
    }

    public static Anketa SelectById( int id )
    {
        Anketa anketa = (Anketa)HttpContext.Current.Cache["Anketa_" + id.ToString()];

        if( anketa != null ) return anketa;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.anketa WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 anketa = new Anketa();

                 anketa.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Anketa_" + id.ToString()] = anketa;
             }

             odbcConnection.Close();
        }

        return anketa;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.anketa", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Anketa anketa )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.anketa SET " +
                "nazov = ?, mozno_upravit = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = anketa.Nazov;
             odbcCommand.Parameters.Add("@mozno_upravit", OdbcType.Char).Value = anketa.MoznoUpravit;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = anketa.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Anketa_" + anketa.Id.ToString()] = anketa;

             odbcConnection.Close();
        }
    }
}
