using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;

public partial class BlacklistSpravaDAL
{
    public static void Delete( BlacklistSprava blacklistSprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.blacklist_sprava WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = blacklistSprava.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static void Insert( BlacklistSprava blacklistSprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.blacklist_sprava( " +
                "odosielatel_konto, prijemca_id, is_skupina ) " +
                "VALUES (?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@odosielatel_konto", OdbcType.NVarChar).Value = blacklistSprava.OdosielatelKonto;
             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blacklistSprava.PrijemcaId;
             odbcCommand.Parameters.Add("@is_skupina", OdbcType.Char).Value = blacklistSprava.IsSkupina;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<BlacklistSprava> Select()
    {
        List<BlacklistSprava> blacklistSpravaList = new List<BlacklistSprava>();
        BlacklistSprava blacklistSprava;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.blacklist_sprava", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     blacklistSprava = new BlacklistSprava();

                     blacklistSprava.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                     blacklistSpravaList.Add( blacklistSprava );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return blacklistSpravaList;
    }

    public static BlacklistSprava SelectById( int id )
    {
        BlacklistSprava blacklistSprava;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.blacklist_sprava WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 blacklistSprava = new BlacklistSprava();

                 blacklistSprava.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return blacklistSprava;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.blacklist_sprava", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( BlacklistSprava blacklistSprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.blacklist_sprava SET " +
                "odosielatel_konto = ?, prijemca_id = ?, is_skupina = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@odosielatel_konto", OdbcType.NVarChar).Value = blacklistSprava.OdosielatelKonto;
             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = blacklistSprava.PrijemcaId;
             odbcCommand.Parameters.Add("@is_skupina", OdbcType.Char).Value = blacklistSprava.IsSkupina;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = blacklistSprava.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }
}
