using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class InstanciaAnketyDAL
{
    public static void Delete( InstanciaAnkety instanciaAnkety )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.instancia_ankety WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = instanciaAnkety.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("InstanciaAnkety_" + instanciaAnkety.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( InstanciaAnkety instanciaAnkety )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.instancia_ankety( " +
                "anketa_id, datum_od, datum_do ) " +
                "VALUES (?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@anketa_id", OdbcType.Int).Value = instanciaAnkety.AnketaId;
             odbcCommand.Parameters.Add("@datum_od", OdbcType.Date).Value = instanciaAnkety.DatumOd;
             odbcCommand.Parameters.Add("@datum_do", OdbcType.Date).Value = instanciaAnkety.DatumDo;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<InstanciaAnkety> Select()
    {
        List<InstanciaAnkety> instanciaAnketyList = new List<InstanciaAnkety>();
        InstanciaAnkety instanciaAnkety;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.instancia_ankety", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     instanciaAnkety = (InstanciaAnkety)HttpContext.Current.Cache["InstanciaAnkety_" + id.ToString()];

                     if( instanciaAnkety == null )
                     {
                         instanciaAnkety = new InstanciaAnkety();

                         instanciaAnkety.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["InstanciaAnkety_" + id.ToString()] = instanciaAnkety;
                     }

                     instanciaAnketyList.Add( instanciaAnkety );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return instanciaAnketyList;
    }

    public static InstanciaAnkety SelectById( int id )
    {
        InstanciaAnkety instanciaAnkety = (InstanciaAnkety)HttpContext.Current.Cache["InstanciaAnkety_" + id.ToString()];

        if( instanciaAnkety != null ) return instanciaAnkety;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.instancia_ankety WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 instanciaAnkety = new InstanciaAnkety();

                 instanciaAnkety.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["InstanciaAnkety_" + id.ToString()] = instanciaAnkety;
             }

             odbcConnection.Close();
        }

        return instanciaAnkety;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.instancia_ankety", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( InstanciaAnkety instanciaAnkety )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.instancia_ankety SET " +
                "anketa_id = ?, datum_od = ?, datum_do = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@anketa_id", OdbcType.Int).Value = instanciaAnkety.AnketaId;
             odbcCommand.Parameters.Add("@datum_od", OdbcType.Date).Value = instanciaAnkety.DatumOd;
             odbcCommand.Parameters.Add("@datum_do", OdbcType.Date).Value = instanciaAnkety.DatumDo;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = instanciaAnkety.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["InstanciaAnkety_" + instanciaAnkety.Id.ToString()] = instanciaAnkety;

             odbcConnection.Close();
        }
    }
}
