using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class JazykHodnotenieDAL
{
    public static void Delete( JazykHodnotenie jazykHodnotenie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.jazyk_hodnotenie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = jazykHodnotenie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("JazykHodnotenie_" + jazykHodnotenie.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( JazykHodnotenie jazykHodnotenie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.jazyk_hodnotenie( " +
                "hodnotenie_skupina, hodnotenie_popis ) " +
                "VALUES (?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@hodnotenie_skupina", OdbcType.NChar).Value = jazykHodnotenie.HodnotenieSkupina;
             odbcCommand.Parameters.Add("@hodnotenie_popis", OdbcType.NText).Value = ( jazykHodnotenie.HodnoteniePopis == null ? null : jazykHodnotenie.HodnoteniePopis );

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<JazykHodnotenie> Select()
    {
        List<JazykHodnotenie> jazykHodnotenieList = new List<JazykHodnotenie>();
        JazykHodnotenie jazykHodnotenie;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.jazyk_hodnotenie", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     jazykHodnotenie = (JazykHodnotenie)HttpContext.Current.Cache["JazykHodnotenie_" + id.ToString()];

                     if( jazykHodnotenie == null )
                     {
                         jazykHodnotenie = new JazykHodnotenie();

                         jazykHodnotenie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["JazykHodnotenie_" + id.ToString()] = jazykHodnotenie;
                     }

                     jazykHodnotenieList.Add( jazykHodnotenie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return jazykHodnotenieList;
    }

    public static JazykHodnotenie SelectById( int id )
    {
        JazykHodnotenie jazykHodnotenie = (JazykHodnotenie)HttpContext.Current.Cache["JazykHodnotenie_" + id.ToString()];

        if( jazykHodnotenie != null ) return jazykHodnotenie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.jazyk_hodnotenie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 jazykHodnotenie = new JazykHodnotenie();

                 jazykHodnotenie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["JazykHodnotenie_" + id.ToString()] = jazykHodnotenie;
             }

             odbcConnection.Close();
        }

        return jazykHodnotenie;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.jazyk_hodnotenie", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( JazykHodnotenie jazykHodnotenie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.jazyk_hodnotenie SET " +
                "hodnotenie_skupina = ?, hodnotenie_popis = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@hodnotenie_skupina", OdbcType.NChar).Value = jazykHodnotenie.HodnotenieSkupina;
             odbcCommand.Parameters.Add("@hodnotenie_popis", OdbcType.NText).Value = ( jazykHodnotenie.HodnoteniePopis == null ? null : jazykHodnotenie.HodnoteniePopis );
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = jazykHodnotenie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["JazykHodnotenie_" + jazykHodnotenie.Id.ToString()] = jazykHodnotenie;

             odbcConnection.Close();
        }
    }
}
