using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class MozneOdpovedeDAL
{
    public static void Delete( MozneOdpovede mozneOdpovede )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.mozne_odpovede WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = mozneOdpovede.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("MozneOdpovede_" + mozneOdpovede.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( MozneOdpovede mozneOdpovede )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.mozne_odpovede( " +
                "text, otazka_id ) " +
                "VALUES (?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = mozneOdpovede.Text;
             odbcCommand.Parameters.Add("@otazka_id", OdbcType.Int).Value = mozneOdpovede.OtazkaId;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<MozneOdpovede> Select()
    {
        List<MozneOdpovede> mozneOdpovedeList = new List<MozneOdpovede>();
        MozneOdpovede mozneOdpovede;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.mozne_odpovede", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     mozneOdpovede = (MozneOdpovede)HttpContext.Current.Cache["MozneOdpovede_" + id.ToString()];

                     if( mozneOdpovede == null )
                     {
                         mozneOdpovede = new MozneOdpovede();

                         mozneOdpovede.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["MozneOdpovede_" + id.ToString()] = mozneOdpovede;
                     }

                     mozneOdpovedeList.Add( mozneOdpovede );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return mozneOdpovedeList;
    }

    public static MozneOdpovede SelectById( int id )
    {
        MozneOdpovede mozneOdpovede = (MozneOdpovede)HttpContext.Current.Cache["MozneOdpovede_" + id.ToString()];

        if( mozneOdpovede != null ) return mozneOdpovede;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.mozne_odpovede WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 mozneOdpovede = new MozneOdpovede();

                 mozneOdpovede.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["MozneOdpovede_" + id.ToString()] = mozneOdpovede;
             }

             odbcConnection.Close();
        }

        return mozneOdpovede;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.mozne_odpovede", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( MozneOdpovede mozneOdpovede )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.mozne_odpovede SET " +
                "text = ?, otazka_id = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = mozneOdpovede.Text;
             odbcCommand.Parameters.Add("@otazka_id", OdbcType.Int).Value = mozneOdpovede.OtazkaId;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = mozneOdpovede.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["MozneOdpovede_" + mozneOdpovede.Id.ToString()] = mozneOdpovede;

             odbcConnection.Close();
        }
    }
}
