using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class ObmedzenieDAL
{
    public static void Delete( Obmedzenie obmedzenie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.obmedzenie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = obmedzenie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Obmedzenie_" + obmedzenie.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Obmedzenie obmedzenie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.obmedzenie( " +
                "typ_osoby_id, operacia_id, objekt_obmedzenia ) " +
                "VALUES (?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ_osoby_id", OdbcType.Int).Value = obmedzenie.TypOsobyId;
             odbcCommand.Parameters.Add("@operacia_id", OdbcType.Int).Value = obmedzenie.OperaciaId;
             odbcCommand.Parameters.Add("@objekt_obmedzenia", OdbcType.Int).Value = obmedzenie.ObjektObmedzenia;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Obmedzenie> Select()
    {
        List<Obmedzenie> obmedzenieList = new List<Obmedzenie>();
        Obmedzenie obmedzenie;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.obmedzenie", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     obmedzenie = (Obmedzenie)HttpContext.Current.Cache["Obmedzenie_" + id.ToString()];

                     if( obmedzenie == null )
                     {
                         obmedzenie = new Obmedzenie();

                         obmedzenie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Obmedzenie_" + id.ToString()] = obmedzenie;
                     }

                     obmedzenieList.Add( obmedzenie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return obmedzenieList;
    }

    public static Obmedzenie SelectById( int id )
    {
        Obmedzenie obmedzenie = (Obmedzenie)HttpContext.Current.Cache["Obmedzenie_" + id.ToString()];

        if( obmedzenie != null ) return obmedzenie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.obmedzenie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 obmedzenie = new Obmedzenie();

                 obmedzenie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Obmedzenie_" + id.ToString()] = obmedzenie;
             }

             odbcConnection.Close();
        }

        return obmedzenie;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.obmedzenie", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Obmedzenie obmedzenie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.obmedzenie SET " +
                "typ_osoby_id = ?, operacia_id = ?, objekt_obmedzenia = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ_osoby_id", OdbcType.Int).Value = obmedzenie.TypOsobyId;
             odbcCommand.Parameters.Add("@operacia_id", OdbcType.Int).Value = obmedzenie.OperaciaId;
             odbcCommand.Parameters.Add("@objekt_obmedzenia", OdbcType.Int).Value = obmedzenie.ObjektObmedzenia;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = obmedzenie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Obmedzenie_" + obmedzenie.Id.ToString()] = obmedzenie;

             odbcConnection.Close();
        }
    }
}
