using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class OdpovedDAL
{
    public static void Delete( Odpoved odpoved )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.odpoved WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = odpoved.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Odpoved_" + odpoved.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Odpoved odpoved )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.odpoved( " +
                "instancia_ankety_id, osoba_id, otazka_id, text_odpovede ) " +
                "VALUES (?, ?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@instancia_ankety_id", OdbcType.Int).Value = odpoved.InstanciaAnketyId;
             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = odpoved.OsobaId;
             odbcCommand.Parameters.Add("@otazka_id", OdbcType.Int).Value = odpoved.OtazkaId;
             odbcCommand.Parameters.Add("@text_odpovede", OdbcType.NText).Value = odpoved.TextOdpovede;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Odpoved> Select()
    {
        List<Odpoved> odpovedList = new List<Odpoved>();
        Odpoved odpoved;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.odpoved", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     odpoved = (Odpoved)HttpContext.Current.Cache["Odpoved_" + id.ToString()];

                     if( odpoved == null )
                     {
                         odpoved = new Odpoved();

                         odpoved.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Odpoved_" + id.ToString()] = odpoved;
                     }

                     odpovedList.Add( odpoved );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return odpovedList;
    }

    public static Odpoved SelectById( int id )
    {
        Odpoved odpoved = (Odpoved)HttpContext.Current.Cache["Odpoved_" + id.ToString()];

        if( odpoved != null ) return odpoved;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.odpoved WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 odpoved = new Odpoved();

                 odpoved.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Odpoved_" + id.ToString()] = odpoved;
             }

             odbcConnection.Close();
        }

        return odpoved;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.odpoved", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Odpoved odpoved )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.odpoved SET " +
                "instancia_ankety_id = ?, osoba_id = ?, otazka_id = ?, text_odpovede = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@instancia_ankety_id", OdbcType.Int).Value = odpoved.InstanciaAnketyId;
             odbcCommand.Parameters.Add("@osoba_id", OdbcType.Int).Value = odpoved.OsobaId;
             odbcCommand.Parameters.Add("@otazka_id", OdbcType.Int).Value = odpoved.OtazkaId;
             odbcCommand.Parameters.Add("@text_odpovede", OdbcType.NText).Value = odpoved.TextOdpovede;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = odpoved.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Odpoved_" + odpoved.Id.ToString()] = odpoved;

             odbcConnection.Close();
        }
    }
}
