using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class OdvetvieDAL
{
    public static void Delete( Odvetvie odvetvie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.odvetvie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = odvetvie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Odvetvie_" + odvetvie.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Odvetvie odvetvie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.odvetvie( " +
                "nazov ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = odvetvie.Nazov;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Odvetvie> Select()
    {
        List<Odvetvie> odvetvieList = new List<Odvetvie>();
        Odvetvie odvetvie;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.odvetvie", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     odvetvie = (Odvetvie)HttpContext.Current.Cache["Odvetvie_" + id.ToString()];

                     if( odvetvie == null )
                     {
                         odvetvie = new Odvetvie();

                         odvetvie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Odvetvie_" + id.ToString()] = odvetvie;
                     }

                     odvetvieList.Add( odvetvie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return odvetvieList;
    }

    public static Odvetvie SelectById( int id )
    {
        Odvetvie odvetvie = (Odvetvie)HttpContext.Current.Cache["Odvetvie_" + id.ToString()];

        if( odvetvie != null ) return odvetvie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.odvetvie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 odvetvie = new Odvetvie();

                 odvetvie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Odvetvie_" + id.ToString()] = odvetvie;
             }

             odbcConnection.Close();
        }

        return odvetvie;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.odvetvie", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Odvetvie odvetvie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.odvetvie SET " +
                "nazov = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = odvetvie.Nazov;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = odvetvie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Odvetvie_" + odvetvie.Id.ToString()] = odvetvie;

             odbcConnection.Close();
        }
    }
}
