using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class OperaciaDAL
{
    public static void Delete( Operacia operacia )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.operacia WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = operacia.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Operacia_" + operacia.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Operacia operacia )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.operacia( " +
                "nazov ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = operacia.Nazov;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Operacia> Select()
    {
        List<Operacia> operaciaList = new List<Operacia>();
        Operacia operacia;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.operacia", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     operacia = (Operacia)HttpContext.Current.Cache["Operacia_" + id.ToString()];

                     if( operacia == null )
                     {
                         operacia = new Operacia();

                         operacia.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Operacia_" + id.ToString()] = operacia;
                     }

                     operaciaList.Add( operacia );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return operaciaList;
    }

    public static Operacia SelectById( int id )
    {
        Operacia operacia = (Operacia)HttpContext.Current.Cache["Operacia_" + id.ToString()];

        if( operacia != null ) return operacia;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.operacia WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 operacia = new Operacia();

                 operacia.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Operacia_" + id.ToString()] = operacia;
             }

             odbcConnection.Close();
        }

        return operacia;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.operacia", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Operacia operacia )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.operacia SET " +
                "nazov = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = operacia.Nazov;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = operacia.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Operacia_" + operacia.Id.ToString()] = operacia;

             odbcConnection.Close();
        }
    }
}
