using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class OsobaDAL
{
    public static void Delete( Osoba osoba )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.osoba WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = osoba.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Osoba_" + osoba.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Osoba osoba )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.osoba( " +
                "typ_osoby_id, konto, konto_aktivne, heslo, posledne_prihlasenie, " +
                "posledna_ip, meno, tituly, priezvisko, rodne_priezvisko, statna_prislusnost, " +
                "materinsky_jazyk, telefon, mobil, fax, msn, email, web, pohlavie, " +
                "datum_narodenia, rok_absolvovania, zivotopis_ine, icq, skype, socialne_zrucnosti, " +
                "organizacne_zrucnosti, technicke_zrucnosti, pocitacove_zrucnosti, " +
                "umelecke_zrucnosti, dalsie_zrucnosti, vodicsky_preukaz ) " +
                "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ_osoby_id", OdbcType.Int).Value = osoba.TypOsobyId;
             odbcCommand.Parameters.Add("@konto", OdbcType.NVarChar).Value = osoba.Konto;
             odbcCommand.Parameters.Add("@konto_aktivne", OdbcType.Char).Value = osoba.KontoAktivne;
             odbcCommand.Parameters.Add("@heslo", OdbcType.NText).Value = osoba.Heslo;
             odbcCommand.Parameters.Add("@posledne_prihlasenie", OdbcType.DateTime).Value = ( osoba.PoslednePrihlasenie == null ? null : osoba.PoslednePrihlasenie );
             odbcCommand.Parameters.Add("@posledna_ip", OdbcType.NVarChar).Value = ( osoba.PoslednaIp == null ? null : osoba.PoslednaIp );
             odbcCommand.Parameters.Add("@meno", OdbcType.NVarChar).Value = osoba.Meno;
             odbcCommand.Parameters.Add("@tituly", OdbcType.NVarChar).Value = ( osoba.Tituly == null ? null : osoba.Tituly );
             odbcCommand.Parameters.Add("@priezvisko", OdbcType.NVarChar).Value = osoba.Priezvisko;
             odbcCommand.Parameters.Add("@rodne_priezvisko", OdbcType.NVarChar).Value = ( osoba.RodnePriezvisko == null ? null : osoba.RodnePriezvisko );
             odbcCommand.Parameters.Add("@statna_prislusnost", OdbcType.NVarChar).Value = ( osoba.StatnaPrislusnost == null ? null : osoba.StatnaPrislusnost );
             odbcCommand.Parameters.Add("@materinsky_jazyk", OdbcType.NVarChar).Value = ( osoba.MaterinskyJazyk == null ? null : osoba.MaterinskyJazyk );
             odbcCommand.Parameters.Add("@telefon", OdbcType.NVarChar).Value = ( osoba.Telefon == null ? null : osoba.Telefon );
             odbcCommand.Parameters.Add("@mobil", OdbcType.NVarChar).Value = ( osoba.Mobil == null ? null : osoba.Mobil );
             odbcCommand.Parameters.Add("@fax", OdbcType.NVarChar).Value = ( osoba.Fax == null ? null : osoba.Fax );
             odbcCommand.Parameters.Add("@msn", OdbcType.NVarChar).Value = ( osoba.Msn == null ? null : osoba.Msn );
             odbcCommand.Parameters.Add("@email", OdbcType.NVarChar).Value = osoba.Email;
             odbcCommand.Parameters.Add("@web", OdbcType.NText).Value = ( osoba.Web == null ? null : osoba.Web );
             odbcCommand.Parameters.Add("@pohlavie", OdbcType.NVarChar).Value = ( osoba.Pohlavie == null ? null : osoba.Pohlavie );
             odbcCommand.Parameters.Add("@datum_narodenia", OdbcType.Date).Value = osoba.DatumNarodenia;
             odbcCommand.Parameters.Add("@rok_absolvovania", OdbcType.Int).Value = ( osoba.RokAbsolvovania == null ? null : osoba.RokAbsolvovania );
             odbcCommand.Parameters.Add("@zivotopis_ine", OdbcType.NText).Value = ( osoba.ZivotopisIne == null ? null : osoba.ZivotopisIne );
             odbcCommand.Parameters.Add("@icq", OdbcType.NVarChar).Value = ( osoba.Icq == null ? null : osoba.Icq );
             odbcCommand.Parameters.Add("@skype", OdbcType.NText).Value = ( osoba.Skype == null ? null : osoba.Skype );
             odbcCommand.Parameters.Add("@socialne_zrucnosti", OdbcType.NText).Value = ( osoba.SocialneZrucnosti == null ? null : osoba.SocialneZrucnosti );
             odbcCommand.Parameters.Add("@organizacne_zrucnosti", OdbcType.NText).Value = ( osoba.OrganizacneZrucnosti == null ? null : osoba.OrganizacneZrucnosti );
             odbcCommand.Parameters.Add("@technicke_zrucnosti", OdbcType.NText).Value = ( osoba.TechnickeZrucnosti == null ? null : osoba.TechnickeZrucnosti );
             odbcCommand.Parameters.Add("@pocitacove_zrucnosti", OdbcType.NText).Value = ( osoba.PocitacoveZrucnosti == null ? null : osoba.PocitacoveZrucnosti );
             odbcCommand.Parameters.Add("@umelecke_zrucnosti", OdbcType.NText).Value = ( osoba.UmeleckeZrucnosti == null ? null : osoba.UmeleckeZrucnosti );
             odbcCommand.Parameters.Add("@dalsie_zrucnosti", OdbcType.NText).Value = ( osoba.DalsieZrucnosti == null ? null : osoba.DalsieZrucnosti );
             odbcCommand.Parameters.Add("@vodicsky_preukaz", OdbcType.NVarChar).Value = ( osoba.VodicskyPreukaz == null ? null : osoba.VodicskyPreukaz );

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Osoba> Select()
    {
        List<Osoba> osobaList = new List<Osoba>();
        Osoba osoba;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.osoba", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     osoba = (Osoba)HttpContext.Current.Cache["Osoba_" + id.ToString()];

                     if( osoba == null )
                     {
                         osoba = new Osoba();

                         osoba.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Osoba_" + id.ToString()] = osoba;
                     }

                     osobaList.Add( osoba );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return osobaList;
    }

    public static Osoba SelectById( int id )
    {
        Osoba osoba = (Osoba)HttpContext.Current.Cache["Osoba_" + id.ToString()];

        if( osoba != null ) return osoba;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.osoba WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 osoba = new Osoba();

                 osoba.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Osoba_" + id.ToString()] = osoba;
             }

             odbcConnection.Close();
        }

        return osoba;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.osoba", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Osoba osoba )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.osoba SET " +
                "typ_osoby_id = ?, konto = ?, konto_aktivne = ?, heslo = ?, posledne_prihlasenie = ?, " +
                "posledna_ip = ?, meno = ?, tituly = ?, priezvisko = ?, rodne_priezvisko = ?, " +
                "statna_prislusnost = ?, materinsky_jazyk = ?, telefon = ?, mobil = ?, " +
                "fax = ?, msn = ?, email = ?, web = ?, pohlavie = ?, datum_narodenia = ?, " +
                "rok_absolvovania = ?, zivotopis_ine = ?, icq = ?, skype = ?, socialne_zrucnosti = ?, " +
                "organizacne_zrucnosti = ?, technicke_zrucnosti = ?, pocitacove_zrucnosti = ?, " +
                "umelecke_zrucnosti = ?, dalsie_zrucnosti = ?, vodicsky_preukaz = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ_osoby_id", OdbcType.Int).Value = osoba.TypOsobyId;
             odbcCommand.Parameters.Add("@konto", OdbcType.NVarChar).Value = osoba.Konto;
             odbcCommand.Parameters.Add("@konto_aktivne", OdbcType.Char).Value = osoba.KontoAktivne;
             odbcCommand.Parameters.Add("@heslo", OdbcType.NText).Value = osoba.Heslo;
             odbcCommand.Parameters.Add("@posledne_prihlasenie", OdbcType.DateTime).Value = ( osoba.PoslednePrihlasenie == null ? null : osoba.PoslednePrihlasenie );
             odbcCommand.Parameters.Add("@posledna_ip", OdbcType.NVarChar).Value = ( osoba.PoslednaIp == null ? null : osoba.PoslednaIp );
             odbcCommand.Parameters.Add("@meno", OdbcType.NVarChar).Value = osoba.Meno;
             odbcCommand.Parameters.Add("@tituly", OdbcType.NVarChar).Value = ( osoba.Tituly == null ? null : osoba.Tituly );
             odbcCommand.Parameters.Add("@priezvisko", OdbcType.NVarChar).Value = osoba.Priezvisko;
             odbcCommand.Parameters.Add("@rodne_priezvisko", OdbcType.NVarChar).Value = ( osoba.RodnePriezvisko == null ? null : osoba.RodnePriezvisko );
             odbcCommand.Parameters.Add("@statna_prislusnost", OdbcType.NVarChar).Value = ( osoba.StatnaPrislusnost == null ? null : osoba.StatnaPrislusnost );
             odbcCommand.Parameters.Add("@materinsky_jazyk", OdbcType.NVarChar).Value = ( osoba.MaterinskyJazyk == null ? null : osoba.MaterinskyJazyk );
             odbcCommand.Parameters.Add("@telefon", OdbcType.NVarChar).Value = ( osoba.Telefon == null ? null : osoba.Telefon );
             odbcCommand.Parameters.Add("@mobil", OdbcType.NVarChar).Value = ( osoba.Mobil == null ? null : osoba.Mobil );
             odbcCommand.Parameters.Add("@fax", OdbcType.NVarChar).Value = ( osoba.Fax == null ? null : osoba.Fax );
             odbcCommand.Parameters.Add("@msn", OdbcType.NVarChar).Value = ( osoba.Msn == null ? null : osoba.Msn );
             odbcCommand.Parameters.Add("@email", OdbcType.NVarChar).Value = osoba.Email;
             odbcCommand.Parameters.Add("@web", OdbcType.NText).Value = ( osoba.Web == null ? null : osoba.Web );
             odbcCommand.Parameters.Add("@pohlavie", OdbcType.NVarChar).Value = ( osoba.Pohlavie == null ? null : osoba.Pohlavie );
             odbcCommand.Parameters.Add("@datum_narodenia", OdbcType.Date).Value = osoba.DatumNarodenia;
             odbcCommand.Parameters.Add("@rok_absolvovania", OdbcType.Int).Value = ( osoba.RokAbsolvovania == null ? null : osoba.RokAbsolvovania );
             odbcCommand.Parameters.Add("@zivotopis_ine", OdbcType.NText).Value = ( osoba.ZivotopisIne == null ? null : osoba.ZivotopisIne );
             odbcCommand.Parameters.Add("@icq", OdbcType.NVarChar).Value = ( osoba.Icq == null ? null : osoba.Icq );
             odbcCommand.Parameters.Add("@skype", OdbcType.NText).Value = ( osoba.Skype == null ? null : osoba.Skype );
             odbcCommand.Parameters.Add("@socialne_zrucnosti", OdbcType.NText).Value = ( osoba.SocialneZrucnosti == null ? null : osoba.SocialneZrucnosti );
             odbcCommand.Parameters.Add("@organizacne_zrucnosti", OdbcType.NText).Value = ( osoba.OrganizacneZrucnosti == null ? null : osoba.OrganizacneZrucnosti );
             odbcCommand.Parameters.Add("@technicke_zrucnosti", OdbcType.NText).Value = ( osoba.TechnickeZrucnosti == null ? null : osoba.TechnickeZrucnosti );
             odbcCommand.Parameters.Add("@pocitacove_zrucnosti", OdbcType.NText).Value = ( osoba.PocitacoveZrucnosti == null ? null : osoba.PocitacoveZrucnosti );
             odbcCommand.Parameters.Add("@umelecke_zrucnosti", OdbcType.NText).Value = ( osoba.UmeleckeZrucnosti == null ? null : osoba.UmeleckeZrucnosti );
             odbcCommand.Parameters.Add("@dalsie_zrucnosti", OdbcType.NText).Value = ( osoba.DalsieZrucnosti == null ? null : osoba.DalsieZrucnosti );
             odbcCommand.Parameters.Add("@vodicsky_preukaz", OdbcType.NVarChar).Value = ( osoba.VodicskyPreukaz == null ? null : osoba.VodicskyPreukaz );
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = osoba.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Osoba_" + osoba.Id.ToString()] = osoba;

             odbcConnection.Close();
        }
    }
}
