using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class OtazkaDAL
{
    public static void Delete( Otazka otazka )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.otazka WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = otazka.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Otazka_" + otazka.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Otazka otazka )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.otazka( " +
                "text_otazky, typ_odpovede, ine, anketa_id ) " +
                "VALUES (?, ?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@text_otazky", OdbcType.NText).Value = otazka.TextOtazky;
             odbcCommand.Parameters.Add("@typ_odpovede", OdbcType.SmallInt).Value = otazka.TypOdpovede;
             odbcCommand.Parameters.Add("@ine", OdbcType.NVarChar).Value = ( otazka.Ine == null ? null : otazka.Ine );
             odbcCommand.Parameters.Add("@anketa_id", OdbcType.Int).Value = otazka.AnketaId;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Otazka> Select()
    {
        List<Otazka> otazkaList = new List<Otazka>();
        Otazka otazka;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.otazka", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     otazka = (Otazka)HttpContext.Current.Cache["Otazka_" + id.ToString()];

                     if( otazka == null )
                     {
                         otazka = new Otazka();

                         otazka.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Otazka_" + id.ToString()] = otazka;
                     }

                     otazkaList.Add( otazka );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return otazkaList;
    }

    public static Otazka SelectById( int id )
    {
        Otazka otazka = (Otazka)HttpContext.Current.Cache["Otazka_" + id.ToString()];

        if( otazka != null ) return otazka;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.otazka WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 otazka = new Otazka();

                 otazka.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Otazka_" + id.ToString()] = otazka;
             }

             odbcConnection.Close();
        }

        return otazka;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.otazka", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Otazka otazka )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.otazka SET " +
                "text_otazky = ?, typ_odpovede = ?, ine = ?, anketa_id = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@text_otazky", OdbcType.NText).Value = otazka.TextOtazky;
             odbcCommand.Parameters.Add("@typ_odpovede", OdbcType.SmallInt).Value = otazka.TypOdpovede;
             odbcCommand.Parameters.Add("@ine", OdbcType.NVarChar).Value = ( otazka.Ine == null ? null : otazka.Ine );
             odbcCommand.Parameters.Add("@anketa_id", OdbcType.Int).Value = otazka.AnketaId;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = otazka.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Otazka_" + otazka.Id.ToString()] = otazka;

             odbcConnection.Close();
        }
    }
}
