using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class PoziciaOdvetvieDAL
{
    public static void Delete( PoziciaOdvetvie poziciaOdvetvie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.pozicia_odvetvie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = poziciaOdvetvie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("PoziciaOdvetvie_" + poziciaOdvetvie.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( PoziciaOdvetvie poziciaOdvetvie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.pozicia_odvetvie( " +
                "pozicia, odvetvie_id ) " +
                "VALUES (?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@pozicia", OdbcType.NVarChar).Value = poziciaOdvetvie.Pozicia;
             odbcCommand.Parameters.Add("@odvetvie_id", OdbcType.Int).Value = poziciaOdvetvie.OdvetvieId;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<PoziciaOdvetvie> Select()
    {
        List<PoziciaOdvetvie> poziciaOdvetvieList = new List<PoziciaOdvetvie>();
        PoziciaOdvetvie poziciaOdvetvie;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.pozicia_odvetvie", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     poziciaOdvetvie = (PoziciaOdvetvie)HttpContext.Current.Cache["PoziciaOdvetvie_" + id.ToString()];

                     if( poziciaOdvetvie == null )
                     {
                         poziciaOdvetvie = new PoziciaOdvetvie();

                         poziciaOdvetvie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["PoziciaOdvetvie_" + id.ToString()] = poziciaOdvetvie;
                     }

                     poziciaOdvetvieList.Add( poziciaOdvetvie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return poziciaOdvetvieList;
    }

    public static PoziciaOdvetvie SelectById( int id )
    {
        PoziciaOdvetvie poziciaOdvetvie = (PoziciaOdvetvie)HttpContext.Current.Cache["PoziciaOdvetvie_" + id.ToString()];

        if( poziciaOdvetvie != null ) return poziciaOdvetvie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.pozicia_odvetvie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 poziciaOdvetvie = new PoziciaOdvetvie();

                 poziciaOdvetvie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["PoziciaOdvetvie_" + id.ToString()] = poziciaOdvetvie;
             }

             odbcConnection.Close();
        }

        return poziciaOdvetvie;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.pozicia_odvetvie", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( PoziciaOdvetvie poziciaOdvetvie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.pozicia_odvetvie SET " +
                "pozicia = ?, odvetvie_id = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@pozicia", OdbcType.NVarChar).Value = poziciaOdvetvie.Pozicia;
             odbcCommand.Parameters.Add("@odvetvie_id", OdbcType.Int).Value = poziciaOdvetvie.OdvetvieId;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = poziciaOdvetvie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["PoziciaOdvetvie_" + poziciaOdvetvie.Id.ToString()] = poziciaOdvetvie;

             odbcConnection.Close();
        }
    }
}
