using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class SkupinovaSpravaDAL
{
    public static void Delete( SkupinovaSprava skupinovaSprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.skupinova_sprava WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = skupinovaSprava.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["SkupinovaSprava_" + skupinovaSprava.Id.ToString()] = null;

             odbcConnection.Close();
        }
    }

    public static void Insert( SkupinovaSprava skupinovaSprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.skupinova_sprava( " +
                "odosielatel_id, prijemca_id, cas, predmet, text, precitana, odosielatel_kos, " +
                "prijemca_kos, odosielatel_zmazana, prijemca_zmazana, notifikovat, " +
                "typ_spravy_id, prijemca_skup ) " +
                "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = skupinovaSprava.OdosielatelId;
             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = skupinovaSprava.PrijemcaId;
             odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = skupinovaSprava.Cas;
             odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = ( skupinovaSprava.Predmet == null ? null : skupinovaSprava.Predmet );
             odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = ( skupinovaSprava.Text == null ? null : skupinovaSprava.Text );
             odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = skupinovaSprava.Precitana;
             odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = skupinovaSprava.OdosielatelKos;
             odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = skupinovaSprava.PrijemcaKos;
             odbcCommand.Parameters.Add("@odosielatel_zmazana", OdbcType.Char).Value = skupinovaSprava.OdosielatelZmazana;
             odbcCommand.Parameters.Add("@prijemca_zmazana", OdbcType.Char).Value = skupinovaSprava.PrijemcaZmazana;
             odbcCommand.Parameters.Add("@notifikovat", OdbcType.Char).Value = skupinovaSprava.Notifikovat;
             odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = skupinovaSprava.TypSpravyId;
             odbcCommand.Parameters.Add("@prijemca_skup", OdbcType.NVarChar).Value = skupinovaSprava.PrijemcaSkup;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<SkupinovaSprava> Select()
    {
        List<SkupinovaSprava> skupinovaSpravaList = new List<SkupinovaSprava>();
        SkupinovaSprava skupinovaSprava;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.skupinova_sprava", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     skupinovaSprava = (SkupinovaSprava)HttpContext.Current.Cache["SkupinovaSprava_" + id.ToString()];

                     if( skupinovaSprava == null )
                     {
                         skupinovaSprava = new SkupinovaSprava();

                         skupinovaSprava.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["SkupinovaSprava_" + id.ToString()] = skupinovaSprava;
                     }

                     skupinovaSpravaList.Add( skupinovaSprava );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return skupinovaSpravaList;
    }

    public static SkupinovaSprava SelectById( int id )
    {
        SkupinovaSprava skupinovaSprava = (SkupinovaSprava)HttpContext.Current.Cache["SkupinovaSprava_" + id.ToString()];

        if( skupinovaSprava != null ) return skupinovaSprava;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.skupinova_sprava WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 skupinovaSprava = new SkupinovaSprava();

                 skupinovaSprava.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["SkupinovaSprava_" + id.ToString()] = skupinovaSprava;
             }

             odbcConnection.Close();
        }

        return skupinovaSprava;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.skupinova_sprava", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( SkupinovaSprava skupinovaSprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.skupinova_sprava SET " +
                "odosielatel_id = ?, prijemca_id = ?, cas = ?, predmet = ?, text = ?, " +
                "precitana = ?, odosielatel_kos = ?, prijemca_kos = ?, odosielatel_zmazana = ?, " +
                "prijemca_zmazana = ?, notifikovat = ?, typ_spravy_id = ?, prijemca_skup = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = skupinovaSprava.OdosielatelId;
             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = skupinovaSprava.PrijemcaId;
             odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = skupinovaSprava.Cas;
             odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = ( skupinovaSprava.Predmet == null ? null : skupinovaSprava.Predmet );
             odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = ( skupinovaSprava.Text == null ? null : skupinovaSprava.Text );
             odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = skupinovaSprava.Precitana;
             odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = skupinovaSprava.OdosielatelKos;
             odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = skupinovaSprava.PrijemcaKos;
             odbcCommand.Parameters.Add("@odosielatel_zmazana", OdbcType.Char).Value = skupinovaSprava.OdosielatelZmazana;
             odbcCommand.Parameters.Add("@prijemca_zmazana", OdbcType.Char).Value = skupinovaSprava.PrijemcaZmazana;
             odbcCommand.Parameters.Add("@notifikovat", OdbcType.Char).Value = skupinovaSprava.Notifikovat;
             odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = skupinovaSprava.TypSpravyId;
             odbcCommand.Parameters.Add("@prijemca_skup", OdbcType.NVarChar).Value = skupinovaSprava.PrijemcaSkup;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = skupinovaSprava.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["SkupinovaSprava_" + skupinovaSprava.Id.ToString()] = skupinovaSprava;

             odbcConnection.Close();
        }
    }
}
