using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class SpravaDAL
{
    public static void Delete( Sprava sprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.sprava WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = sprava.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Sprava_" + sprava.Id.ToString()] = null;

             odbcConnection.Close();
        }
    }

    public static void Insert( Sprava sprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.sprava( " +
                "odosielatel_id, prijemca_id, cas, predmet, text, precitana, odosielatel_kos, " +
                "prijemca_kos, odosielatel_zmazana, prijemca_zmazana, notifikovat, " +
                "typ_spravy_id ) " +
                "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
             odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
             odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = ( sprava.Predmet == null ? null : sprava.Predmet );
             odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = ( sprava.Text == null ? null : sprava.Text );
             odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = sprava.Precitana;
             odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = sprava.OdosielatelKos;
             odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = sprava.PrijemcaKos;
             odbcCommand.Parameters.Add("@odosielatel_zmazana", OdbcType.Char).Value = sprava.OdosielatelZmazana;
             odbcCommand.Parameters.Add("@prijemca_zmazana", OdbcType.Char).Value = sprava.PrijemcaZmazana;
             odbcCommand.Parameters.Add("@notifikovat", OdbcType.Char).Value = sprava.Notifikovat;
             odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = sprava.TypSpravyId;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Sprava> Select()
    {
        List<Sprava> spravaList = new List<Sprava>();
        Sprava sprava;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.sprava", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     sprava = (Sprava)HttpContext.Current.Cache["Sprava_" + id.ToString()];

                     if( sprava == null )
                     {
                         sprava = new Sprava();

                         sprava.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Sprava_" + id.ToString()] = sprava;
                     }

                     spravaList.Add( sprava );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return spravaList;
    }

    public static Sprava SelectById( int id )
    {
        Sprava sprava = (Sprava)HttpContext.Current.Cache["Sprava_" + id.ToString()];

        if( sprava != null ) return sprava;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.sprava WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 sprava = new Sprava();

                 sprava.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Sprava_" + id.ToString()] = sprava;
             }

             odbcConnection.Close();
        }

        return sprava;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.sprava", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Sprava sprava )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.sprava SET " +
                "odosielatel_id = ?, prijemca_id = ?, cas = ?, predmet = ?, text = ?, " +
                "precitana = ?, odosielatel_kos = ?, prijemca_kos = ?, odosielatel_zmazana = ?, " +
                "prijemca_zmazana = ?, notifikovat = ?, typ_spravy_id = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@odosielatel_id", OdbcType.Int).Value = sprava.OdosielatelId;
             odbcCommand.Parameters.Add("@prijemca_id", OdbcType.Int).Value = sprava.PrijemcaId;
             odbcCommand.Parameters.Add("@cas", OdbcType.DateTime).Value = sprava.Cas;
             odbcCommand.Parameters.Add("@predmet", OdbcType.NVarChar).Value = ( sprava.Predmet == null ? null : sprava.Predmet );
             odbcCommand.Parameters.Add("@text", OdbcType.NText).Value = ( sprava.Text == null ? null : sprava.Text );
             odbcCommand.Parameters.Add("@precitana", OdbcType.Char).Value = sprava.Precitana;
             odbcCommand.Parameters.Add("@odosielatel_kos", OdbcType.Char).Value = sprava.OdosielatelKos;
             odbcCommand.Parameters.Add("@prijemca_kos", OdbcType.Char).Value = sprava.PrijemcaKos;
             odbcCommand.Parameters.Add("@odosielatel_zmazana", OdbcType.Char).Value = sprava.OdosielatelZmazana;
             odbcCommand.Parameters.Add("@prijemca_zmazana", OdbcType.Char).Value = sprava.PrijemcaZmazana;
             odbcCommand.Parameters.Add("@notifikovat", OdbcType.Char).Value = sprava.Notifikovat;
             odbcCommand.Parameters.Add("@typ_spravy_id", OdbcType.Int).Value = sprava.TypSpravyId;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = sprava.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Sprava_" + sprava.Id.ToString()] = sprava;

             odbcConnection.Close();
        }
    }
}
