using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class StatDAL
{
    public static void Delete( Stat stat )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.stat WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = stat.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("Stat_" + stat.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( Stat stat )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.stat( " +
                "nazov ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = stat.Nazov;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<Stat> Select()
    {
        List<Stat> statList = new List<Stat>();
        Stat stat;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.stat", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     stat = (Stat)HttpContext.Current.Cache["Stat_" + id.ToString()];

                     if( stat == null )
                     {
                         stat = new Stat();

                         stat.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["Stat_" + id.ToString()] = stat;
                     }

                     statList.Add( stat );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return statList;
    }

    public static Stat SelectById( int id )
    {
        Stat stat = (Stat)HttpContext.Current.Cache["Stat_" + id.ToString()];

        if( stat != null ) return stat;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.stat WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 stat = new Stat();

                 stat.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["Stat_" + id.ToString()] = stat;
             }

             odbcConnection.Close();
        }

        return stat;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.stat", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( Stat stat )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.stat SET " +
                "nazov = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@nazov", OdbcType.NVarChar).Value = stat.Nazov;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = stat.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["Stat_" + stat.Id.ToString()] = stat;

             odbcConnection.Close();
        }
    }
}
