using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class TypOsobyDAL
{
    public static void Delete( TypOsoby typOsoby )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.typ_osoby WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typOsoby.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("TypOsoby_" + typOsoby.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( TypOsoby typOsoby )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.typ_osoby( " +
                "typ ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typOsoby.Typ;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<TypOsoby> Select()
    {
        List<TypOsoby> typOsobyList = new List<TypOsoby>();
        TypOsoby typOsoby;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_osoby", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     typOsoby = (TypOsoby)HttpContext.Current.Cache["TypOsoby_" + id.ToString()];

                     if( typOsoby == null )
                     {
                         typOsoby = new TypOsoby();

                         typOsoby.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["TypOsoby_" + id.ToString()] = typOsoby;
                     }

                     typOsobyList.Add( typOsoby );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return typOsobyList;
    }

    public static TypOsoby SelectById( int id )
    {
        TypOsoby typOsoby = (TypOsoby)HttpContext.Current.Cache["TypOsoby_" + id.ToString()];

        if( typOsoby != null ) return typOsoby;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_osoby WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 typOsoby = new TypOsoby();

                 typOsoby.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["TypOsoby_" + id.ToString()] = typOsoby;
             }

             odbcConnection.Close();
        }

        return typOsoby;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.typ_osoby", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( TypOsoby typOsoby )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.typ_osoby SET " +
                "typ = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typOsoby.Typ;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typOsoby.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["TypOsoby_" + typOsoby.Id.ToString()] = typOsoby;

             odbcConnection.Close();
        }
    }
}
