using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class TypOznamuDAL
{
    public static void Delete( TypOznamu typOznamu )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.typ_oznamu WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typOznamu.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("TypOznamu_" + typOznamu.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( TypOznamu typOznamu )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.typ_oznamu( " +
                "typ ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typOznamu.Typ;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<TypOznamu> Select()
    {
        List<TypOznamu> typOznamuList = new List<TypOznamu>();
        TypOznamu typOznamu;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_oznamu", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     typOznamu = (TypOznamu)HttpContext.Current.Cache["TypOznamu_" + id.ToString()];

                     if( typOznamu == null )
                     {
                         typOznamu = new TypOznamu();

                         typOznamu.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["TypOznamu_" + id.ToString()] = typOznamu;
                     }

                     typOznamuList.Add( typOznamu );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return typOznamuList;
    }

    public static TypOznamu SelectById( int id )
    {
        TypOznamu typOznamu = (TypOznamu)HttpContext.Current.Cache["TypOznamu_" + id.ToString()];

        if( typOznamu != null ) return typOznamu;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_oznamu WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 typOznamu = new TypOznamu();

                 typOznamu.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["TypOznamu_" + id.ToString()] = typOznamu;
             }

             odbcConnection.Close();
        }

        return typOznamu;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.typ_oznamu", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( TypOznamu typOznamu )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.typ_oznamu SET " +
                "typ = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typOznamu.Typ;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typOznamu.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["TypOznamu_" + typOznamu.Id.ToString()] = typOznamu;

             odbcConnection.Close();
        }
    }
}
