using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class TypRegistracieDAL
{
    public static void Delete( TypRegistracie typRegistracie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.typ_registracie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typRegistracie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache.Remove("TypRegistracie_" + typRegistracie.Id.ToString());

             odbcConnection.Close();
        }
    }

    public static void Insert( TypRegistracie typRegistracie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.typ_registracie( " +
                "typ ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typRegistracie.Typ;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<TypRegistracie> Select()
    {
        List<TypRegistracie> typRegistracieList = new List<TypRegistracie>();
        TypRegistracie typRegistracie;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_registracie", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     typRegistracie = (TypRegistracie)HttpContext.Current.Cache["TypRegistracie_" + id.ToString()];

                     if( typRegistracie == null )
                     {
                         typRegistracie = new TypRegistracie();

                         typRegistracie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["TypRegistracie_" + id.ToString()] = typRegistracie;
                     }

                     typRegistracieList.Add( typRegistracie );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return typRegistracieList;
    }

    public static TypRegistracie SelectById( int id )
    {
        TypRegistracie typRegistracie = (TypRegistracie)HttpContext.Current.Cache["TypRegistracie_" + id.ToString()];

        if( typRegistracie != null ) return typRegistracie;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_registracie WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 typRegistracie = new TypRegistracie();

                 typRegistracie.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["TypRegistracie_" + id.ToString()] = typRegistracie;
             }

             odbcConnection.Close();
        }

        return typRegistracie;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.typ_registracie", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( TypRegistracie typRegistracie )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.typ_registracie SET " +
                "typ = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typRegistracie.Typ;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typRegistracie.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["TypRegistracie_" + typRegistracie.Id.ToString()] = typRegistracie;

             odbcConnection.Close();
        }
    }
}
