using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections.Generic;
using System.Web;
using System.Web.Caching;

public partial class TypSpravyDAL
{
    public static void Delete( TypSpravy typSpravy )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "DELETE FROM alumni.typ_spravy WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typSpravy.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["TypSpravy_" + typSpravy.Id.ToString()] = null;

             odbcConnection.Close();
        }
    }

    public static void Insert( TypSpravy typSpravy )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "INSERT INTO alumni.typ_spravy( " +
                "typ ) " +
                "VALUES (?)", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typSpravy.Typ;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             odbcConnection.Close();
        }
    }

    public static List<TypSpravy> Select()
    {
        List<TypSpravy> typSpravyList = new List<TypSpravy>();
        TypSpravy typSpravy;
        int id;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_spravy", odbcConnection );

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 while ( odbcDataReader.Read() )
                 {
                     id = odbcDataReader.GetInt32(0);

                     typSpravy = (TypSpravy)HttpContext.Current.Cache["TypSpravy_" + id.ToString()];

                     if( typSpravy == null )
                     {
                         typSpravy = new TypSpravy();

                         typSpravy.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                         HttpContext.Current.Cache["TypSpravy_" + id.ToString()] = typSpravy;
                     }

                     typSpravyList.Add( typSpravy );
                 }

                 odbcDataReader.Close();
             }

             odbcConnection.Close();
        }

        return typSpravyList;
    }

    public static TypSpravy SelectById( int id )
    {
        TypSpravy typSpravy = (TypSpravy)HttpContext.Current.Cache["TypSpravy_" + id.ToString()];

        if( typSpravy != null ) return typSpravy;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT * FROM alumni.typ_spravy WHERE id = ?", odbcConnection );

             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = id;

             odbcConnection.Open();

             using ( OdbcDataReader odbcDataReader = odbcCommand.ExecuteReader() )
             {
                 if( !odbcDataReader.Read() )
                 {
                     odbcDataReader.Close();
                     odbcConnection.Close();

                     return null;
                 }

                 typSpravy = new TypSpravy();

                 typSpravy.ValuesFromReader( odbcDataReader.GetInt32(0), odbcDataReader );

                 odbcDataReader.Close();

                 HttpContext.Current.Cache["TypSpravy_" + id.ToString()] = typSpravy;
             }

             odbcConnection.Close();
        }

        return typSpravy;
    }

    public static int SelectCount()
    {
        int rowCount;

        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "SELECT COUNT(*) FROM alumni.typ_spravy", odbcConnection );

             odbcConnection.Open();

             rowCount = Convert.ToInt32( odbcCommand.ExecuteScalar() );

             odbcConnection.Close();
        }

        return rowCount;
    }

    public static void Update( TypSpravy typSpravy )
    {
        using ( OdbcConnection odbcConnection = new OdbcConnection( ConfigurationManager.ConnectionStrings["alumni"].ConnectionString ) )
        {
             OdbcCommand odbcCommand = new OdbcCommand( "UPDATE alumni.typ_spravy SET " +
                "typ = ? " +
                "WHERE id = ?", odbcConnection
             );

             odbcCommand.Parameters.Add("@typ", OdbcType.NVarChar).Value = typSpravy.Typ;
             odbcCommand.Parameters.Add("@id", OdbcType.Int).Value = typSpravy.Id;

             odbcConnection.Open();

             odbcCommand.ExecuteNonQuery();

             HttpContext.Current.Cache["TypSpravy_" + typSpravy.Id.ToString()] = typSpravy;

             odbcConnection.Close();
        }
    }
}
