using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using System.Collections;

public class Helper
{
    public static string ConvertEmail( string email )
    {
        string[] emailParts = email.Split(new char[] { '@' });

        emailParts[1] = emailParts[1].ToLower();

        return emailParts[0] + "@" + emailParts[1];
    }

    public static int QStringToInt32( string queryString )
    {
        if( queryString == null ) return 0;

        int number;

        try
        {
            number = Convert.ToInt32( queryString );
        }
        catch( FormatException )
        {
            return 0;
        }

        return number;
    }

    public static List<KeyValuePair<string, AnswerStat[]>> SurveyStats( int instanciaId )
    {
        InstanciaAnkety instanciaAnkety = InstanciaAnketyDAL.SelectById( instanciaId );
        
        if( instanciaAnkety == null ) return null;

        //if( DateTime.Now < instanciaAnkety.DatumDo ) return null;

        List<KeyValuePair<string, AnswerStat[]>> resultsList = new List<KeyValuePair<string, AnswerStat[]>>();

        List<Otazka> otazkaList = OtazkaDAL.SelectByAnketaId( instanciaAnkety.AnketaId );
        otazkaList.Sort( new ObjectComparer<Otazka>( "Id", "ASC" ) );

        List<MozneOdpovede> mozneOdpovedeList;
        AnswerStat[] answerStatArray;
        int index = 0;
        string[] odpovede;
        List<Odpoved> odpovedList;

        foreach( Otazka otazka in otazkaList )
        {
            mozneOdpovedeList = MozneOdpovedeDAL.SelectByOtazkaId( otazka.Id );

            if( otazka.Ine == string.Empty ) 
            {
                if( otazka.TypOdpovede == 0 || otazka.TypOdpovede == 1 ) 
                {
                    answerStatArray =  new AnswerStat[mozneOdpovedeList.Count + 1];

                    for( int i = 0; i < mozneOdpovedeList.Count; i++ ) answerStatArray[i] = new AnswerStat( mozneOdpovedeList[i].Text );

                    answerStatArray [mozneOdpovedeList.Count] = new AnswerStat( string.Empty );
                }
                else answerStatArray = null;
            }
            else
            {
                if( otazka.TypOdpovede == 0 || otazka.TypOdpovede == 1 ) 
                {
                    answerStatArray = new AnswerStat[mozneOdpovedeList.Count + 2];

                    for( int i = 0; i < mozneOdpovedeList.Count; i++ ) answerStatArray[i] = new AnswerStat( mozneOdpovedeList[i].Text );

                    answerStatArray[mozneOdpovedeList.Count] = new AnswerStat( otazka.Ine );
                    answerStatArray[mozneOdpovedeList.Count + 1] = new AnswerStat( string.Empty );
                }
                else answerStatArray = null;
            }

            if( answerStatArray != null ) 
            {
                odpovedList = OdpovedDAL.SelectByInstanciaIdOtazkaId( instanciaId, otazka.Id );
                answerStatArray[answerStatArray.Length - 1].Count = odpovedList.Count;

                foreach( Odpoved odpoved in odpovedList )
                {
                    odpovede = odpoved.TextOdpovede.Split( new char[] { '\n' }, StringSplitOptions.RemoveEmptyEntries );

                    for( int i = 0; i < odpovede.Length; i++ )
                    {
                        if ( Int32.TryParse( odpovede[i], out index ) == true ) answerStatArray[index].Count++;
                    }
                }
            }

            resultsList.Add( new KeyValuePair<string,AnswerStat[]>( otazka.TextOtazky, answerStatArray ) );
        }

        return resultsList;
    }
public static int[] stringComaSepNumberToArray(string str)
    {
        List<int> ls = new List<int>();
        String[] strs = str.Split(',');

        for (int i = 0; i < strs.Length; i++)
        {
            try
            {
                int n = Convert.ToInt32(strs[i]);
                ls.Add(n);
            }
            catch (System.FormatException sf)
            {

            }

        }
        return ls.ToArray();
    }

    public static String intArrayToComaSepString(int[] ar)
    {
        System.Text.StringBuilder str = new System.Text.StringBuilder();
        for (int i = 0; i < ar.Length; i++)
        {
            if (i == 0) str.Append(ar[i].ToString());
            else str.Append("," + ar[i].ToString());

        }
        return str.ToString();
    }

    public static Dictionary<string, string> stringComaSepNumberToHashTable(string str)
    {
        Dictionary<string, string> ds = new Dictionary<string, string>();
        String[] strs = str.Split(',');
        for (int i = 0; i < strs.Length; i++)
        {
            try
            {
                int n = Convert.ToInt32(strs[i]);
                ds.Add(strs[i], strs[i]);
            }
            catch (System.FormatException sf)
            {

            }

        }
        //  return ls.ToArray();
        return ds;
    }

    public static string enkodovatZobaciky(string text)
    {
        text = text.Replace("<", "&lt;");
        text = text.Replace(">", "&gt;");
        return text;
    }

    public static string cutText(string text, int charCount, string end)
    {
        string str = text;
        if (str.Length > charCount)
        {
            //        lb.ToolTip = lb.Text;
            //       lb.Text = lb.Text.Substring(0, 5 - 3) + "...";
            str = str.Substring(0, charCount - end.Length) + end;
        }
        return str;
    }

    public static string wrapText(string text, int charCount)
    {
        string st2 = text;
        CharEnumerator che = st2.GetEnumerator();
        che.Reset();
        int length = 0;
        int i = 0;
        while (che.MoveNext())
        {
            Char c = che.Current;
            if (Char.IsWhiteSpace(c))
            {
                length = 0;

            }
            else
            {
                length++;
                if (length > charCount)
                {
                    st2 = st2.Insert(i, "- ");
                    length = 0;
                }

            }
            i++;

        }
        return st2;
    }

}
