using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using eu.europass;
using System.Reflection;
using System.Collections;
using Europass;
using System.Xml.Serialization;
using System.Xml;
using System.Xml.Schema;
using System.IO;
using System.Collections.Generic;

/// <summary>
/// Summary description for webservice
/// </summary>
public class webservice
{
    private string documentLanguage;

    public string DocumentLanguage
    {
        get { return documentLanguage; }
        set { documentLanguage = value; }
    }
    private string documentFormat;

    public string DocumentFormat
    {
        get { return documentFormat; }
        set { documentFormat = value; }
    }

    private string aplikacia;

    public string Aplikacia
    {
        get { return aplikacia; }
        set { aplikacia = value; }
    }

	public webservice()
	{
		
	}

    public preferencesField createPreferencesField(string name, bool keep)
    {
        preferencesField newPreferencesField = new preferencesField();
        newPreferencesField.name = name;
        newPreferencesField.keep = keep;
        newPreferencesField.keepSpecified = true;
        return newPreferencesField;        
    }    

    public preferencesField createPreferencesField(string name, string before)
    {
        preferencesField newPreferencesField = new preferencesField();
        newPreferencesField.name = name;
        newPreferencesField.before = before;
        return newPreferencesField;
    }

    public preferencesField createPreferencesField(string name, bool keep, string format)
    {
        preferencesField newPreferencesField = new preferencesField();
        newPreferencesField.name = name;
        newPreferencesField.keep = keep;
        newPreferencesField.format = format;
        newPreferencesField.keepSpecified = true;
        return newPreferencesField;
    }

    private identification GetIdentification(Osoba osoba, ArrayList list)
    {
        identification identification_object = new identification();
        list.Add(createPreferencesField("step1.lastName", "step1.firstName"));
        identification_object.firstname = osoba.Meno;
        identification_object.lastname = osoba.Priezvisko;
        identification_object.demographics = GetDemographics(osoba, list);
        identification_object.contactinfo = GetContactInfo(osoba, list);
        return identification_object;
    }

    private contactinfo GetContactInfo(Osoba osoba, ArrayList list)
    {
        contactinfo contactinfo_object = new contactinfo();

        if (osoba.Telefon != string.Empty && osoba.Telefon != null)
        {
            list.Add(createPreferencesField("step1.telephone", true));
            contactinfo_object.telephone = osoba.Telefon;
        }
        else
        {
            list.Add(createPreferencesField("step1.telephone", false));
            contactinfo_object.telephone = string.Empty;
        }

        list.Add(createPreferencesField("step1.email", true));
        contactinfo_object.email = osoba.Email;

        if (osoba.Mobil != string.Empty && osoba.Mobil != null)
        {
            list.Add(createPreferencesField("step1.mobile", true));
            contactinfo_object.mobile = osoba.Mobil;
        }
        else
        {
            list.Add(createPreferencesField("step1.mobile", false));
            contactinfo_object.mobile = string.Empty;
        }

        if (osoba.Fax != string.Empty && osoba.Fax != null)
        {
            list.Add(createPreferencesField("step1.fax", true));
            contactinfo_object.fax = osoba.Fax;
        }
        else
        {
            list.Add(createPreferencesField("step1.fax", true));
            contactinfo_object.fax = string.Empty;
        }

        if (osoba.Web != string.Empty && osoba.Web != null)
        {
            //list.Add(createPreferencesField("step7.web", true));
            contactinfo_object.web = osoba.Web;
        }
        else
        {
 
        }

        addressInfo addressInfo_object = GetAddressInfo(osoba, list);
        if (addressInfo_object != null)
        {
            contactinfo_object.address = addressInfo_object;
        }

        return contactinfo_object;
    }

    private demographics GetDemographics(Osoba osoba,ArrayList list)
    {
        demographics demographics_object = new demographics();
        if (osoba.StatnaPrislusnost != null)
        {
            list.Add(createPreferencesField("step1.nationality", true));
            country[] krajiny = new country[1];
            country stat = new country();
            stat.label = osoba.StatnaPrislusnost;
            //stat.code = "SK";
            krajiny[0] = stat;
            demographics_object.nationality = krajiny;
        }
        else
        {
            list.Add(createPreferencesField("step1.nationality", false));
        }

        if (osoba.DatumNarodenia != null)
        {
            list.Add(createPreferencesField("step1.birthDate", true, "/numeric/long"));
            demographics_object.birthdate = osoba.DatumNarodenia;
            demographics_object.birthdateSpecified = true;
        }
        else
        {
            list.Add(createPreferencesField("step1.birthDate", false, "/numeric/long"));
        }

        if (osoba.Pohlavie != null)
        {
            list.Add(createPreferencesField("step1.gender", true));
            demographics_object.gender = demographicsGender.M;
            demographics_object.genderSpecified = true;
        }
        else
        {
            list.Add(createPreferencesField("step1.gender", false));
        }
        return demographics_object;
    }

    private addressInfo GetAddressInfo(Osoba osoba, ArrayList list)
    {
        Adresa adresa = new Adresa();
        adresa = AdresaDAL.SelectByOsobaId(osoba.Id);
        addressInfo addressInfo_object;
        if (adresa != null)
        {
            list.Add(createPreferencesField("step1.addressInfo", true));
            Stat stat = new Stat();
            stat = StatDAL.SelectById(osoba.Id);
            addressInfo_object = new addressInfo();
            country country_object = new country();
            country_object.label = stat.Nazov;
            country_object.code = "SK";
            addressInfo_object.country = country_object;
            addressInfo_object.postalCode = adresa.Psc;
            string[] adresaInformacie = new string[1];
            adresaInformacie[0] = adresa.Ulica + ", " + adresa.Mesto;
            //adresaInformacie[1] = adresa.Mesto;
            addressInfo_object.addressLine = adresaInformacie;
            addressInfo_object.municipality = "municipality";            
        }
        else
        {
            list.Add(createPreferencesField("step1.addressInfo", false));
            addressInfo_object = new addressInfo();           
        }
        return addressInfo_object;
    }    

    private docinfo GetDocInfo(DateTime issuedate, string comment, string xsdversion)
    {
        docinfo docinfo_object = new docinfo();
        docinfo_object.issuedate = issuedate;
        docinfo_object.comment = comment;
        docinfo_object.xsdversion = xsdversion;
        return docinfo_object;
    }

    private workexperience[] GetWorkerExprienceList(Osoba osoba, ArrayList list)
    {
        ArrayList workexperience_list = new ArrayList();
        List<Zamestnanie> zamestnania = ZamestnanieDAL.SelectByOsobaId(osoba.Id);
        int index = 0;

        foreach (Zamestnanie zamestnanie in zamestnania)
        {
            if(index == 0) list.Add(createPreferencesField("step3List", "step4List"));

            workexperience workexperience_object = new workexperience();

            workexperience_object.activities = zamestnanie.Poznamka;
            list.Add(createPreferencesField("step3List[" + index.ToString() + "].activities", zamestnanie.Poznamka != string.Empty));

            workexperience_object.employer = zamestnanie.NazovFirmy;
            list.Add(createPreferencesField("step3List[" + index.ToString() + "].employer", true));

            workexperience_object.position = PoziciaOdvetvieDAL.SelectById(zamestnanie.PoziciaOdvetvieId.Value).Pozicia;
            list.Add(createPreferencesField("step3List[" + index.ToString() + "].position", true));

            workexperience_object.sector = OdvetvieDAL.SelectById(PoziciaOdvetvieDAL.SelectById(zamestnanie.PoziciaOdvetvieId.Value).OdvetvieId).Nazov;
            list.Add(createPreferencesField("step3List[" + index.ToString() + "].sector", true));

            workexperience_object.period = GetPeriod(GetDate(zamestnanie.DatumOd), GetDate(zamestnanie.DatumDo.HasValue ? zamestnanie.DatumDo.Value : DateTime.Now));
            list.Add(createPreferencesField("step3List[" + index.ToString() + "].period", true, "/numeric/long"));

            workexperience_list.Add(workexperience_object);
            index++;
        }

        if (workexperience_list.Count == 0)
        {
            createPreferencesField("step3List", false);
            workexperience workexperience_object = new workexperience();
            workexperience_object.activities = string.Empty;
            workexperience_object.employer = string.Empty;
            workexperience_object.period = new period();
            workexperience_object.period.from = new date();
            workexperience_object.period.to = new date();
            workexperience_object.position = string.Empty;
            workexperience_object.sector = string.Empty;
            workexperience_list.Add(workexperience_object);
        }

        workexperience[] workerexpriences = new workexperience[workexperience_list.Count];
        workexperience_list.CopyTo(workerexpriences);
        return workerexpriences;
    }

    private language[] GetLanguageList(Osoba osoba, ArrayList list)
    {        
        ArrayList languages_list = new ArrayList();

        if (osoba.MaterinskyJazyk != null)
        {
            list.Add(createPreferencesField("step5.motherLanguages", true));
        }        
        language language_object_materinsky = new language();
        language_object_materinsky.code = null;
        language_object_materinsky.label = osoba.MaterinskyJazyk;
        language_object_materinsky.type = langenum.mother;
        languages_list.Add(language_object_materinsky);

        List<Jazyk> jazyky = JazykDAL.SelectByOsobaId(osoba.Id);
        int index = 0;
        foreach (Jazyk jazyk in jazyky)
        {
            if(index == 0)list.Add(createPreferencesField("step5.foreignLanguageList",true));
            list.Add(createPreferencesField("step5.foreignLanguageList["+index.ToString()+"]",true));
            language language_object = new language();
            language_object.code = "sk-SK";
            language_object.label = jazyk.Nazov;
            language_object.type = langenum.foreign;           
            
            language_object.level = GetLanguageLevel(JazykHodnotenieDAL.SelectById(jazyk.PorozumeniePocuvanie).HodnotenieSkupina,
                                                     JazykHodnotenieDAL.SelectById(jazyk.PorozumenieCitanie).HodnotenieSkupina,
                                                     JazykHodnotenieDAL.SelectById(jazyk.HovorenieInterakcia).HodnotenieSkupina,
                                                     JazykHodnotenieDAL.SelectById(jazyk.HovoreniePrejav).HodnotenieSkupina,
                                                     JazykHodnotenieDAL.SelectById(jazyk.Pisanie).HodnotenieSkupina);
            languages_list.Add(language_object);
            index++;
        }

        language[] languages = new language[languages_list.Count];
        languages_list.CopyTo(languages);

        return languages;
    }

    private languageLevel GetLanguageLevel(string listening, string reading, string spokeninteraction, string spokenproduction, string writing)
    {
        languageLevel languageLevel_object = new languageLevel();
        languageLevel_object.listening = listening;
        languageLevel_object.reading = reading;
        languageLevel_object.spokeninteraction = spokeninteraction;
        languageLevel_object.spokenproduction = spokenproduction;
        languageLevel_object.writing = writing;
        return languageLevel_object;
    }

    private education[] GetEducationList(Osoba osoba, ArrayList list)
    {
        
        ArrayList educations_list = new ArrayList();
        List<Studium> studia = StudiumDAL.SelectByOsobaId(osoba.Id);
        
        int index = 0;
        foreach (Studium studium in studia)
        {            
            list.Add(createPreferencesField("step4List", true));
            education education_object = new education();
            
            list.Add(createPreferencesField("step4List[" + index.ToString() + "].period", true, "/numeric/long"));
            education_object.period = GetPeriod(GetDate(studium.DatumOd), GetDate(studium.DatumDo.HasValue ? studium.DatumDo.Value : DateTime.Now));

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].level", false));
            education_object.level = string.Empty;            

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].organisation", true));
            education_object.organisation = SkolaDAL.SelectById(studium.SkolaId).Nazov;

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].skills", true));
            education_object.skills = studium.Odbor;

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].title", true));
            education_object.title = ( studium.ZiskanyTitul == null ? string.Empty : studium.ZiskanyTitul );

            educations_list.Add(education_object);

            index++;
                           
        }

        List<Kurz> kurzy = KurzDAL.SelectByOsobaId(osoba.Id);
        foreach (Kurz kurz in kurzy)
        {
            if (index == 0)
            {
                list.Add(createPreferencesField("step4List", true));
            }

            education education_object = new education();

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].period",kurz.DatumOd.HasValue ? true : false, "/numeric/long"));
            education_object.period = GetPeriod(GetDate(kurz.DatumOd.HasValue ? kurz.DatumOd.Value : DateTime.Now), GetDate(kurz.DatumDo.HasValue ? kurz.DatumDo.Value : DateTime.Now));

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].level", false));
            education_object.level = string.Empty;

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].organisation", false));
            education_object.organisation = string.Empty;

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].skills", true));
            education_object.skills = kurz.Nazov;

            list.Add(createPreferencesField("step4List[" + index.ToString() + "].title", false));
            education_object.title = string.Empty;

            educations_list.Add(education_object);

            index++;
        }

        if (educations_list.Count == 0)
        {
            list.Add(createPreferencesField("step4List", false));
            education education_object = new education();
            education_object.period = new period();
            education_object.period.from = new date();
            education_object.period.to = new date();
            education_object.level = string.Empty;
            education_object.organisation = string.Empty;
            education_object.skills = string.Empty;
            education_object.title = string.Empty;
            educations_list.Add(education_object);
        }

        education[] educations = new education[educations_list.Count];
        educations_list.CopyTo(educations);
        return educations;
    }

    private string GetApplication(ArrayList list)
    {
        if (aplikacia != string.Empty)
        {
            list.Add(createPreferencesField("step1.application", true));
        }
        else
        {
            list.Add(createPreferencesField("step1.application", false));
        }
        return aplikacia;
    }

    private period GetPeriod(date date_from, date date_to)
    {
        period period_object = new period();
        period_object.from = date_from;
        period_object.to = date_to;
        return period_object;
    }

    private date GetDate(string day, string month, string year)
    {
        date date_object = new date();
        date_object.day = day;
        date_object.month = month;
        date_object.year = year;
        return date_object;
    }

    private date GetDate(DateTime date)
    {
        date date_object = new date();
        date_object.day = "---" + FormatDate(date.Day.ToString());
        date_object.month = "--" + FormatDate(date.Month.ToString());
        date_object.year = date.Year.ToString();
        return date_object;
    }

    private string FormatDate(string date)
    {
        if (date.Length == 1)
        {
            date = "0" + date;
        }
        return date;
    }

    private skill[] GetSkillList(Osoba osoba, ArrayList list)
    {
        ArrayList skill_list = new ArrayList();

        if (osoba.UmeleckeZrucnosti != null)
        {
            list.Add(createPreferencesField("step6.artisticSkills", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.artistic;
            skill_object.Value = osoba.UmeleckeZrucnosti;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (osoba.PocitacoveZrucnosti != null)
        {
            list.Add(createPreferencesField("step6.computerSkills", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.computer;
            skill_object.Value = osoba.PocitacoveZrucnosti;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (osoba.VodicskyPreukaz != null)
        {
            list.Add(createPreferencesField("step6.drivingLicences", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.driving;
            skill_object.Value = osoba.VodicskyPreukaz;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (osoba.OrganizacneZrucnosti != null)
        {
            list.Add(createPreferencesField("step6.organisationalSkills", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.organisational;
            skill_object.Value = osoba.OrganizacneZrucnosti;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (osoba.DalsieZrucnosti != null)
        {
            list.Add(createPreferencesField("step6.otherSkills", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.other;
            skill_object.Value = osoba.DalsieZrucnosti;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (osoba.SocialneZrucnosti != null)
        {
            list.Add(createPreferencesField("step6.socialSkills", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.social;
            skill_object.Value = osoba.SocialneZrucnosti;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (osoba.TechnickeZrucnosti != null)
        {
            list.Add(createPreferencesField("step6.technicalSkills", true));
            skill skill_object = new skill();
            skill_object.type = skillenum.technical;
            skill_object.Value = osoba.TechnickeZrucnosti;
            skill_list.Add(skill_object);
        }
        else
        {
            list.Add(createPreferencesField("step6.artisticSkills", false));
        }

        if (skill_list.Count != 0)
        {
            skill[] skills = new skill[skill_list.Count];
            skill_list.CopyTo(skills);
            return skills;
        }
        return null;
    }

    //private miscellaneous[] GetMiscellaneousList(Osoba osoba, ArrayList list)
    //{
    //    miscellaneous[] miscellaneouss;
    //    miscellaneous mis = new miscellaneous();   
    //    return miscellaneouss;
    //}

    public void createEuropaseObject(CustomPrincipal user)
    {
        learnerinformation learnerinformation_object = new learnerinformation();  
                               
        ArrayList list = new ArrayList();

        Osoba osoba = new Osoba();
        osoba = OsobaDAL.SelectById(user.Id);        
        
        //if (osoba.ZivotopisIne != null)
        //{
            list.Add(createPreferencesField("step7.additionalInfo", false));           
        //}        
        
        learnerinformation_object.docinfo = GetDocInfo(DateTime.Now, "Automatically generated Europass CV", "V1.2");
        learnerinformation_object.application = GetApplication(list);
        learnerinformation_object.locale = documentLanguage;
        learnerinformation_object.identification = GetIdentification(osoba, list);
        learnerinformation_object.workexperiencelist = GetWorkerExprienceList(osoba,list);
        learnerinformation_object.educationlist = GetEducationList(osoba,list);
        learnerinformation_object.languagelist = GetLanguageList(osoba,list);
        learnerinformation_object.skilllist = GetSkillList(osoba, list);        
       

        preferencesField[] preferencesFieldis = new preferencesField[list.Count];
        list.CopyTo(preferencesFieldis);

        learnerinformation_object.prefs = preferencesFieldis;

        //TextWriter writer = new StreamWriter(HttpContext.Current.Server.MapPath("CV\\cv.xml")); 

        MemoryStream memoryStream = new MemoryStream();
        XmlTextWriter writer = new XmlTextWriter(memoryStream, System.Text.Encoding.UTF7);

        XmlSerializer serializer = new XmlSerializer(typeof(learnerinformation));
        XmlSerializerNamespaces ns = new XmlSerializerNamespaces();
        ns.Add("europass", "http://europass.cedefop.europa.eu/Europass/V1.2");
        ns.Add("xsi", "http://www.w3.org/2001/XMLSchema-instance");
        serializer.Serialize(writer, learnerinformation_object,ns);  
        
        XmlDocument xml = new XmlDocument();   
        XmlReader xr = XmlReader.Create(HttpContext.Current.Server.MapPath("CV\\EuropassSchema_V1.2.xsd"));        
        XmlSchema schema = XmlSchema.Read(xr,new ValidationEventHandler(OnXsdValidate));
        xr.Close();
        xml.Schemas.Add(schema);

        //testovaci dokument xml
        //xml.Load(HttpContext.Current.Server.MapPath("CV\\cv-test.xml"));

        xml.LoadXml(UTF8ByteArrayToString(memoryStream.ToArray()));

        writer.Close();

        InstrumentsService proxy = new InstrumentsService();
       
        xml.Validate(OnXsdValidate);
        
        byte[] bytes = proxy.getDocumentFromCV(xml.OuterXml, documentFormat, documentLanguage);
        
        //FileStream fs = new FileStream(HttpContext.Current.Server.MapPath("CV\\cv." + documentFormat), FileMode.Create);
        //fs.Write(bytes, 0, bytes.Length);
        //fs.Close();

        memoryStream = new MemoryStream(bytes,0,bytes.Length);
        HttpContext.Current.Response.AddHeader("content-disposition", "inline;filename=cv." + documentFormat);
        HttpContext.Current.Response.OutputStream.Write(bytes, 0, bytes.Length);        
        HttpContext.Current.Response.ContentType = "file/" + documentFormat;
        
    }

    private String UTF8ByteArrayToString(Byte[] characters)
    {

        System.Text.UTF7Encoding encoding = new System.Text.UTF7Encoding();

        String constructedString = encoding.GetString(characters);

        return (constructedString);

    }

    void OnXsdValidate(object sender, ValidationEventArgs e)
    {
        throw new Exception(e.Message , e.Exception);
    }
   
}
