using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Biography : System.Web.UI.Page
{
    Osoba osoba;

    protected void Page_Load(object sender, EventArgs e)
    {
        pnl_error.Visible = true;

        InicializeControls();

        osoba = OsobaDAL.SelectById(((CustomPrincipal)User).Id);

        if (!Page.IsPostBack)
        {
            InicializeControlsData();
        }
        
    }

    private void InicializeControlsData()
    {
        SkillInit(osoba.OrganizacneZrucnosti, tbox_organisationalSkills, chbox_organisationalSkills, label_organisationalSkills_tbox);
        SkillInit(osoba.PocitacoveZrucnosti, tbox_computerSkills, chbox_computerSkills, label_computerSkills_tbox);
        SkillInit(osoba.SocialneZrucnosti, tbox_socialSkills, chbox_socialSkills, label_socialSkills_tbox);
        SkillInit(osoba.TechnickeZrucnosti, tbox_technicalSkills, chbox_technicalSkills, label_technicalSkills_tbox);
        SkillInit(osoba.UmeleckeZrucnosti, tbox_artisticSkills, chbox_artisticSkills, label_artisticSkills_tbox);
        SkillInit(osoba.VodicskyPreukaz, tbox_drivingLicences, chbox_drivingLicences, label_drivingLicences_tbox);
        SkillInit(osoba.DalsieZrucnosti, tbox_otherSkills, chbox_otherSkills, label_otherSkills_tbox);
    }

    private void SkillInit(string zrucnost, TextBox tbox, HtmlInputCheckBox chbox, HtmlGenericControl label)
    {
        if (zrucnost != null)
        {
            tbox.Text = zrucnost;
            chbox.Checked = true;
            tbox.Style["display"] = "block";
            label.Style["display"] = "block";   
        }
        else
        {
            chbox.Checked = false;
            tbox.Style["display"] = "none";
            label.Style["display"] = "none";           
        }
    }

    private void InicializeControls()
    {
        dd_formatDokumentu.Items.Add("doc");
        dd_formatDokumentu.Items.Add("pdf");
        dd_formatDokumentu.Items.Add("odt");

        ListItem li = new ListItem("Slovensk", "sk_SK");
        dd_jazykDokumentu.Items.Add(li);
        li = new ListItem("Anglick", "en_GB");
        dd_jazykDokumentu.Items.Add(li);
        li = new ListItem("Nemeck", "de_DE");
        dd_jazykDokumentu.Items.Add(li);
        li = new ListItem("Franczky", "fr_FR");
        dd_jazykDokumentu.Items.Add(li);
        li = new ListItem("Maarsk", "hu_HU");
        dd_jazykDokumentu.Items.Add(li);
        li = new ListItem("Taliansk", "it_IT");  
        dd_jazykDokumentu.Items.Add(li);
        li = new ListItem("panielsk", "es_ES");
        dd_jazykDokumentu.Items.Add(li);        

        chbox_artisticSkills.Attributes["onclick"] = "HideTextBox('" + tbox_artisticSkills.ClientID + "','" + label_artisticSkills_tbox.ClientID + "')";
        label_artisticSkills.Attributes["for"] = chbox_artisticSkills.ClientID;

        chbox_computerSkills.Attributes["onclick"] = "HideTextBox('" + tbox_computerSkills.ClientID + "','" + label_computerSkills_tbox.ClientID + "')";
        label_computerSkills.Attributes["for"] = chbox_computerSkills.ClientID;

        chbox_drivingLicences.Attributes["onclick"] = "HideTextBox('" + tbox_drivingLicences.ClientID + "','" + label_drivingLicences_tbox.ClientID + "')";
        label_drivingLicences.Attributes["for"] = chbox_drivingLicences.ClientID;

        chbox_organisationalSkills.Attributes["onclick"] = "HideTextBox('" + tbox_organisationalSkills.ClientID + "','" + label_organisationalSkills_tbox.ClientID + "')";
        label_organisationalSkills.Attributes["for"] = chbox_organisationalSkills.ClientID;

        chbox_otherSkills.Attributes["onclick"] = "HideTextBox('" + tbox_otherSkills.ClientID + "','" + label_otherSkills_tbox.ClientID + "')";
        label_otherSkills.Attributes["for"] = chbox_otherSkills.ClientID;

        chbox_socialSkills.Attributes["onclick"] = "HideTextBox('" + tbox_socialSkills.ClientID + "','" + label_socialSkills_tbox.ClientID + "')";
        label_socialSkills.Attributes["for"] = chbox_socialSkills.ClientID;

        chbox_technicalSkills.Attributes["onclick"] = "HideTextBox('" + tbox_technicalSkills.ClientID + "','" + label_technicalSkills_tbox.ClientID + "')";
        label_technicalSkills.Attributes["for"] = chbox_technicalSkills.ClientID;
    }

    protected void btn_Odoslat_Click(object sender, EventArgs e)
    {
        osoba.DalsieZrucnosti = GetNullableValue(tbox_otherSkills.Text);
        osoba.OrganizacneZrucnosti = GetNullableValue(chbox_organisationalSkills.Checked ? tbox_organisationalSkills.Text : string.Empty);
        osoba.PocitacoveZrucnosti = GetNullableValue(chbox_computerSkills.Checked ? tbox_computerSkills.Text : string.Empty);
        osoba.SocialneZrucnosti = GetNullableValue(chbox_socialSkills.Checked ? tbox_socialSkills.Text : string.Empty);
        osoba.TechnickeZrucnosti = GetNullableValue(chbox_technicalSkills.Checked ? tbox_technicalSkills.Text : string.Empty);
        osoba.UmeleckeZrucnosti = GetNullableValue(chbox_artisticSkills.Checked ? tbox_artisticSkills.Text : string.Empty);
        osoba.VodicskyPreukaz = GetNullableValue(chbox_drivingLicences.Checked ? tbox_drivingLicences.Text : string.Empty);
        OsobaDAL.Update(osoba);
        InicializeControlsData();
        GenerateBiography();
    }

    private void GenerateBiography()
    {
        webservice ws = new webservice();
        ws.DocumentFormat = dd_formatDokumentu.SelectedValue;
        ws.DocumentLanguage = dd_jazykDokumentu.SelectedValue;
        ws.Aplikacia = tboxAplikacia.Text.Trim();
        try
        {
            ws.createEuropaseObject((CustomPrincipal)User);
        }
        catch (Exception e)
        {
            pnl_error.Visible = true;
            lt_error.Text = "Pri generovan ivotopisu dolo k chybe!";
        }
    }

    private string GetNullableValue(string value)
    {
        if(value == string.Empty) return null;
        return value;
    }
}
