using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ApproveRequestUC: System.Web.UI.UserControl
{
    private Registracia registracia = null;

    public Registracia Data
    {
        get { return registracia; }
        set { registracia = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if ( registracia != null )
        {
            this.Visible = true;

            TB_Type.Text = TypRegistracieDAL.SelectById( registracia.TypRegistracieId ).Typ;
            TB_Birthday.Text = registracia.DatumNarodenia.ToShortDateString();
            TB_Email.Text = registracia.Email;
            TB_Firstname.Text = registracia.Meno;
            TB_Graduated.Text = registracia.RokAbsolvovania.ToString();
            TB_Surename.Text = registracia.Priezvisko;
        }
        else
        {
            // TODO Skor hodit error null by tu nemalo byt nikdy
            this.Visible = false;
        }
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    protected void BN_Approve_Click(object sender, EventArgs e)
    {
        HideStatus();

        if( !Page.IsValid || ( registracia == null ) ) return;

        if ( OsobaDAL.SelectByKonto( TB_Username.Text ) != null )
        {
            ShowError( "Konto so zadanm menom u existuje!" );
            return;
        }

        if ( OsobaDAL.SelectByEmail( TB_Email.Text ) != null )
        {
            ShowError( "Konto viazan na dan email u existuje!" );
            return;
        }

        OsobaDAL.Insert( new Osoba( 0, Convert.ToInt32( DDL_Role.SelectedValue ), TB_Username.Text, true, registracia.Heslo, registracia.Meno, registracia.Priezvisko, registracia.Email, registracia.DatumNarodenia ) );
        RegistraciaDAL.Delete( registracia );

        ShowSuccess( "Poiadavka o registrciu bola schvlena" );
    }
    protected void BN_Delete_Click(object sender, EventArgs e)
    {
        HideStatus();

        RegistraciaDAL.Delete( registracia );

        Response.Redirect("Requests.aspx");
    }

    protected void BN_Recover_Click(object sender, EventArgs e)
    {
        HideStatus();

        if( !Page.IsValid || ( registracia == null ) ) return;

        Osoba osoba = OsobaDAL.SelectByKonto( TB_Username.Text );

        if( osoba == null )
        {
            ShowError( "Konto so zadanm menom neexistuje!" );
            return;
        }

        osoba.KontoAktivne = true;
        osoba.Heslo = registracia.Heslo;
        osoba.Meno = registracia.Meno;
        osoba.Priezvisko = registracia.Priezvisko;
        osoba.Email = registracia.Email;
        osoba.DatumNarodenia = registracia.DatumNarodenia;

        OsobaDAL.Update( osoba );
        RegistraciaDAL.Delete( registracia );

        ShowSuccess( "Konto bolo obnoven" );
    }
    protected void BN_Back_Click(object sender, EventArgs e)
    {
        Response.Redirect("RequestList.aspx");
    }
}
