using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class EditContactUC : System.Web.UI.UserControl
{
    private Osoba osoba = null;

    public Osoba Data
    {
        get { return osoba; }
        set { osoba = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        HideStatus();
        
        if( osoba != null )
        {
            TB_Email.Text = osoba.Email;
            TB_Fax.Text = osoba.Fax;
            TB_Icq.Text = osoba.Icq;
            TB_Mobil.Text = osoba.Mobil;
            TB_Msn.Text = osoba.Msn;
            TB_Skype.Text = osoba.Skype;
            TB_Telephone.Text = osoba.Telefon;
        }
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    protected void BN_Save_Click(object sender, EventArgs e)
    {
        Osoba osobaByEmail = OsobaDAL.SelectByEmail( TB_Email.Text );

        if( ( osobaByEmail != null ) && ( osoba.Id != osobaByEmail.Id ) )
        {
            ShowError("Email je u registrovan!");
            return;
        }

        osoba.Email = TB_Email.Text;
        osoba.Fax = TB_Fax.Text;
        osoba.Icq = TB_Icq.Text;
        osoba.Mobil = TB_Mobil.Text;
        osoba.Msn = TB_Msn.Text;
        osoba.Skype = TB_Skype.Text;
        osoba.Telefon = TB_Telephone.Text;

        OsobaDAL.Update(osoba);

        ShowSuccess("daje uloen");
    }
}
