﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="EditCoursesUC.ascx.cs" Inherits="EditCoursesUC" %>
<table id="TBL_Form" class="Form_Table_NoBorder">
    <tr>
        <td class="Form_TableCollumn_Margin">
        </td>
        <td class="Form_TableCollumn_Left">
            <asp:Label ID="LA_Name" runat="server" Text="Meno"></asp:Label>
        </td>
        <td class="Form_TableCollumn_Right">
            <asp:TextBox ID="TB_Name" runat="server" CssClass="Form_TextBox_Long"></asp:TextBox>
        </td>
        <td class="Form_TableCollumn_Margin">
            <asp:RegularExpressionValidator ID="REV_Name" runat="server" ErrorMessage="Nesprávny formát mena" ControlToValidate="TB_Name" 
                Display="Dynamic" ValidationExpression="[a-zA-Z0-9\040\u00C0-\u01FF]{1,200}" ToolTip="Nesprávny formát mena"><asp:Image ID="REV_Name_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RegularExpressionValidator>
            <asp:RequiredFieldValidator ID="RFV_Name" runat="server"
                ControlToValidate="TB_Name" ErrorMessage="Nie je zadané meno" Display="Dynamic" ToolTip="Nie je zadané meno"><asp:Image ID="RFV_Name_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RequiredFieldValidator>
        </td>
    </tr>
    <tr>
        <td class="Form_TableCollumn_Margin">
        </td>
        <td class="Form_TableCollumn_Left">
            <asp:Label ID="LA_Started" runat="server" Text="Dátum začiatku"></asp:Label>
        </td>
        <td class="Form_TableCollumn_Right">
            <asp:TextBox ID="TB_Started" runat="server" CssClass="Form_TextBox_Long"></asp:TextBox>
        </td>
        <td class="Form_TableCollumn_Margin">
            <asp:RegularExpressionValidator ID="REV_Started" runat="server" ErrorMessage="Nesprávny dátum alebo formát dátumu" ControlToValidate="TB_Started" 
                Display="Dynamic" ValidationExpression="^(?:(?:31(\/|-|\.)(?:0?[13578]|1[02]))\1|(?:(?:29|30)(\/|-|\.)(?:0?[1,3-9]|1[0-2])\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})$|^(?:29(\/|-|\.)0?2\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))$|^(?:0?[1-9]|1\d|2[0-8])(\/|-|\.)(?:(?:0?[1-9])|(?:1[0-2]))\4(?:(?:1[6-9]|[2-9]\d)?\d{2})$" 
                ToolTip="Nesprávny dátum alebo formát dátumu"><asp:Image ID="REV_Started_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RegularExpressionValidator>
            <asp:RequiredFieldValidator ID="RFV_Started" runat="server" ControlToValidate="TB_Started"
                ErrorMessage="Nie je zadaný dátum začiatku" Display="Dynamic" ToolTip="Nie je zadaný dátum začiatku"><asp:Image ID="RFV_Started_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RequiredFieldValidator>
        </td>
    </tr>
    <tr>
        <td class="Form_TableCollumn_Margin">
        </td>
        <td class="Form_TableCollumn_Left">
            <asp:Label ID="LA_Finished" runat="server" Text="Dátum ukončenia"></asp:Label>
        </td>
        <td class="Form_TableCollumn_Right">
            <asp:TextBox ID="TB_Finished" runat="server" CssClass="Form_TextBox_Long"></asp:TextBox>
        </td>
        <td class="Form_TableCollumn_Margin">
            <asp:RegularExpressionValidator ID="REV_Finished" runat="server" ErrorMessage="Nesprávny dátum alebo formát dátumu" ControlToValidate="TB_Finished" 
                Display="Dynamic" ValidationExpression="^(?:(?:31(\/|-|\.)(?:0?[13578]|1[02]))\1|(?:(?:29|30)(\/|-|\.)(?:0?[1,3-9]|1[0-2])\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})$|^(?:29(\/|-|\.)0?2\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))$|^(?:0?[1-9]|1\d|2[0-8])(\/|-|\.)(?:(?:0?[1-9])|(?:1[0-2]))\4(?:(?:1[6-9]|[2-9]\d)?\d{2})$" 
                ToolTip="Nesprávny dátum alebo formát dátumu"><asp:Image ID="REV_Finished_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RegularExpressionValidator>
            <asp:RequiredFieldValidator ID="RFV_Finished" runat="server" ControlToValidate="TB_Finished"
                ErrorMessage="Nie je zadaný dátum ukončenia" Display="Dynamic" ToolTip="Nie je zadaný dátum ukončenia"><asp:Image ID="RFV_Finished_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RequiredFieldValidator>
        </td>
    </tr>  
    <tr>
        <td class="Form_TableCollumn_Margin">
        </td>
        <td class="Form_TableCollumn_Left">
            <asp:Label ID="LA_Note" runat="server" Text="Poznámka"></asp:Label>
        </td>
        <td class="Form_TableCollumn_Right">
            <asp:TextBox ID="TB_Note" runat="server" CssClass="Form_TextArea_Long" TextMode="MultiLine"></asp:TextBox>
        </td>
        <td class="Form_TableCollumn_Margin">
            <asp:RegularExpressionValidator ID="REV_Note" runat="server" 
                ErrorMessage="Nesprávny formát textu poznámky" ControlToValidate="TB_Note" Display="Dynamic" ValidationExpression="[a-zA-Z\s\u002A-\u0039\040\u00C0-\u01FF]{1,8000}" 
                ToolTip="Nesprávny formát textu poznámky"><asp:Image ID="REV_Note_Image" runat="server" SkinID="Skin_IMG_Validator" />
            </asp:RegularExpressionValidator>
        </td>
    </tr>
    <tr>
        <td colspan="1" class="Form_TableCollumn_Margin">
        </td>
        <td colspan="2" class="Form_TableCollumn_Center">
            <asp:Label ID="LA_Status" runat="server" Visible="False"></asp:Label>
        </td>
        <td class="Form_TableCollumn_Margin">
        </td>
    </tr>
    <tr>
        <td colspan="1" class="Form_TableCollumn_Margin">
        </td>
        <td colspan="2" class="Form_TableCollumn_Center">
            <asp:Button ID="BN_Insert" runat="server" CssClass="Button_WhiteBlue_Short" Text="Pridať" OnClick="BN_Insert_Click" />
            <asp:Button ID="BN_Edit" runat="server" CssClass="Button_WhiteBlue_Short" OnClick="BN_Edit_Click"
                Text="Zmeniť" />
            <asp:Button ID="BN_New" runat="server" CausesValidation="False" CssClass="Button_WhiteBlue_Short"
                OnClick="BN_New_Click" Text="Nový" /></td>
        <td class="Form_TableCollumn_Margin">
        </td>
    </tr>
    <tr>
        <td colspan="1" class="Form_TableCollumn_Margin">
        </td>
        <td colspan="2" class="Form_TableCollumn_Center">
            <asp:GridView ID="GV_Courses" runat="server" AllowPaging="True" AllowSorting="True" AutoGenerateColumns="False" DataSourceID="ODS_Courses" SkinID="Skin_GridView" DataKeyNames="Id" OnSelectedIndexChanging="GV_Courses_RowSelecting" EnableViewState="False" OnRowDeleted="GV_Courses_RowDeleted" CssClass="List_GridView">
                <Columns>
                    <asp:BoundField DataField="Nazov" HeaderText="Nazov" SortExpression="Nazov">
                        <ItemStyle Width="250px" />
                    </asp:BoundField>
                    <asp:BoundField DataField="DatumOd" HeaderText="DatumOd" SortExpression="DatumOd" DataFormatString="{0:dd.MM.yyyy}" HtmlEncode="False">
                          <ItemStyle Width="100px" />
                    </asp:BoundField>
                    <asp:BoundField DataField="DatumDo" HeaderText="DatumDo" SortExpression="DatumDo" DataFormatString="{0:dd.MM.yyyy}" HtmlEncode="False">
                         <ItemStyle Width="100px" />
                    </asp:BoundField>
                    <asp:CommandField DeleteText="Zmaž" SelectText="Vyber" ShowDeleteButton="True" ShowSelectButton="True">
                        <ItemStyle CssClass="List_GridView_Command" />
                    </asp:CommandField>
                </Columns>
            </asp:GridView>
            <asp:ObjectDataSource ID="ODS_Courses" runat="server" DataObjectTypeName="Kurz" DeleteMethod="Delete"
                EnablePaging="True" InsertMethod="Insert" OldValuesParameterFormatString="original_{0}"
                SelectCountMethod="SelectCountByOsobaId" SelectMethod="SelectByOsobaIdPagedSorted" SortParameterName="sortExpression"
                TypeName="KurzBLL" UpdateMethod="Update">
                <SelectParameters>
                    <asp:Parameter Name="osobaId" Type="Int32" />
                </SelectParameters>
            </asp:ObjectDataSource>
        </td>
        <td class="Form_TableCollumn_Margin">
        </td>
    </tr>
</table>