using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class EditNoticeUC : System.Web.UI.UserControl
{
    private Oznam oznam = null;

    public Oznam Data
    {
        get { return oznam; }
        set { oznam = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if( oznam != null )
        {
            TB_Relevance.Text = oznam.DatumPlatnosti.ToShortDateString().Replace(" ", "");
            TB_Name.Text = oznam.Nazov;
            TB_Notice.Text = oznam.Popis;
            TB_AddedBy.Text = oznam.OsobaFK.Meno + " " + oznam.OsobaFK.Priezvisko;
        }
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    protected void DDL_Cathegories_DataBound(object sender, EventArgs e)
    {
        if( oznam != null ) DDL_Cathegories.Items.FindByValue( oznam.TypOznamuId.ToString() ).Selected = true;
    }

    protected void BN_Delete_Click(object sender, EventArgs e)
    {
        OznamDAL.Delete( oznam );

        Response.Redirect("Board.aspx");
    }
    protected void BN_Edit_Click(object sender, EventArgs e)
    {
        oznam.DatumPlatnosti = DateTime.Parse( TB_Relevance.Text );
        oznam.Nazov = TB_Name.Text;
        oznam.Popis = TB_Notice.Text;
        oznam.TypOznamuId = Convert.ToInt32( DDL_Cathegories.SelectedValue );

        OznamDAL.Update( oznam );

        ShowSuccess("Oznam bol upraven");
    }

    protected void BN_Back_Click(object sender, EventArgs e)
    {
        Response.Redirect("Board.aspx");
    }
}
