using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class EditQuestionUC : System.Web.UI.UserControl
{
    private Otazka otazka;

    public Otazka Data 
    {
        get { return otazka; }
        set { otazka = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        HideStatus();

        UC_QC_Choices.Data = otazka;

        if( otazka != null )
        {
            TB_Question.Text = otazka.TextOtazky;
            TB_Other.Text = otazka.Ine;
            DDL_Type.SelectedIndex = otazka.TypOdpovede;
        }
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    protected void BN_Edit_Click(object sender, EventArgs e)
    {
        HideStatus();

        if( DDL_Type.SelectedValue == "0" ||  DDL_Type.SelectedValue == "1" )
        {
            if( UC_QC_Choices.GetChoiceCount() < 2 )
            {
                ShowError("Prli mlo monost pre tento typ otzky!");
                return;
            }
        }

        if( DDL_Type.SelectedValue == "2" )
        {
            if( UC_QC_Choices.GetChoiceCount() < 1 )
            {
                ShowError("Prli mlo monost pre tento typ otzky!");
                return;
            }
        }

        if( UC_QC_Choices.CanSave() )
        {
            otazka.TextOtazky = TB_Question.Text;
            otazka.Ine = TB_Other.Text;
            otazka.TypOdpovede = Convert.ToInt16( DDL_Type.SelectedIndex );

            UC_QC_Choices.SaveChoices();
            OtazkaDAL.Update( otazka );
            ShowSuccess("Otzka bola uloen");
        }
        else ShowError("Niektor monos nieje vyplnen!");
    }
    protected void BN_Back_Click(object sender, EventArgs e)
    {
        Response.Redirect("EditSurvey.aspx?Id=" + otazka.AnketaId.ToString() );
    }
}
