using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class EditSurveyUC : System.Web.UI.UserControl
{
    private Anketa anketa;

    public Anketa Data
    {
        get { return anketa; }
        set { anketa = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        ODS_Questions.SelectParameters["anketaId"].DefaultValue = anketa.Id.ToString();
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        if( !anketa.MoznoUpravit )
        {
            ( (CommandField)GV_Questions.Columns[1] ).Visible = false;
        }

        GV_Questions.Sort( "Id", SortDirection.Ascending );
    }

    private void ShowError( Label status, string text )
    {
        status.ForeColor = System.Drawing.Color.Red;
        status.Text = text;
        status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Options_Status.Visible = false;
        LA_Question_Status.Visible = false;
    }

    private void ShowSuccess( Label status, string text )
    {
        status.ForeColor = System.Drawing.Color.Green;
        status.Text = text;
        status.Visible = true;
    }

    protected void BN_Add_Click(object sender, EventArgs e)
    {
        if( anketa.MoznoUpravit )
        {
            OtazkaDAL.Insert( new Otazka( 0, TB_Question.Text, 0, anketa.Id ) );
        }
        else ShowError( LA_Question_Status, "Anketu nieje mon upravova!" );
    }

    protected void BN_Preview_Click(object sender, EventArgs e)
    {
        Response.Redirect("PreviewSurvey.aspx?Id=" + anketa.Id.ToString());
    }

    protected void GV_Questions_RowEditing(object sender, GridViewEditEventArgs e)
    {
        int id = Convert.ToInt32( GV_Questions.DataKeys[e.NewEditIndex].Value );

        Response.Redirect("EditQuestion.aspx?Id=" + id.ToString());
    }
    protected void BN_Start_Click(object sender, EventArgs e)
    {
        List<Otazka> otazkaList= OtazkaDAL.SelectByAnketaId( anketa.Id );
        
        if( otazkaList.Count == 0 ) 
        {
            ShowError( LA_Options_Status, "Nie s zadan iadne otzky!" );
            return;
        }
        
        otazkaList.Sort( new ObjectComparer<Otazka>( "Id", "ASC" ) );

        List<MozneOdpovede> mozneOdpovedeList;
        bool canStart = true;
        string format = "Otzka {0}je nesprvne zadan!";
        string wrongQuestions = string.Empty;

        for( int i = 0; i < otazkaList.Count; i++ )
        {
            mozneOdpovedeList = MozneOdpovedeDAL.SelectByOtazkaId( otazkaList[i].Id );

            if( ( otazkaList[i].TypOdpovede == 0 || otazkaList[i].TypOdpovede == 1 ) && mozneOdpovedeList.Count < 2 ) 
            {
                if( wrongQuestions != string.Empty ) format = "Otzky {0}s nesprvne zadan!";
                wrongQuestions += (i + 1).ToString() + " ";
                canStart = false;
            }
            if( ( otazkaList[i].TypOdpovede == 2 ) && mozneOdpovedeList.Count < 1 )
            {
                if( wrongQuestions != string.Empty) format = "Otzky {0}s nesprvne zadan!";
                wrongQuestions += (i + 1).ToString() + " ";
                canStart = false;
            }
        }

        if( canStart ) 
        {
            InstanciaAnketyDAL.Insert( new InstanciaAnkety( 0, anketa.Id, DateTime.Parse( TB_Start.Text ), DateTime.Parse( TB_Finish.Text ) ) );
        
            anketa.MoznoUpravit = false;
            AnketaDAL.Update( anketa );

            ShowSuccess( LA_Options_Status, "Anketa bola spusten!" );
        }
        else ShowError( LA_Options_Status, string.Format( format, wrongQuestions ) );
    }
}
