using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using System.Reflection;
using System.Text;

public partial class ExportDataUC : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            SetCheckboxes(true);

            List<int> graduationYears = OsobaDAL.SelectGraduationYears();
            SetDropDownList(graduationYear_DDL, graduationYears);
        }

        HideStatus();
    }
    protected void exportCSV_B_Click(object sender, EventArgs e)
    {
        CreateExport("csv");
    }

    protected void exportXLS_B_Click(object sender, EventArgs e)
    {
        CreateExport("xls");
    }

    public void CreateExport(string fileType) 
    {
        DataTable dt = new DataTable();
        List<String> columnsToExport = GetColumnsToExport();

        List<Osoba> listOsoba = OsobaBLL.Select();

        if (listOsoba == null || listOsoba.Count <= 0)
        {
            ShowError("iadne daje na export.");
            return;
        }

        Type t = listOsoba[0].GetType();
        PropertyInfo pi;

        for (int i = 0; i < columnsToExport.Count; i++)
        {
            pi = t.GetProperty(columnsToExport[i]);
            if (pi != null)
            {
                dt.Columns.Add(pi.Name, Type.GetType("System.String"));
            }
        }

        object tmpObject = null;
        for (int i = 0; i < listOsoba.Count; i++)
        {
            if (listOsoba[i].TypOsobyId != 2 ||
                (listOsoba[i].RokAbsolvovania.ToString() != this.graduationYear_DDL.SelectedValue &&
                this.graduationYear_DDL.SelectedValue.ToLower() != "vetky"))
                continue;

            t = listOsoba[i].GetType();
            DataRow row = dt.NewRow();

            for (int j = 0; j < columnsToExport.Count; j++)
            {
                pi = t.GetProperty(columnsToExport[j]);

                if (pi != null)
                {
                    tmpObject = pi.GetValue(listOsoba[i], null);

                    if (tmpObject != null)
                    {
                        row[pi.Name] = tmpObject.ToString();
                    }
                }
            }

            dt.Rows.Add(row);
        }
        
        Exporter objExport = new Exporter();

        if (fileType == "csv")
            objExport.ExportDetails(dt, Exporter.ExportFormat.CSV, "export");
        else
            objExport.ExportDetails(dt, Exporter.ExportFormat.Excel, "export");
    }

    protected void SetCheckboxes(bool value)
    {
        this.name_CH.Checked = value;
        this.surname_CH.Checked = value;
        this.titles_CH.Checked = value;
        this.mobil_CH.Checked = value;
        this.phone_CH.Checked = value;
        this.email_CH.Checked = value;
        this.web_CH.Checked = value;
        this.icq_CH.Checked = value;
        this.skype_CH.Checked = value;
        this.login_CH.Checked = value;
        this.graduationYear_CH.Checked = value;
        this.bornDate_CH.Checked = value;
    }

    protected List<String> GetColumnsToExport()
    {
        List<String> al = new List<String>();

        if (this.name_CH.Checked)
            al.Add("Meno");
        if (this.surname_CH.Checked)
            al.Add("Priezvisko");
        if (this.titles_CH.Checked)
            al.Add("Tituly");
        if (this.mobil_CH.Checked)
            al.Add("Mobil");
        if (this.phone_CH.Checked)
            al.Add("Telefon");
        if (this.email_CH.Checked)
            al.Add("Email");
        if (this.web_CH.Checked)
            al.Add("Web");
        if (this.icq_CH.Checked)
            al.Add("Icq");
        if (this.skype_CH.Checked)
            al.Add("Skype");
        if (this.login_CH.Checked)
            al.Add("Konto");
        if (this.graduationYear_CH.Checked)
            al.Add("RokAbsolvovania");
        if (this.bornDate_CH.Checked)
            al.Add("DatumNarodenia");

        return al;
    }

    private void SetDropDownList(DropDownList dropDownList, List<int> graduationYears)
    {
        dropDownList.Items.Clear();

        dropDownList.Items.Add(new ListItem("Vetky"));

        for (int i = 0; i < graduationYears.Count; i++)
        {
            dropDownList.Items.Add(new ListItem(graduationYears[i].ToString()));
        }
    }

    private void ShowError(string text)
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess(string text)
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

}
