using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class InsertProjectUC : System.Web.UI.UserControl
{
    private int osobaId = 0;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        if( ViewState["backUrlWasSet"] == null )
        {
            ViewState["backUrl"] = Request.UrlReferrer == null ? null : Request.UrlReferrer.PathAndQuery;
            ViewState["backUrlWasSet"] = true;
        }

        if( ViewState["backUrl"] == null ) BN_Back.Visible = false;
        else BN_Back.Visible = true;


        if( Session["riesitel"] == null ) osobaId = ((CustomPrincipal)Context.User).Id;
        else osobaId = (int)Session["riesitel"];

        Osoba osoba = OsobaDAL.SelectById( osobaId );

        TB_Author.Text = osoba.Meno + " " + osoba.Priezvisko;
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    protected void BN_Add_Click(object sender, EventArgs e)
    {
        string nazov = TB_Name.Text;
        string abstrakt = TB_Abstract.Text;
        string veduci = TB_Leader.Text;
        string klucoveSlova = TB_Keywords.Text;
        DateTime datumVypracovania = DateTime.Parse( TB_Date.Text );
        string poznamka = TB_Note.Text;

        Projekt projekt = ProjektDAL.SelectByOsobaIdNazov( osobaId, nazov );

        if( projekt == null )
        {
            ProjektDAL.Insert( new Projekt( 0, osobaId, null, null, nazov, abstrakt, veduci, klucoveSlova, datumVypracovania, null, poznamka ) );

            Session.Remove("riesitel");

            ShowSuccess("Projekt bol uloen");
        }

        else
        {
            ShowError("Projekt pod tmto nzvom u existuje!");
        }    
    }
    protected void BN_Back_Click(object sender, EventArgs e)
    {
        Response.Redirect( (string)ViewState["backUrl"]  );
    }
}
