using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class QuestionChoicesUC : System.Web.UI.UserControl
{
    private Otazka otazka;

    private List<string> ChoiceIdList
    {
        get 
        {
            if (ViewState["ChoiceIdList"] == null) ViewState["ChoiceIdList"] = new List<string>();
            return (List<string>)ViewState["ChoiceIdList"];
        }
        set { ViewState["ChoiceIdList"] = value; }
    }

    private int LastChoiceId
    {
        get 
        {
            if (ViewState["LastChoiceId"] == null) ViewState["LastChoiceId"] = (int)0;
            return (int)ViewState["LastChoiceId"];
        }
        set { ViewState["LastChoiceId"] = value; }
    }

    public Otazka Data
    {
        get { return otazka; }
        set { otazka = value; }
    }

    protected override void LoadViewState(object savedState)
    {
        base.LoadViewState( savedState );

        for (int i = 0; i < ChoiceIdList.Count; i++)
        {
            TextBox textBox = new TextBox();
            textBox.ID = "TB_Choice_" + ChoiceIdList[i];
            textBox.CssClass = "Form_TextBox_Longer";

            Button button = new Button();
            button.ID = "BN_Remove_" + ChoiceIdList[i];
            button.Text = "Odstrni";
            button.CssClass = "Button_WhiteBlue_Short";
            button.Click += new EventHandler( BN_Remove_Click );
            button.CausesValidation = false;

            PH_Choices.Controls.Add( textBox );
            PH_Choices.Controls.Add( button );
            PH_Choices.Controls.Add( new LiteralControl("<br />") );
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if( !Page.IsPostBack )
        {
            if( otazka == null ) return;

            List<MozneOdpovede> mozneOdpovedeList = MozneOdpovedeDAL.SelectByOtazkaId( otazka.Id );

            for( int i = 0; i < mozneOdpovedeList.Count; i++ )
            {
                AddChoice( mozneOdpovedeList[i].Text );
            }
        }
    }

    public bool CanSave()
    {
        for( int i = 0; i < PH_Choices.Controls.Count; i++ )
        {
            if( PH_Choices.Controls[i] is TextBox )
            {    
                string text = ((TextBox)PH_Choices.Controls[i]).Text.Trim();

                if( text == string.Empty ) return false;
            }
        }

        return true;
    }

    public int GetChoiceCount()
    {
        return ChoiceIdList.Count;
    }

    public void SaveChoices()
    {
        List<MozneOdpovede> mozneOdpovedeList = MozneOdpovedeDAL.SelectByOtazkaId( otazka.Id );

        int choiceCount = mozneOdpovedeList.Count < ChoiceIdList.Count ? ChoiceIdList.Count : mozneOdpovedeList.Count;

        for( int i = 0; i < choiceCount; i++ )
        {
            if( i >= mozneOdpovedeList.Count )
            {
                MozneOdpovedeDAL.Insert( new MozneOdpovede( 0, ( (TextBox)FindControl( "TB_Choice_" + ChoiceIdList[i] ) ).Text, otazka.Id ) );
                continue;
            }
            if( i >= ChoiceIdList.Count )
            {
                MozneOdpovedeDAL.Delete( mozneOdpovedeList[i] );
                continue;
            }

            mozneOdpovedeList[i].Text = ( (TextBox)FindControl( "TB_Choice_" + ChoiceIdList[i] ) ).Text;
            MozneOdpovedeDAL.Update( mozneOdpovedeList[i] );
        }
    }

    private void AddChoice( string text )
    {
        LastChoiceId++;

        TextBox textBox = new TextBox();
        textBox.ID = "TB_Choice_" + LastChoiceId.ToString();
        textBox.Text = text;
        textBox.CssClass = "Form_TextBox_Longer";

        Button button = new Button();
        button.ID = "BN_Remove_" + LastChoiceId.ToString();
        button.Text = "Odstrni";
        button.CssClass = "Button_WhiteBlue_Short";
        button.Click += new EventHandler( BN_Remove_Click );
        button.CausesValidation = false;

        PH_Choices.Controls.Add( textBox );
        PH_Choices.Controls.Add( button );
        PH_Choices.Controls.Add( new LiteralControl("<br />") );

        ChoiceIdList.Add( LastChoiceId.ToString() );
    }

    protected void BN_Add_Click(object sender, EventArgs e)
    {
        AddChoice( string.Empty );
    }

    void BN_Remove_Click(object sender, EventArgs e)
    {
        Button button = (Button)sender;

        string textBoxId = "TB_Choice_" + button.ID.Remove( 0, 10 );

        for (int i = 0; i < PH_Choices.Controls.Count; i++ )
        {
            if( PH_Choices.Controls[i].ID == textBoxId )
            {    
                PH_Choices.Controls.RemoveAt( i );
                PH_Choices.Controls.RemoveAt( i );
                PH_Choices.Controls.RemoveAt( i );
                i--;
            }
        }

        ChoiceIdList.Remove( button.ID.Remove( 0, 10 ) );
    }
}
