using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class ViewAnswerUC : System.Web.UI.UserControl
{
    private int instanceId; 
    private int userId;
    private Odpoved odpoved;
    private Otazka otazka;
    private List<MozneOdpovede> mozneOdpovedeList;

    public Otazka Question
    {
        get { return otazka; }
        set { otazka = value; }
    }

    public int InstanceId
    {
        get { return instanceId; }
        set { instanceId = value; }
    }

    public int UserId
    {
        get { return userId; }
        set { userId = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        odpoved = OdpovedDAL.SelectByInstanciaIdOsobaIdOtazkaId( instanceId, userId, otazka.Id );

        if( odpoved != null )
        {
            mozneOdpovedeList = MozneOdpovedeDAL.SelectByOtazkaId( odpoved.OtazkaId  );

            if( ( otazka.TypOdpovede == 0 || otazka.TypOdpovede == 1 ) && mozneOdpovedeList.Count < 2 ) return;
            if( ( otazka.TypOdpovede == 2 ) && mozneOdpovedeList.Count < 1 ) return;

            this.Controls.Add( new LiteralControl("<table class=\"Question_Table\">") );
            this.Controls.Add( new LiteralControl("<tr>") );
            this.Controls.Add( new LiteralControl("<td colspan=\"2\">") );
            this.Controls.Add( new LiteralControl("<span><b>" + otazka.TextOtazky + "</b></span>") );
            this.Controls.Add( new LiteralControl("</td>") );
            this.Controls.Add( new LiteralControl("</tr>") );

            switch ( otazka.TypOdpovede )
            {
                case 0: InsertCheckBoxes(); break;
                case 1: InsertRadioButtons(); break;
                case 2: InsertTextBoxes(); break;
                default: return;
            }

            this.Controls.Add( new LiteralControl("</table>") );
        }
    }

    private void InsertCheckBoxes()
    {
        CheckBoxList checkBoxList = new CheckBoxList();
        checkBoxList.ID = "CBL_Choices";

        for( int i = 0; i < mozneOdpovedeList.Count; i++ )
        {
            checkBoxList.Items.Add( new ListItem( mozneOdpovedeList[i].Text ) );
        }

        checkBoxList.Enabled = false;

        TextBox textbox = null;

        this.Controls.Add( new LiteralControl("<tr>") );
        this.Controls.Add( new LiteralControl("<td colspan=\"2\">") );      
        if( otazka.Ine != string.Empty )
        {
            textbox = new TextBox();
            textbox.ID = "TB_Other";
            textbox.Enabled = false;
            textbox.CssClass = "Question_TextBox";

            checkBoxList.Items.Add( otazka.Ine );

            this.Controls.Add( checkBoxList );
            this.Controls.Add( textbox );

        }
        else this.Controls.Add( checkBoxList );

        string[] odpovede = odpoved.TextOdpovede.Split( new char[]{'\n'}, StringSplitOptions.RemoveEmptyEntries );

        int index;

        for( int i = 0; i < odpovede.Length; i++ )
        {
            if( Int32.TryParse( odpovede[i], out index ) == true ) checkBoxList.Items[index].Selected = true;
        }

        if( otazka.Ine != string.Empty && checkBoxList.Items[checkBoxList.Items.Count - 1].Selected == true )
        {
            textbox.Text = odpovede[odpovede.Length - 1];
        }

        this.Controls.Add( new LiteralControl("</td>") );
        this.Controls.Add( new LiteralControl("</tr>") );
    }

    private void InsertRadioButtons()
    {
        RadioButtonList radioButtonList = new RadioButtonList();
        radioButtonList.ID = "RBL_Choices";

        for( int i = 0; i < mozneOdpovedeList.Count; i++ )
        {
            radioButtonList.Items.Add( new ListItem( mozneOdpovedeList[i].Text ) );
        }

        radioButtonList.Enabled = false;

        TextBox textbox = null;

        this.Controls.Add( new LiteralControl("<tr>") );
        this.Controls.Add( new LiteralControl("<td colspan=\"2\">") );
        if( otazka.Ine != string.Empty )
        {
            textbox = new TextBox();
            textbox.ID = "TB_Other";
            textbox.Enabled = false;
            textbox.CssClass = "Question_TextBox";

            radioButtonList.Items.Add( otazka.Ine );

            this.Controls.Add( radioButtonList );
            this.Controls.Add( textbox );

        }
        else this.Controls.Add( radioButtonList );

        string[] odpovede = odpoved.TextOdpovede.Split( new char[]{'\n'}, StringSplitOptions.RemoveEmptyEntries );

        int index;

        if( Int32.TryParse( odpovede[0], out index ) == true ) radioButtonList.Items[index].Selected = true;

        if( otazka.Ine != string.Empty && radioButtonList.Items[radioButtonList.Items.Count - 1].Selected == true )
        {
            textbox.Text = odpovede[odpovede.Length - 1];
        }

        this.Controls.Add( new LiteralControl("</td>") );
        this.Controls.Add( new LiteralControl("</tr>") );
    }

    private void InsertTextBoxes()
    {
        string[] odpovede = odpoved.TextOdpovede.Split( new char[]{'\n'}, StringSplitOptions.RemoveEmptyEntries );

        for( int i = 0; i < mozneOdpovedeList.Count; i++ )
        {
            this.Controls.Add( new LiteralControl("<tr>") );

            this.Controls.Add( new LiteralControl("<td>") );
            this.Controls.Add( new LiteralControl("<span>" + mozneOdpovedeList[i].Text + "</span>") );
            this.Controls.Add( new LiteralControl("</td>") );

            TextBox textbox = new TextBox();
            textbox.ID = "TB_Text_" + i.ToString();
            textbox.Text = odpovede[i];
            textbox.Enabled = false;
            textbox.CssClass = "Question_TextBox";

            this.Controls.Add( new LiteralControl("<td>") );
            this.Controls.Add( textbox );
            this.Controls.Add( new LiteralControl("</td>") );

            if( i != mozneOdpovedeList.Count - 1 ) 
            {
                this.Controls.Add( new LiteralControl("<br />") );
            }

            this.Controls.Add( new LiteralControl("</tr>") );
        }  
    }
}
