using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ViewJobsUC : System.Web.UI.UserControl
{
    private Osoba osoba = null;
    Zamestnanie zamestanie = null;

    public Osoba Data
    {
        get { return osoba; }
        set { osoba = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        ODS_Jobs.SelectParameters["osobaId"].DefaultValue = osoba.Id.ToString();
    }

    private void SetFields( Zamestnanie zamestanie )
    {
        PoziciaOdvetvie poziciaOdvetvie = PoziciaOdvetvieDAL.SelectById( zamestanie.PoziciaOdvetvieId.Value );

        TB_Sector.Text = OdvetvieDAL.SelectById( poziciaOdvetvie.OdvetvieId ).Nazov;
        TB_Position.Text = poziciaOdvetvie.Pozicia;
        TB_Employer.Text = zamestanie.NazovFirmy;
        TB_Finished.Text = zamestanie.DatumDo.HasValue ? zamestanie.DatumDo.Value.ToShortDateString().Replace(" ","") : null;
        TB_Note.Text = zamestanie.Poznamka;
        TB_Started.Text = zamestanie.DatumOd.ToShortDateString().Replace(" ", ""); 
    }

    protected void GV_Jobs_RowSelecting(object sender, GridViewSelectEventArgs e)
    {
        int id = Convert.ToInt32( GV_Jobs.DataKeys[e.NewSelectedIndex].Value );

        zamestanie = ZamestnanieDAL.SelectById( id );

        SetFields( zamestanie );
    }
}
