using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class ViewLanguagesUC : System.Web.UI.UserControl
{
    private Osoba osoba = null;
    Jazyk jazyk = null;

    public Osoba Data
    {
        get { return osoba; }
        set { osoba = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        ODS_Languages.SelectParameters["osobaId"].DefaultValue = osoba.Id.ToString();
    }

    private string FindRateString( List<JazykHodnotenie> jazykHodnotenieList, int id )
    {
        for( int i = 0; i < jazykHodnotenieList.Count; i++ )
        {
            if( jazykHodnotenieList[i].Id == id ) return jazykHodnotenieList[i].HodnotenieSkupina + " " + jazykHodnotenieList[i].HodnoteniePopis;
        }

        return null;
    }

    private void SetFields( Jazyk jazyk )
    {
        List<JazykHodnotenie> jazykHodnotenieList = JazykHodnotenieDAL.Select();

        TB_Language.Text = jazyk.Nazov;
        TB_Interaction.Text = FindRateString( jazykHodnotenieList, jazyk.HovorenieInterakcia );
        TB_Listening.Text= FindRateString( jazykHodnotenieList, jazyk.PorozumeniePocuvanie );
        TB_Reading.Text = FindRateString( jazykHodnotenieList, jazyk.PorozumenieCitanie );
        TB_Speach.Text = FindRateString( jazykHodnotenieList, jazyk.HovoreniePrejav );
        TB_Writing.Text = FindRateString( jazykHodnotenieList, jazyk.Pisanie );
    }

    protected void GV_Languages_RowSelecting(object sender, GridViewSelectEventArgs e)
    {
        int id = Convert.ToInt32( GV_Languages.DataKeys[e.NewSelectedIndex].Value );

        jazyk = JazykDAL.SelectById( id );

        SetFields( jazyk );
    }
}
