<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ViewProjectListUC.ascx.cs" Inherits="ViewProjectListUC" %>
<%@ Register Src="~/Controls/ShowEmptyUC.ascx" TagName="ShowEmptyControl" TagPrefix="uc" %>

<asp:GridView ID="GV_Projects" runat="server" AllowPaging="True" AllowSorting="True"
    AutoGenerateColumns="False" CssClass="List_GridView" DataKeyNames="Id" DataSourceID="ODS_Projects"
    OnSelectedIndexChanging="GV_Projects_RowSelecting" SkinID="Skin_GridView">
    <Columns>
        <asp:BoundField DataField="Nazov" HeaderText="N&#225;zov" SortExpression="Nazov">
            <ItemStyle Width="350px" />
        </asp:BoundField>
        <asp:BoundField DataField="DatumVypracovania" DataFormatString="{0:dd.MM.yyyy}" HeaderText="Vypracovan&#253;"
            HtmlEncode="False" SortExpression="DatumVypracovania">
            <ItemStyle Width="100px" />
        </asp:BoundField>
        <asp:CommandField DeleteText="Zma" EditText="Uprav" SelectText="Vyber" ShowSelectButton="True">
            <ItemStyle CssClass="List_GridView_Command" />
        </asp:CommandField>
    </Columns>
    <EmptyDataTemplate>
        <uc:ShowEmptyControl ID="UC_EC_NoData" Message="iadne projekty" runat="server" />
    </EmptyDataTemplate>
</asp:GridView>
<asp:ObjectDataSource ID="ODS_Projects" runat="server" DataObjectTypeName="Projekt"
    DeleteMethod="Delete" EnablePaging="True" InsertMethod="Insert" OldValuesParameterFormatString="original_{0}"
    SelectCountMethod="SelectCountByOsobaId" SelectMethod="SelectByOsobaIdPagedSorted" SortParameterName="sortExpression"
    TypeName="ProjektBLL" UpdateMethod="Update">
    <SelectParameters>
        <asp:Parameter Name="osobaId" Type="Int32" />
    </SelectParameters>
</asp:ObjectDataSource>
