using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class ViewQuestionUC : System.Web.UI.UserControl
{
    private int questionId;
    private int instanceId;
    private Otazka otazka;
    private List<MozneOdpovede> mozneOdpovedeList;

    public int QuestionId
    {
        get { return questionId; }
        set { questionId = value; }
    }

    public int InstanceId
    {
        get { return instanceId; }
        set { instanceId = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        otazka = OtazkaDAL.SelectById( questionId );

        if( otazka != null )
        {
            mozneOdpovedeList = MozneOdpovedeDAL.SelectByOtazkaId( questionId );

            if( ( otazka.TypOdpovede == 0 || otazka.TypOdpovede == 1 ) && mozneOdpovedeList.Count < 2 ) return;
            if( ( otazka.TypOdpovede == 2 ) && mozneOdpovedeList.Count < 1 ) return;

            this.Controls.Add( new LiteralControl("<table class=\"Question_Table\">") );
            this.Controls.Add( new LiteralControl("<tr>") );
            this.Controls.Add( new LiteralControl("<td colspan=\"2\">") );
            this.Controls.Add( new LiteralControl("<span><b>" + otazka.TextOtazky + "</b></span>") );
            this.Controls.Add( new LiteralControl("</td>") );
            this.Controls.Add( new LiteralControl("</tr>") );

            switch ( otazka.TypOdpovede )
            {
                case 0: InsertCheckBoxes(); break;
                case 1: InsertRadioButtons(); break;
                case 2: InsertTextBoxes(); break;
                default: return;
            }

            this.Controls.Add( new LiteralControl("</table>") );
        }
    }

    public bool CanSave()
    {
        switch ( otazka.TypOdpovede )
        {
            case 0: return ChanSaveCheckBoxes();
            case 1: return ChanSaveRadioButtons();
            case 2: return ChanSaveTextBoxes();
            default: return false;
        }
    }

    private bool ChanSaveCheckBoxes()
    {
        bool canSave = false;
        CheckBoxList checkBoxList = (CheckBoxList)FindControl("CBL_Choices");

        for( int i = 0; i < checkBoxList.Items.Count; i++)
        {
            if( checkBoxList.Items[i].Selected ) canSave = true;
        }

        if( otazka.Ine != string.Empty && checkBoxList.Items[checkBoxList.Items.Count - 1].Selected == true )
        {
            TextBox textBox = (TextBox)FindControl("TB_Other");

            if( textBox.Text.Trim() == string.Empty ) canSave = false;
            else canSave = true;
        }

        return canSave;
    }

    private bool ChanSaveRadioButtons()
    {
        bool canSave = false;
        RadioButtonList radioButtonList = (RadioButtonList)FindControl("RBL_Choices");

        for( int i = 0; i < radioButtonList.Items.Count; i++)
        {
            if( radioButtonList.Items[i].Selected ) canSave = true;
        }

        if( otazka.Ine != string.Empty && radioButtonList.Items[radioButtonList.Items.Count - 1].Selected == true )
        {
            TextBox textBox = (TextBox)FindControl("TB_Other");

            if( textBox.Text.Trim() == string.Empty ) canSave = false;
            else canSave = true;
        }

        return canSave;
    }

    private bool ChanSaveTextBoxes() 
    {
        TextBox textBox;

        for( int i = 0; i < this.Controls.Count; i++ )
        {
            if( this.Controls[i] is TextBox )
            {
                textBox = ((TextBox)this.Controls[i]);

                if( textBox.ID.StartsWith( "TB_Text_") )
                {
                    if( textBox.Text.Trim() == string.Empty ) return false;
                }
            }
        }

        return true;
    }
    
    public void SaveAnswer( int osobaId )
    {
        switch ( otazka.TypOdpovede )
        {
            case 0: SaveCheckBoxes( osobaId ); break;
            case 1: SaveRadioButtons( osobaId ); break;
            case 2: SaveTextBoxes( osobaId ); break;
            default: return;
        }
    }

    private void SaveCheckBoxes( int osobaId )
    {
        CheckBoxList checkBoxList = (CheckBoxList)FindControl("CBL_Choices");
        string answer = string.Empty;

        for( int i = 0; i < checkBoxList.Items.Count; i++)
        {
            if( checkBoxList.Items[i].Selected ) answer += i.ToString() + "\n";
        }

        if( otazka.Ine != string.Empty )
        {
            TextBox textbox = (TextBox)FindControl("TB_Other");
            answer += textbox.Text;
        }

        OdpovedDAL.Insert( new Odpoved( 0, instanceId , osobaId, otazka.Id, answer ) );
    }

    private void SaveRadioButtons( int osobaId )
    {
        RadioButtonList radioButtonList = (RadioButtonList)FindControl("RBL_Choices");
        string answer = string.Empty;

        for( int i = 0; i < radioButtonList.Items.Count; i++)
        {
            if( radioButtonList.Items[i].Selected ) answer += i.ToString() + "\n";
        }

        if( otazka.Ine != string.Empty )
        {
            TextBox textbox = (TextBox)FindControl("TB_Other");
            answer += textbox.Text;
        }

        OdpovedDAL.Insert( new Odpoved( 0, instanceId , osobaId, otazka.Id, answer ) );
    }

    private void SaveTextBoxes( int osobaId )
    {
        string answer = string.Empty;

        TextBox textBox;

        for( int i = 0; i < this.Controls.Count; i++ )
        {
            if( this.Controls[i] is TextBox )
            {
                textBox = ((TextBox)this.Controls[i]);

                if( textBox.ID.StartsWith( "TB_Text_") )
                {
                    answer += textBox.Text + "\n";
                }
            }
        }

        OdpovedDAL.Insert( new Odpoved( 0, instanceId , osobaId, otazka.Id, answer ) );
    }

    private void InsertCheckBoxes()
    {
        CheckBoxList checkBoxList = new CheckBoxList();
        checkBoxList.ID = "CBL_Choices";

        for( int i = 0; i < mozneOdpovedeList.Count; i++ )
        {
            checkBoxList.Items.Add( new ListItem( mozneOdpovedeList[i].Text ) );
        }

        this.Controls.Add( new LiteralControl("<tr>") );
        this.Controls.Add( new LiteralControl("<td colspan=\"2\">") );      
        if( otazka.Ine != string.Empty )
        {
            TextBox textbox = new TextBox();
            textbox.ID = "TB_Other";
            textbox.CssClass = "Question_TextBox";

            checkBoxList.Items.Add( otazka.Ine );

            this.Controls.Add( checkBoxList );
            this.Controls.Add( textbox );

        }
        else this.Controls.Add( checkBoxList );
        this.Controls.Add( new LiteralControl("</td>") );
        this.Controls.Add( new LiteralControl("</tr>") );
    }

    private void InsertRadioButtons()
    {
        RadioButtonList radioButtonList = new RadioButtonList();
        radioButtonList.ID = "RBL_Choices";

        for( int i = 0; i < mozneOdpovedeList.Count; i++ )
        {
            radioButtonList.Items.Add( new ListItem( mozneOdpovedeList[i].Text ) );
        }

        this.Controls.Add( new LiteralControl("<tr>") );
        this.Controls.Add( new LiteralControl("<td colspan=\"2\">") );
        if( otazka.Ine != string.Empty )
        {
            TextBox textbox = new TextBox();
            textbox.ID = "TB_Other";
            textbox.CssClass = "Question_TextBox";

            radioButtonList.Items.Add( otazka.Ine );

            this.Controls.Add( radioButtonList );
            this.Controls.Add( textbox );

        }
        else this.Controls.Add( radioButtonList );
        this.Controls.Add( new LiteralControl("</td>") );
        this.Controls.Add( new LiteralControl("</tr>") );
    }

    private void InsertTextBoxes()
    {
        for( int i = 0; i < mozneOdpovedeList.Count; i++ )
        {
            this.Controls.Add( new LiteralControl("<tr>") );

            this.Controls.Add( new LiteralControl("<td>") );
            this.Controls.Add( new LiteralControl("<span>" + mozneOdpovedeList[i].Text + "</span>") );
            this.Controls.Add( new LiteralControl("</td>") );

            TextBox textbox = new TextBox();
            textbox.ID = "TB_Text_" + i.ToString();
            textbox.CssClass = "Question_TextBox";

            this.Controls.Add( new LiteralControl("<td>") );
            this.Controls.Add( textbox );
            this.Controls.Add( new LiteralControl("</td>") );

            if( i != mozneOdpovedeList.Count - 1 ) 
            {
                this.Controls.Add( new LiteralControl("<br />") );
            }

            this.Controls.Add( new LiteralControl("</tr>") );
        }  
    }
}
