using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ViewStudiesUC : System.Web.UI.UserControl
{
    private Osoba osoba = null;
    private Studium studium = null;

    public Osoba Data
    {
        get { return osoba; }
        set { osoba = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        ODS_Studies.SelectParameters["osobaId"].DefaultValue = osoba.Id.ToString();
    }

    private void SetFields( Studium studium )
    {
        TB_School.Text = studium.SkolaFK.Nazov;
        TB_Direction.Text = ( studium.SmerFK == null ? null : studium.SmerFK.Nazov );
        TB_Faculty.Text = studium.Fakulta;
        TB_Finished.Text = studium.DatumDo.HasValue ? studium.DatumDo.Value.ToShortDateString().Replace(" ","") : null;
        TB_Odbor.Text = studium.Odbor;
        TB_Started.Text = studium.DatumOd.ToShortDateString().Replace(" ", ""); 
        TB_Title.Text = studium.ZiskanyTitul;
    }

    protected void GV_Studies_RowSelecting(object sender, GridViewSelectEventArgs e)
    {
        int id = Convert.ToInt32( GV_Studies.DataKeys[e.NewSelectedIndex].Value );

        studium = StudiumDAL.SelectById( id );

        SetFields( studium );
    }
}
