--
-- PostgreSQL database dump
--

-- Started on 2008-05-19 15:11:33

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- TOC entry 5 (class 2615 OID 16404)
-- Name: alumni; Type: SCHEMA; Schema: -; Owner: admin
--

CREATE SCHEMA alumni;


ALTER SCHEMA alumni OWNER TO "admin";

--
-- TOC entry 1895 (class 0 OID 0)
-- Dependencies: 4
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: admin
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- TOC entry 338 (class 2612 OID 16386)
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: admin
--

CREATE PROCEDURAL LANGUAGE plpgsql;


SET search_path = alumni, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1344 (class 1259 OID 23279)
-- Dependencies: 5
-- Name: adresa; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE adresa (
    id integer NOT NULL,
    osoba_id integer,
    zamestnanie_id integer,
    ulica text NOT NULL,
    psc character varying(10) NOT NULL,
    mesto character varying(50) NOT NULL,
    stat_id integer NOT NULL
);


ALTER TABLE alumni.adresa OWNER TO "admin";

--
-- TOC entry 1343 (class 1259 OID 23277)
-- Dependencies: 1344 5
-- Name: adresa_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE adresa_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.adresa_id_seq OWNER TO "admin";

--
-- TOC entry 1897 (class 0 OID 0)
-- Dependencies: 1343
-- Name: adresa_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE adresa_id_seq OWNED BY adresa.id;


--
-- TOC entry 1898 (class 0 OID 0)
-- Dependencies: 1343
-- Name: adresa_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('adresa_id_seq', 1, true);


--
-- TOC entry 1346 (class 1259 OID 23289)
-- Dependencies: 1736 5
-- Name: anketa; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE anketa (
    id integer NOT NULL,
    nazov character varying(100) NOT NULL,
    mozno_upravit boolean DEFAULT true NOT NULL
);


ALTER TABLE alumni.anketa OWNER TO "admin";

--
-- TOC entry 1345 (class 1259 OID 23287)
-- Dependencies: 5 1346
-- Name: anketa_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE anketa_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.anketa_id_seq OWNER TO "admin";

--
-- TOC entry 1899 (class 0 OID 0)
-- Dependencies: 1345
-- Name: anketa_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE anketa_id_seq OWNED BY anketa.id;


--
-- TOC entry 1900 (class 0 OID 0)
-- Dependencies: 1345
-- Name: anketa_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('anketa_id_seq', 3, true);


--
-- TOC entry 1384 (class 1259 OID 23466)
-- Dependencies: 1763 5
-- Name: blacklist_sprava; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE blacklist_sprava (
    id integer NOT NULL,
    odosielatel_konto character varying(20) NOT NULL,
    prijemca_id integer NOT NULL,
    is_skupina boolean DEFAULT false NOT NULL
);


ALTER TABLE alumni.blacklist_sprava OWNER TO "admin";

--
-- TOC entry 1383 (class 1259 OID 23464)
-- Dependencies: 5 1384
-- Name: blacklist_sprava_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE blacklist_sprava_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.blacklist_sprava_id_seq OWNER TO "admin";

--
-- TOC entry 1901 (class 0 OID 0)
-- Dependencies: 1383
-- Name: blacklist_sprava_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE blacklist_sprava_id_seq OWNED BY blacklist_sprava.id;


--
-- TOC entry 1902 (class 0 OID 0)
-- Dependencies: 1383
-- Name: blacklist_sprava_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('blacklist_sprava_id_seq', 4, true);


--
-- TOC entry 1348 (class 1259 OID 23297)
-- Dependencies: 5
-- Name: instancia_ankety; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE instancia_ankety (
    id integer NOT NULL,
    anketa_id integer NOT NULL,
    datum_od date NOT NULL,
    datum_do date NOT NULL
);


ALTER TABLE alumni.instancia_ankety OWNER TO "admin";

--
-- TOC entry 1347 (class 1259 OID 23295)
-- Dependencies: 1348 5
-- Name: instancia_ankety_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE instancia_ankety_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.instancia_ankety_id_seq OWNER TO "admin";

--
-- TOC entry 1903 (class 0 OID 0)
-- Dependencies: 1347
-- Name: instancia_ankety_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE instancia_ankety_id_seq OWNED BY instancia_ankety.id;


--
-- TOC entry 1904 (class 0 OID 0)
-- Dependencies: 1347
-- Name: instancia_ankety_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('instancia_ankety_id_seq', 4, true);


--
-- TOC entry 1350 (class 1259 OID 23304)
-- Dependencies: 1739 1740 1741 1742 1743 5
-- Name: jazyk; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE jazyk (
    id integer NOT NULL,
    osoba_id integer NOT NULL,
    porozumenie_pocuvanie integer DEFAULT 0 NOT NULL,
    porozumenie_citanie integer DEFAULT 0 NOT NULL,
    hovorenie_interakcia integer DEFAULT 0 NOT NULL,
    hovorenie_prejav integer DEFAULT 0 NOT NULL,
    pisanie integer DEFAULT 0 NOT NULL,
    nazov character varying(30) NOT NULL
);


ALTER TABLE alumni.jazyk OWNER TO "admin";

--
-- TOC entry 1352 (class 1259 OID 23316)
-- Dependencies: 5
-- Name: jazyk_hodnotenie; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE jazyk_hodnotenie (
    id integer NOT NULL,
    hodnotenie_skupina character(2) NOT NULL,
    hodnotenie_popis text
);


ALTER TABLE alumni.jazyk_hodnotenie OWNER TO "admin";

--
-- TOC entry 1351 (class 1259 OID 23314)
-- Dependencies: 5 1352
-- Name: jazyk_hodnotenie_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE jazyk_hodnotenie_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.jazyk_hodnotenie_id_seq OWNER TO "admin";

--
-- TOC entry 1905 (class 0 OID 0)
-- Dependencies: 1351
-- Name: jazyk_hodnotenie_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE jazyk_hodnotenie_id_seq OWNED BY jazyk_hodnotenie.id;


--
-- TOC entry 1906 (class 0 OID 0)
-- Dependencies: 1351
-- Name: jazyk_hodnotenie_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('jazyk_hodnotenie_id_seq', 6, true);


--
-- TOC entry 1349 (class 1259 OID 23302)
-- Dependencies: 1350 5
-- Name: jazyk_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE jazyk_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.jazyk_id_seq OWNER TO "admin";

--
-- TOC entry 1907 (class 0 OID 0)
-- Dependencies: 1349
-- Name: jazyk_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE jazyk_id_seq OWNED BY jazyk.id;


--
-- TOC entry 1908 (class 0 OID 0)
-- Dependencies: 1349
-- Name: jazyk_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('jazyk_id_seq', 1, true);


--
-- TOC entry 1354 (class 1259 OID 23326)
-- Dependencies: 5
-- Name: kurz; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE kurz (
    id integer NOT NULL,
    nazov character varying(100) NOT NULL,
    datum_od date,
    datum_do date,
    poznamka text,
    osoba_id integer NOT NULL
);


ALTER TABLE alumni.kurz OWNER TO "admin";

--
-- TOC entry 1353 (class 1259 OID 23324)
-- Dependencies: 1354 5
-- Name: kurz_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE kurz_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.kurz_id_seq OWNER TO "admin";

--
-- TOC entry 1909 (class 0 OID 0)
-- Dependencies: 1353
-- Name: kurz_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE kurz_id_seq OWNED BY kurz.id;


--
-- TOC entry 1910 (class 0 OID 0)
-- Dependencies: 1353
-- Name: kurz_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('kurz_id_seq', 1, false);


--
-- TOC entry 1356 (class 1259 OID 23336)
-- Dependencies: 5
-- Name: mozne_odpovede; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE mozne_odpovede (
    id integer NOT NULL,
    text text NOT NULL,
    otazka_id integer NOT NULL
);


ALTER TABLE alumni.mozne_odpovede OWNER TO "admin";

--
-- TOC entry 1355 (class 1259 OID 23334)
-- Dependencies: 5 1356
-- Name: mozne_odpovede_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE mozne_odpovede_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.mozne_odpovede_id_seq OWNER TO "admin";

--
-- TOC entry 1911 (class 0 OID 0)
-- Dependencies: 1355
-- Name: mozne_odpovede_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE mozne_odpovede_id_seq OWNED BY mozne_odpovede.id;


--
-- TOC entry 1912 (class 0 OID 0)
-- Dependencies: 1355
-- Name: mozne_odpovede_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('mozne_odpovede_id_seq', 10, true);


--
-- TOC entry 1358 (class 1259 OID 23346)
-- Dependencies: 5
-- Name: obmedzenie; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE obmedzenie (
    id integer NOT NULL,
    typ_osoby_id integer NOT NULL,
    operacia_id integer NOT NULL,
    objekt_obmedzenia integer NOT NULL
);


ALTER TABLE alumni.obmedzenie OWNER TO "admin";

--
-- TOC entry 1357 (class 1259 OID 23344)
-- Dependencies: 5 1358
-- Name: obmedzenie_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE obmedzenie_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.obmedzenie_id_seq OWNER TO "admin";

--
-- TOC entry 1913 (class 0 OID 0)
-- Dependencies: 1357
-- Name: obmedzenie_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE obmedzenie_id_seq OWNED BY obmedzenie.id;


--
-- TOC entry 1914 (class 0 OID 0)
-- Dependencies: 1357
-- Name: obmedzenie_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('obmedzenie_id_seq', 1, false);


--
-- TOC entry 1360 (class 1259 OID 23353)
-- Dependencies: 5
-- Name: odpoved; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE odpoved (
    id integer NOT NULL,
    instancia_ankety_id integer NOT NULL,
    osoba_id integer NOT NULL,
    otazka_id integer NOT NULL,
    text_odpovede text NOT NULL
);


ALTER TABLE alumni.odpoved OWNER TO "admin";

--
-- TOC entry 1359 (class 1259 OID 23351)
-- Dependencies: 1360 5
-- Name: odpoved_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE odpoved_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.odpoved_id_seq OWNER TO "admin";

--
-- TOC entry 1915 (class 0 OID 0)
-- Dependencies: 1359
-- Name: odpoved_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE odpoved_id_seq OWNED BY odpoved.id;


--
-- TOC entry 1916 (class 0 OID 0)
-- Dependencies: 1359
-- Name: odpoved_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('odpoved_id_seq', 6, true);


--
-- TOC entry 1362 (class 1259 OID 23363)
-- Dependencies: 5
-- Name: odvetvie; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE odvetvie (
    id integer NOT NULL,
    nazov character varying(50) NOT NULL
);


ALTER TABLE alumni.odvetvie OWNER TO "admin";

--
-- TOC entry 1361 (class 1259 OID 23361)
-- Dependencies: 1362 5
-- Name: odvetvie_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE odvetvie_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.odvetvie_id_seq OWNER TO "admin";

--
-- TOC entry 1917 (class 0 OID 0)
-- Dependencies: 1361
-- Name: odvetvie_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE odvetvie_id_seq OWNED BY odvetvie.id;


--
-- TOC entry 1918 (class 0 OID 0)
-- Dependencies: 1361
-- Name: odvetvie_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('odvetvie_id_seq', 2, true);


--
-- TOC entry 1364 (class 1259 OID 23370)
-- Dependencies: 5
-- Name: operacia; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE operacia (
    id integer NOT NULL,
    nazov character varying(20) NOT NULL
);


ALTER TABLE alumni.operacia OWNER TO "admin";

--
-- TOC entry 1363 (class 1259 OID 23368)
-- Dependencies: 1364 5
-- Name: operacia_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE operacia_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.operacia_id_seq OWNER TO "admin";

--
-- TOC entry 1919 (class 0 OID 0)
-- Dependencies: 1363
-- Name: operacia_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE operacia_id_seq OWNED BY operacia.id;


--
-- TOC entry 1920 (class 0 OID 0)
-- Dependencies: 1363
-- Name: operacia_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('operacia_id_seq', 1, false);


--
-- TOC entry 1366 (class 1259 OID 23377)
-- Dependencies: 1752 5
-- Name: osoba; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE osoba (
    id integer NOT NULL,
    typ_osoby_id integer NOT NULL,
    konto character varying(20) NOT NULL,
    konto_aktivne boolean DEFAULT true NOT NULL,
    heslo character varying(512) NOT NULL,
    posledne_prihlasenie timestamp without time zone,
    posledna_ip inet,
    meno character varying(20) NOT NULL,
    tituly character varying(20),
    priezvisko character varying(20) NOT NULL,
    rodne_priezvisko character varying(20),
    statna_prislusnost character varying(20),
    materinsky_jazyk character varying(20),
    telefon character varying(20),
    mobil character varying(20),
    fax character varying(20),
    msn character varying(50),
    email character varying(50) NOT NULL,
    web text,
    pohlavie character varying(4),
    datum_narodenia date NOT NULL,
    rok_absolvovania integer,
    zivotopis_ine text,
    icq character varying(10),
    skype text,
    socialne_zrucnosti text,
    organizacne_zrucnosti text,
    technicke_zrucnosti text,
    pocitacove_zrucnosti text,
    umelecke_zrucnosti text,
    dalsie_zrucnosti text,
    vodicsky_preukaz character varying(50)
);


ALTER TABLE alumni.osoba OWNER TO "admin";

--
-- TOC entry 1365 (class 1259 OID 23375)
-- Dependencies: 1366 5
-- Name: osoba_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE osoba_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.osoba_id_seq OWNER TO "admin";

--
-- TOC entry 1921 (class 0 OID 0)
-- Dependencies: 1365
-- Name: osoba_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE osoba_id_seq OWNED BY osoba.id;


--
-- TOC entry 1922 (class 0 OID 0)
-- Dependencies: 1365
-- Name: osoba_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('osoba_id_seq', 10, true);


--
-- TOC entry 1368 (class 1259 OID 23392)
-- Dependencies: 5
-- Name: otazka; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE otazka (
    id integer NOT NULL,
    text_otazky text NOT NULL,
    typ_odpovede smallint NOT NULL,
    ine character varying(50),
    anketa_id integer NOT NULL
);


ALTER TABLE alumni.otazka OWNER TO "admin";

--
-- TOC entry 1367 (class 1259 OID 23390)
-- Dependencies: 5 1368
-- Name: otazka_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE otazka_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.otazka_id_seq OWNER TO "admin";

--
-- TOC entry 1923 (class 0 OID 0)
-- Dependencies: 1367
-- Name: otazka_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE otazka_id_seq OWNED BY otazka.id;


--
-- TOC entry 1924 (class 0 OID 0)
-- Dependencies: 1367
-- Name: otazka_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('otazka_id_seq', 4, true);


--
-- TOC entry 1370 (class 1259 OID 23402)
-- Dependencies: 5
-- Name: oznam; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE oznam (
    id integer NOT NULL,
    osoba_id integer NOT NULL,
    nazov character varying(100) NOT NULL,
    datum_platnosti date NOT NULL,
    typ_oznamu_id integer NOT NULL,
    popis text NOT NULL
);


ALTER TABLE alumni.oznam OWNER TO "admin";

--
-- TOC entry 1369 (class 1259 OID 23400)
-- Dependencies: 5 1370
-- Name: oznam_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE oznam_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.oznam_id_seq OWNER TO "admin";

--
-- TOC entry 1925 (class 0 OID 0)
-- Dependencies: 1369
-- Name: oznam_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE oznam_id_seq OWNED BY oznam.id;


--
-- TOC entry 1926 (class 0 OID 0)
-- Dependencies: 1369
-- Name: oznam_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('oznam_id_seq', 4, true);


--
-- TOC entry 1372 (class 1259 OID 23412)
-- Dependencies: 1756 5
-- Name: pozicia_odvetvie; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE pozicia_odvetvie (
    id integer NOT NULL,
    pozicia character varying(50) NOT NULL,
    odvetvie_id integer DEFAULT 0 NOT NULL
);


ALTER TABLE alumni.pozicia_odvetvie OWNER TO "admin";

--
-- TOC entry 1371 (class 1259 OID 23410)
-- Dependencies: 1372 5
-- Name: pozicia_odvetvie_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE pozicia_odvetvie_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.pozicia_odvetvie_id_seq OWNER TO "admin";

--
-- TOC entry 1927 (class 0 OID 0)
-- Dependencies: 1371
-- Name: pozicia_odvetvie_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE pozicia_odvetvie_id_seq OWNED BY pozicia_odvetvie.id;


--
-- TOC entry 1928 (class 0 OID 0)
-- Dependencies: 1371
-- Name: pozicia_odvetvie_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('pozicia_odvetvie_id_seq', 4, true);


--
-- TOC entry 1374 (class 1259 OID 23420)
-- Dependencies: 5
-- Name: prispevok; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE prispevok (
    id integer NOT NULL,
    text text NOT NULL,
    cas timestamp with time zone NOT NULL,
    tema_id integer NOT NULL,
    osoba_id integer NOT NULL,
    predmet character varying(100)
);


ALTER TABLE alumni.prispevok OWNER TO "admin";

--
-- TOC entry 1373 (class 1259 OID 23418)
-- Dependencies: 5 1374
-- Name: prispevok_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE prispevok_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.prispevok_id_seq OWNER TO "admin";

--
-- TOC entry 1929 (class 0 OID 0)
-- Dependencies: 1373
-- Name: prispevok_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE prispevok_id_seq OWNED BY prispevok.id;


--
-- TOC entry 1930 (class 0 OID 0)
-- Dependencies: 1373
-- Name: prispevok_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('prispevok_id_seq', 1, false);


--
-- TOC entry 1376 (class 1259 OID 23430)
-- Dependencies: 5
-- Name: projekt; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE projekt (
    id integer NOT NULL,
    osoba_id integer NOT NULL,
    job_id integer,
    studium_id integer,
    nazov character varying(100) NOT NULL,
    abstrakt text,
    veduci character varying(50),
    klucove_slova text NOT NULL,
    datum_vypracovania date NOT NULL,
    www_odkaz text,
    poznamka text
);


ALTER TABLE alumni.projekt OWNER TO "admin";

--
-- TOC entry 1375 (class 1259 OID 23428)
-- Dependencies: 1376 5
-- Name: projekt_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE projekt_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.projekt_id_seq OWNER TO "admin";

--
-- TOC entry 1931 (class 0 OID 0)
-- Dependencies: 1375
-- Name: projekt_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE projekt_id_seq OWNED BY projekt.id;


--
-- TOC entry 1932 (class 0 OID 0)
-- Dependencies: 1375
-- Name: projekt_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('projekt_id_seq', 3, true);


--
-- TOC entry 1378 (class 1259 OID 23440)
-- Dependencies: 5
-- Name: registracia; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE registracia (
    id integer NOT NULL,
    email character varying(50) NOT NULL,
    heslo character varying(512) NOT NULL,
    meno character varying(20) NOT NULL,
    priezvisko character varying(20) NOT NULL,
    datum_narodenia date NOT NULL,
    rok_absolvovania integer,
    typ_registracie_id integer NOT NULL
);


ALTER TABLE alumni.registracia OWNER TO "admin";

--
-- TOC entry 1377 (class 1259 OID 23438)
-- Dependencies: 1378 5
-- Name: registracia_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE registracia_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.registracia_id_seq OWNER TO "admin";

--
-- TOC entry 1933 (class 0 OID 0)
-- Dependencies: 1377
-- Name: registracia_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE registracia_id_seq OWNED BY registracia.id;


--
-- TOC entry 1934 (class 0 OID 0)
-- Dependencies: 1377
-- Name: registracia_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('registracia_id_seq', 5, true);


--
-- TOC entry 1380 (class 1259 OID 23452)
-- Dependencies: 5
-- Name: skola; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE skola (
    id integer NOT NULL,
    nazov character varying(255) NOT NULL
);


ALTER TABLE alumni.skola OWNER TO "admin";

--
-- TOC entry 1379 (class 1259 OID 23450)
-- Dependencies: 5 1380
-- Name: skola_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE skola_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.skola_id_seq OWNER TO "admin";

--
-- TOC entry 1935 (class 0 OID 0)
-- Dependencies: 1379
-- Name: skola_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE skola_id_seq OWNED BY skola.id;


--
-- TOC entry 1936 (class 0 OID 0)
-- Dependencies: 1379
-- Name: skola_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('skola_id_seq', 33, true);


--
-- TOC entry 1388 (class 1259 OID 23488)
-- Dependencies: 1766 1767 1768 1769 1770 1771 1772 5
-- Name: sprava; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE sprava (
    id integer NOT NULL,
    odosielatel_id integer NOT NULL,
    prijemca_id integer NOT NULL,
    cas timestamp with time zone NOT NULL,
    predmet character varying(100),
    text text,
    precitana boolean DEFAULT false NOT NULL,
    odosielatel_kos boolean DEFAULT false NOT NULL,
    prijemca_kos boolean DEFAULT false NOT NULL,
    odosielatel_zmazana boolean DEFAULT false NOT NULL,
    prijemca_zmazana boolean DEFAULT false NOT NULL,
    notifikovat boolean DEFAULT true NOT NULL,
    typ_spravy_id integer DEFAULT 1 NOT NULL
);


ALTER TABLE alumni.sprava OWNER TO "admin";

--
-- TOC entry 1387 (class 1259 OID 23486)
-- Dependencies: 5 1388
-- Name: sprava_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE sprava_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.sprava_id_seq OWNER TO "admin";

--
-- TOC entry 1937 (class 0 OID 0)
-- Dependencies: 1387
-- Name: sprava_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE sprava_id_seq OWNED BY sprava.id;


--
-- TOC entry 1938 (class 0 OID 0)
-- Dependencies: 1387
-- Name: sprava_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('sprava_id_seq', 5, true);


--
-- TOC entry 1389 (class 1259 OID 23508)
-- Dependencies: 1773 1774 1775 1776 1777 1778 1779 1780 1388 5
-- Name: skupinova_sprava; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE skupinova_sprava (
    prijemca_skup character varying(50) NOT NULL
)
INHERITS (sprava);


ALTER TABLE alumni.skupinova_sprava OWNER TO "admin";

--
-- TOC entry 1382 (class 1259 OID 23459)
-- Dependencies: 5
-- Name: smer; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE smer (
    id integer NOT NULL,
    nazov character varying(50) NOT NULL
);


ALTER TABLE alumni.smer OWNER TO "admin";

--
-- TOC entry 1381 (class 1259 OID 23457)
-- Dependencies: 1382 5
-- Name: smer_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE smer_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.smer_id_seq OWNER TO "admin";

--
-- TOC entry 1939 (class 0 OID 0)
-- Dependencies: 1381
-- Name: smer_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE smer_id_seq OWNED BY smer.id;


--
-- TOC entry 1940 (class 0 OID 0)
-- Dependencies: 1381
-- Name: smer_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('smer_id_seq', 33, true);


--
-- TOC entry 1391 (class 1259 OID 23523)
-- Dependencies: 5
-- Name: stat; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE stat (
    id integer NOT NULL,
    nazov character varying(50) NOT NULL
);


ALTER TABLE alumni.stat OWNER TO "admin";

--
-- TOC entry 1390 (class 1259 OID 23521)
-- Dependencies: 5 1391
-- Name: stat_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE stat_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.stat_id_seq OWNER TO "admin";

--
-- TOC entry 1941 (class 0 OID 0)
-- Dependencies: 1390
-- Name: stat_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE stat_id_seq OWNED BY stat.id;


--
-- TOC entry 1942 (class 0 OID 0)
-- Dependencies: 1390
-- Name: stat_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('stat_id_seq', 246, true);


--
-- TOC entry 1393 (class 1259 OID 23530)
-- Dependencies: 1783 5
-- Name: studium; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE studium (
    id integer NOT NULL,
    osoba_id integer NOT NULL,
    skola_id integer NOT NULL,
    smer_id integer,
    stupen numeric(1,0) DEFAULT 1 NOT NULL,
    osobne_cislo numeric(15,0),
    datum_od date,
    datum_do date,
    prospech numeric(2,2),
    fakulta character varying(100),
    odbor character varying(50),
    typ_skoly numeric(2,0),
    ziskany_titul character varying(10)
);


ALTER TABLE alumni.studium OWNER TO "admin";

--
-- TOC entry 1392 (class 1259 OID 23528)
-- Dependencies: 5 1393
-- Name: studium_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE studium_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.studium_id_seq OWNER TO "admin";

--
-- TOC entry 1943 (class 0 OID 0)
-- Dependencies: 1392
-- Name: studium_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE studium_id_seq OWNED BY studium.id;


--
-- TOC entry 1944 (class 0 OID 0)
-- Dependencies: 1392
-- Name: studium_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('studium_id_seq', 1, true);


--
-- TOC entry 1395 (class 1259 OID 23538)
-- Dependencies: 1785 5
-- Name: tema; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE tema (
    id integer NOT NULL,
    nazov character varying(100) NOT NULL,
    popis text,
    cas timestamp with time zone NOT NULL,
    je_verejna boolean DEFAULT true NOT NULL,
    osoba_id integer NOT NULL,
    nadtema integer
);


ALTER TABLE alumni.tema OWNER TO "admin";

--
-- TOC entry 1394 (class 1259 OID 23536)
-- Dependencies: 5 1395
-- Name: tema_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE tema_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.tema_id_seq OWNER TO "admin";

--
-- TOC entry 1945 (class 0 OID 0)
-- Dependencies: 1394
-- Name: tema_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE tema_id_seq OWNED BY tema.id;


--
-- TOC entry 1946 (class 0 OID 0)
-- Dependencies: 1394
-- Name: tema_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('tema_id_seq', 1, false);


--
-- TOC entry 1397 (class 1259 OID 23549)
-- Dependencies: 5
-- Name: typ_osoby; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE typ_osoby (
    id integer NOT NULL,
    typ character varying(20) NOT NULL
);


ALTER TABLE alumni.typ_osoby OWNER TO "admin";

--
-- TOC entry 1396 (class 1259 OID 23547)
-- Dependencies: 5 1397
-- Name: typ_osoby_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE typ_osoby_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.typ_osoby_id_seq OWNER TO "admin";

--
-- TOC entry 1947 (class 0 OID 0)
-- Dependencies: 1396
-- Name: typ_osoby_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE typ_osoby_id_seq OWNED BY typ_osoby.id;


--
-- TOC entry 1948 (class 0 OID 0)
-- Dependencies: 1396
-- Name: typ_osoby_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('typ_osoby_id_seq', 4, true);


--
-- TOC entry 1399 (class 1259 OID 23556)
-- Dependencies: 5
-- Name: typ_oznamu; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE typ_oznamu (
    id integer NOT NULL,
    typ character varying(50) NOT NULL
);


ALTER TABLE alumni.typ_oznamu OWNER TO "admin";

--
-- TOC entry 1398 (class 1259 OID 23554)
-- Dependencies: 1399 5
-- Name: typ_oznamu_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE typ_oznamu_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.typ_oznamu_id_seq OWNER TO "admin";

--
-- TOC entry 1949 (class 0 OID 0)
-- Dependencies: 1398
-- Name: typ_oznamu_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE typ_oznamu_id_seq OWNED BY typ_oznamu.id;


--
-- TOC entry 1950 (class 0 OID 0)
-- Dependencies: 1398
-- Name: typ_oznamu_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('typ_oznamu_id_seq', 2, true);


--
-- TOC entry 1401 (class 1259 OID 23563)
-- Dependencies: 5
-- Name: typ_registracie; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE typ_registracie (
    id integer NOT NULL,
    typ character varying(30) NOT NULL
);


ALTER TABLE alumni.typ_registracie OWNER TO "admin";

--
-- TOC entry 1400 (class 1259 OID 23561)
-- Dependencies: 5 1401
-- Name: typ_registracie_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE typ_registracie_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.typ_registracie_id_seq OWNER TO "admin";

--
-- TOC entry 1951 (class 0 OID 0)
-- Dependencies: 1400
-- Name: typ_registracie_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE typ_registracie_id_seq OWNED BY typ_registracie.id;


--
-- TOC entry 1952 (class 0 OID 0)
-- Dependencies: 1400
-- Name: typ_registracie_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('typ_registracie_id_seq', 2, true);


--
-- TOC entry 1386 (class 1259 OID 23481)
-- Dependencies: 5
-- Name: typ_spravy; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE typ_spravy (
    id integer NOT NULL,
    typ character varying(20) NOT NULL
);


ALTER TABLE alumni.typ_spravy OWNER TO "admin";

--
-- TOC entry 1385 (class 1259 OID 23479)
-- Dependencies: 1386 5
-- Name: typ_spravy_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE typ_spravy_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.typ_spravy_id_seq OWNER TO "admin";

--
-- TOC entry 1953 (class 0 OID 0)
-- Dependencies: 1385
-- Name: typ_spravy_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE typ_spravy_id_seq OWNED BY typ_spravy.id;


--
-- TOC entry 1954 (class 0 OID 0)
-- Dependencies: 1385
-- Name: typ_spravy_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('typ_spravy_id_seq', 1, false);


--
-- TOC entry 1403 (class 1259 OID 23570)
-- Dependencies: 5
-- Name: zamestnanie; Type: TABLE; Schema: alumni; Owner: admin; Tablespace: 
--

CREATE TABLE zamestnanie (
    id integer NOT NULL,
    osoba_id integer NOT NULL,
    pozicia_odvetvie_id integer,
    datum_od date NOT NULL,
    datum_do date,
    nazov_firmy character varying(50) NOT NULL,
    poznamka text
);


ALTER TABLE alumni.zamestnanie OWNER TO "admin";

--
-- TOC entry 1402 (class 1259 OID 23568)
-- Dependencies: 1403 5
-- Name: zamestnanie_id_seq; Type: SEQUENCE; Schema: alumni; Owner: admin
--

CREATE SEQUENCE zamestnanie_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE alumni.zamestnanie_id_seq OWNER TO "admin";

--
-- TOC entry 1955 (class 0 OID 0)
-- Dependencies: 1402
-- Name: zamestnanie_id_seq; Type: SEQUENCE OWNED BY; Schema: alumni; Owner: admin
--

ALTER SEQUENCE zamestnanie_id_seq OWNED BY zamestnanie.id;


--
-- TOC entry 1956 (class 0 OID 0)
-- Dependencies: 1402
-- Name: zamestnanie_id_seq; Type: SEQUENCE SET; Schema: alumni; Owner: admin
--

SELECT pg_catalog.setval('zamestnanie_id_seq', 1, true);


--
-- TOC entry 1734 (class 2604 OID 23281)
-- Dependencies: 1343 1344 1344
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE adresa ALTER COLUMN id SET DEFAULT nextval('adresa_id_seq'::regclass);


--
-- TOC entry 1735 (class 2604 OID 23291)
-- Dependencies: 1345 1346 1346
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE anketa ALTER COLUMN id SET DEFAULT nextval('anketa_id_seq'::regclass);


--
-- TOC entry 1762 (class 2604 OID 23468)
-- Dependencies: 1383 1384 1384
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE blacklist_sprava ALTER COLUMN id SET DEFAULT nextval('blacklist_sprava_id_seq'::regclass);


--
-- TOC entry 1737 (class 2604 OID 23299)
-- Dependencies: 1348 1347 1348
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE instancia_ankety ALTER COLUMN id SET DEFAULT nextval('instancia_ankety_id_seq'::regclass);


--
-- TOC entry 1738 (class 2604 OID 23306)
-- Dependencies: 1349 1350 1350
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE jazyk ALTER COLUMN id SET DEFAULT nextval('jazyk_id_seq'::regclass);


--
-- TOC entry 1744 (class 2604 OID 23318)
-- Dependencies: 1352 1351 1352
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE jazyk_hodnotenie ALTER COLUMN id SET DEFAULT nextval('jazyk_hodnotenie_id_seq'::regclass);


--
-- TOC entry 1745 (class 2604 OID 23328)
-- Dependencies: 1353 1354 1354
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE kurz ALTER COLUMN id SET DEFAULT nextval('kurz_id_seq'::regclass);


--
-- TOC entry 1746 (class 2604 OID 23338)
-- Dependencies: 1356 1355 1356
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE mozne_odpovede ALTER COLUMN id SET DEFAULT nextval('mozne_odpovede_id_seq'::regclass);


--
-- TOC entry 1747 (class 2604 OID 23348)
-- Dependencies: 1358 1357 1358
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE obmedzenie ALTER COLUMN id SET DEFAULT nextval('obmedzenie_id_seq'::regclass);


--
-- TOC entry 1748 (class 2604 OID 23355)
-- Dependencies: 1359 1360 1360
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE odpoved ALTER COLUMN id SET DEFAULT nextval('odpoved_id_seq'::regclass);


--
-- TOC entry 1749 (class 2604 OID 23365)
-- Dependencies: 1361 1362 1362
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE odvetvie ALTER COLUMN id SET DEFAULT nextval('odvetvie_id_seq'::regclass);


--
-- TOC entry 1750 (class 2604 OID 23372)
-- Dependencies: 1363 1364 1364
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE operacia ALTER COLUMN id SET DEFAULT nextval('operacia_id_seq'::regclass);


--
-- TOC entry 1751 (class 2604 OID 23379)
-- Dependencies: 1365 1366 1366
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE osoba ALTER COLUMN id SET DEFAULT nextval('osoba_id_seq'::regclass);


--
-- TOC entry 1753 (class 2604 OID 23394)
-- Dependencies: 1367 1368 1368
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE otazka ALTER COLUMN id SET DEFAULT nextval('otazka_id_seq'::regclass);


--
-- TOC entry 1754 (class 2604 OID 23404)
-- Dependencies: 1369 1370 1370
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE oznam ALTER COLUMN id SET DEFAULT nextval('oznam_id_seq'::regclass);


--
-- TOC entry 1755 (class 2604 OID 23414)
-- Dependencies: 1371 1372 1372
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE pozicia_odvetvie ALTER COLUMN id SET DEFAULT nextval('pozicia_odvetvie_id_seq'::regclass);


--
-- TOC entry 1757 (class 2604 OID 23422)
-- Dependencies: 1373 1374 1374
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE prispevok ALTER COLUMN id SET DEFAULT nextval('prispevok_id_seq'::regclass);


--
-- TOC entry 1758 (class 2604 OID 23432)
-- Dependencies: 1375 1376 1376
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE projekt ALTER COLUMN id SET DEFAULT nextval('projekt_id_seq'::regclass);


--
-- TOC entry 1759 (class 2604 OID 23442)
-- Dependencies: 1377 1378 1378
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE registracia ALTER COLUMN id SET DEFAULT nextval('registracia_id_seq'::regclass);


--
-- TOC entry 1760 (class 2604 OID 23454)
-- Dependencies: 1379 1380 1380
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE skola ALTER COLUMN id SET DEFAULT nextval('skola_id_seq'::regclass);


--
-- TOC entry 1761 (class 2604 OID 23461)
-- Dependencies: 1381 1382 1382
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE smer ALTER COLUMN id SET DEFAULT nextval('smer_id_seq'::regclass);


--
-- TOC entry 1765 (class 2604 OID 23490)
-- Dependencies: 1387 1388 1388
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE sprava ALTER COLUMN id SET DEFAULT nextval('sprava_id_seq'::regclass);


--
-- TOC entry 1781 (class 2604 OID 23525)
-- Dependencies: 1390 1391 1391
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE stat ALTER COLUMN id SET DEFAULT nextval('stat_id_seq'::regclass);


--
-- TOC entry 1782 (class 2604 OID 23532)
-- Dependencies: 1392 1393 1393
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE studium ALTER COLUMN id SET DEFAULT nextval('studium_id_seq'::regclass);


--
-- TOC entry 1784 (class 2604 OID 23540)
-- Dependencies: 1395 1394 1395
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE tema ALTER COLUMN id SET DEFAULT nextval('tema_id_seq'::regclass);


--
-- TOC entry 1786 (class 2604 OID 23551)
-- Dependencies: 1396 1397 1397
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE typ_osoby ALTER COLUMN id SET DEFAULT nextval('typ_osoby_id_seq'::regclass);


--
-- TOC entry 1787 (class 2604 OID 23558)
-- Dependencies: 1399 1398 1399
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE typ_oznamu ALTER COLUMN id SET DEFAULT nextval('typ_oznamu_id_seq'::regclass);


--
-- TOC entry 1788 (class 2604 OID 23565)
-- Dependencies: 1400 1401 1401
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE typ_registracie ALTER COLUMN id SET DEFAULT nextval('typ_registracie_id_seq'::regclass);


--
-- TOC entry 1764 (class 2604 OID 23483)
-- Dependencies: 1385 1386 1386
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE typ_spravy ALTER COLUMN id SET DEFAULT nextval('typ_spravy_id_seq'::regclass);


--
-- TOC entry 1789 (class 2604 OID 23572)
-- Dependencies: 1402 1403 1403
-- Name: id; Type: DEFAULT; Schema: alumni; Owner: admin
--

ALTER TABLE zamestnanie ALTER COLUMN id SET DEFAULT nextval('zamestnanie_id_seq'::regclass);


--
-- TOC entry 1860 (class 0 OID 23279)
-- Dependencies: 1344
-- Data for Name: adresa; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY adresa (id, osoba_id, zamestnanie_id, ulica, psc, mesto, stat_id) FROM stdin;
1	4	\N	Via Appia	3333	Kocurkovo	220
\.


--
-- TOC entry 1861 (class 0 OID 23289)
-- Dependencies: 1346
-- Data for Name: anketa; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY anketa (id, nazov, mozno_upravit) FROM stdin;
1	hjgfjg	t
3	fdsh	f
2	Anketa B	f
\.


--
-- TOC entry 1880 (class 0 OID 23466)
-- Dependencies: 1384
-- Data for Name: blacklist_sprava; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY blacklist_sprava (id, odosielatel_konto, prijemca_id, is_skupina) FROM stdin;
3	student	10	f
4	fakultnik	10	f
\.


--
-- TOC entry 1862 (class 0 OID 23297)
-- Dependencies: 1348
-- Data for Name: instancia_ankety; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY instancia_ankety (id, anketa_id, datum_od, datum_do) FROM stdin;
1	2	2001-01-01	2050-01-01
2	3	2000-01-01	2009-01-01
3	3	2004-01-01	2008-05-13
4	2	2009-01-01	2009-05-15
\.


--
-- TOC entry 1863 (class 0 OID 23304)
-- Dependencies: 1350
-- Data for Name: jazyk; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY jazyk (id, osoba_id, porozumenie_pocuvanie, porozumenie_citanie, hovorenie_interakcia, hovorenie_prejav, pisanie, nazov) FROM stdin;
1	2	1	1	1	1	1	angolčtina
\.


--
-- TOC entry 1864 (class 0 OID 23316)
-- Dependencies: 1352
-- Data for Name: jazyk_hodnotenie; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY jazyk_hodnotenie (id, hodnotenie_skupina, hodnotenie_popis) FROM stdin;
1	A1	Používateľ základného jazyka
2	A2	Používateľ základného jazyka
3	B1	Samostatný používateľ
4	B2	Samostatný používateľ
5	C1	Skúsený používateľ
6	C2	Skúsený používateľ
\.


--
-- TOC entry 1865 (class 0 OID 23326)
-- Dependencies: 1354
-- Data for Name: kurz; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY kurz (id, nazov, datum_od, datum_do, poznamka, osoba_id) FROM stdin;
\.


--
-- TOC entry 1866 (class 0 OID 23336)
-- Dependencies: 1356
-- Data for Name: mozne_odpovede; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY mozne_odpovede (id, text, otazka_id) FROM stdin;
1	uytu	1
2	tutyu	1
3	uytu	1
4	ss	3
5	ss	3
6	sse	2
7	ere	2
8	1	4
9	2	4
10	3	4
\.


--
-- TOC entry 1867 (class 0 OID 23346)
-- Dependencies: 1358
-- Data for Name: obmedzenie; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY obmedzenie (id, typ_osoby_id, operacia_id, objekt_obmedzenia) FROM stdin;
\.


--
-- TOC entry 1868 (class 0 OID 23353)
-- Dependencies: 1360
-- Data for Name: odpoved; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY odpoved (id, instancia_ankety_id, osoba_id, otazka_id, text_odpovede) FROM stdin;
1	1	10	2	1\n
2	1	10	3	ss\nss\n
3	2	4	4	1\n3\nfdsfds
4	2	10	4	0\n3\nss
5	1	4	2	0\n
6	1	4	3	sf\nbla bla sldkfja d sa dfjasdf sd.fsad falsdf asdfas: sldkfjasld sdfjsd O W 8**\n
\.


--
-- TOC entry 1869 (class 0 OID 23363)
-- Dependencies: 1362
-- Data for Name: odvetvie; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY odvetvie (id, nazov) FROM stdin;
1	Informatika
2	Softvérový inžinierstvo
\.


--
-- TOC entry 1870 (class 0 OID 23370)
-- Dependencies: 1364
-- Data for Name: operacia; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY operacia (id, nazov) FROM stdin;
\.


--
-- TOC entry 1871 (class 0 OID 23377)
-- Dependencies: 1366
-- Data for Name: osoba; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY osoba (id, typ_osoby_id, konto, konto_aktivne, heslo, posledne_prihlasenie, posledna_ip, meno, tituly, priezvisko, rodne_priezvisko, statna_prislusnost, materinsky_jazyk, telefon, mobil, fax, msn, email, web, pohlavie, datum_narodenia, rok_absolvovania, zivotopis_ine, icq, skype, socialne_zrucnosti, organizacne_zrucnosti, technicke_zrucnosti, pocitacove_zrucnosti, umelecke_zrucnosti, dalsie_zrucnosti, vodicsky_preukaz) FROM stdin;
5	1	xmajan	t	Jpr0bDudnGMZNZhRVNFIkEy2H+8nB/G6IL72I2tx7sJwFr9fk+uUJCqIpgGTQ1qghi29FvfZ61thqNtII2yvgXkLYEsKevf7Ao4L7YA055SC	2008-04-30 18:30:18.14	127.0.0.1	Marian	Bc.	Majan	\N	\N	\N	\N	\N	\N	\N	majo@ynet.sk	\N	Muž	1986-08-02	2007	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
8	1	xmajercik	t	yPvQUet+UQyVoEQDQYMbk1n9mzHcMQEfZTZrW7knsuAsUoB8VTegR9oDMFeNo6ZkeN/sG9S2CNE+GQm5LAFdIwbGl5SzjvY+xQJM5lCe5L0lvnUD+UxnqQ==	\N	\N	Maroš	\N	Majerčík	\N	\N	\N	\N	\N	\N	\N	majercik@gmail.com	\N	\N	1984-09-03	2007	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
9	1	xmichalco	t	XOjQwWu12a/YoqUvepsV7I2OmicMejyQQ73/mee/Ymj2ZTT/d93mu+V8QLIgia6ReRoC4hzHy1B55ZueWZP+dhcEddRo78/e69oKRgMFti4i	\N	\N	Pavol	\N	Michalco	\N	\N	\N	\N	\N	\N	\N	michalco@gmail.com	\N	\N	1985-01-05	2004	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
3	2	absolvent	t	Pp+OaSS0MPzhKJ4i6oJ4ROEt6zynmHNEZ1/X1QNVqnrCV7AnG0El+vbLYC2xPmeg9YK7qqRLHy95PTw9tInmflPa6/sp8IKldkgyXyz2/yA=	2008-05-12 15:18:38.468	192.168.62.174	Absolvent	\N	Absolvent	\N	\N	\N	123456789	\N	\N	\N	absolvent@pobox.sk	www.mojweb.sk	muž	2000-01-01	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
10	1	xgarajj	t	FSDh6tm5lShGT2Q6FeG7lnxSqDT5DboXqhHrF97kEUeR4Q6RMlk+IEZsftBC1v7Y8BTplzrVyblYu6R1KNC4EJrG/Hte0wGLy3mzDj8eyCKUPzZaVx26DE4U/g==	2008-05-15 16:31:26.062	127.0.0.1	Dasdf	\N	Dsdsdfd	dsadsa	Sdas	dsadsa	\N	\N	\N	\N	jj@ss.sk	\N	\N	2008-02-29	\N	\N	\N	\N	sdgf[]3244ľ+čšľťčššščšťčšťššľť	fdasfd	fsdfsda	fsdfafd	safas	fsdafads	fsdafasd
1	4	admin	t	Pp+OaSS0MPzhKJ4i6oJ4ROEt6zynmHNEZ1/X1QNVqnrCV7AnG0El+vbLYC2xPmeg9YK7qqRLHy95PTw9tInmflPa6/sp8IKldkgyXyz2/yA=	2008-05-19 11:56:31.25	192.168.62.171	Admin		Admin	\N	\N	\N	123456789				admin@pobox.sk	www.mojweb.sk	Muž	2000-01-01	\N	\N		sk@sk.sk	xxxxxxxxxxxxxx	yyyyyyyyyyyyyyyy	rrrrrrrrrrrrrrrrrrr	yyyyyyyyyyyyyygggggg	nnnnnnnnnnnnnnn	,gkhkhkh kkhkh\nkhg\nk\nhgk\ngk\nhgk\nh\nkhg	khg khjkgh
2	3	fakultnik	t	Pp+OaSS0MPzhKJ4i6oJ4ROEt6zynmHNEZ1/X1QNVqnrCV7AnG0El+vbLYC2xPmeg9YK7qqRLHy95PTw9tInmflPa6/sp8IKldkgyXyz2/yA=	2008-05-19 12:27:00.015	192.168.62.171	Fakultnik	\N	Fakultnik	\N	\N	\N	123456789	\N	\N	\N	fakultnik@pobox.sk	www.mojweb.sk	muž	2000-01-01	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
4	1	student	t	Pp+OaSS0MPzhKJ4i6oJ4ROEt6zynmHNEZ1/X1QNVqnrCV7AnG0El+vbLYC2xPmeg9YK7qqRLHy95PTw9tInmflPa6/sp8IKldkgyXyz2/yA=	2008-05-19 12:27:52.14	192.168.62.171	Student	\N	Student	brn	SR	slov	123456789	\N	\N	\N	student@pobox.sk	www.mojweb.sk	Muž\n	2000-01-01	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N
\.


--
-- TOC entry 1872 (class 0 OID 23392)
-- Dependencies: 1368
-- Data for Name: otazka; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY otazka (id, text_otazky, typ_odpovede, ine, anketa_id) FROM stdin;
1	uytuty	0		1
3	Otazka 2	2		2
2	Otazka 4	1		2
4	dsfd	0	dsfsf	3
\.


--
-- TOC entry 1873 (class 0 OID 23402)
-- Dependencies: 1370
-- Data for Name: oznam; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY oznam (id, osoba_id, nazov, datum_platnosti, typ_oznamu_id, popis) FROM stdin;
3	4	xxx	2008-05-20	2	Podujatie zajtra o 9.00.
\.


--
-- TOC entry 1874 (class 0 OID 23412)
-- Dependencies: 1372
-- Data for Name: pozicia_odvetvie; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY pozicia_odvetvie (id, pozicia, odvetvie_id) FROM stdin;
1	Systémový administrátor	1
2	Databázový expert	1
3	Programátor	2
4	Analytik	2
\.


--
-- TOC entry 1875 (class 0 OID 23420)
-- Dependencies: 1374
-- Data for Name: prispevok; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY prispevok (id, text, cas, tema_id, osoba_id, predmet) FROM stdin;
\.


--
-- TOC entry 1876 (class 0 OID 23430)
-- Dependencies: 1376
-- Data for Name: projekt; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY projekt (id, osoba_id, job_id, studium_id, nazov, abstrakt, veduci, klucove_slova, datum_vypracovania, www_odkaz, poznamka) FROM stdin;
2	4	\N	\N	Niet ho	Abstraktny	NN	slovo1	2008-02-02	\N	pozn 1
\.


--
-- TOC entry 1877 (class 0 OID 23440)
-- Dependencies: 1378
-- Data for Name: registracia; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY registracia (id, email, heslo, meno, priezvisko, datum_narodenia, rok_absolvovania, typ_registracie_id) FROM stdin;
4	paf@post.sk	0g66emMJJeTihZ0rMq1sU8QMlHPd46neYSvuanaHw2wBlnNAk/dRhi6HzpBae6Xnsd1zB1pD+9JrKzxJSWAFla1uQuD/aVjerbjuuNaoOApLoqY=	Alojz	Alojz	2000-04-22	1998	1
\.


--
-- TOC entry 1878 (class 0 OID 23452)
-- Dependencies: 1380
-- Data for Name: skola; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY skola (id, nazov) FROM stdin;
1	Univerzita Komenského v Bratislave
2	Univerzita Pavla Jozefa Šafárika v Košiciach
3	Prešovská univerzita v Prešove
4	Univerzita sv. Cyrila a Metoda v Trnave
5	Univerzita veterinárskeho lekárstva v Košiciach
6	Univerzita Konštantína Filozofa v Nitre
7	Univerzita Mateja Bela v Banskej Bystrici
8	Trnavská univerzita v Trnave
9	Slovenská technická univerzita v Bratislave
10	Technická univerzita v Košiciach
11	Žilinská univerzita v Žiline
12	Trenčianska univerzita Alexandra Dubčeka v Trenčíne
13	Ekonomická univerzita v Bratislave
14	Slovenská poľnohospodárska univerzita v Nitre
15	Technická univerzita vo Zvolene
16	Vysoká škola múzických umení v Bratislave
17	Vysoká škola výtvarných umení v Bratislave
18	Akadémia umení v Banskej Bystrici
19	Katolícka univerzita v Ružomberku
20	Univerzita J. Selyeho v Komárne
21	Akadémia ozbrojených síl generála Milana Rastislava Štefánika v Liptovskom Mikuláši
22	Akadémia Policajného zboru v Bratislave
23	Slovenská zdravotnícka univerzita v Bratislave
24	Vysoká škola manažmentu v Trenčíne
25	Vysoká škola zdravotníctva a sociálnej práce sv. Alžbety v Bratislave, n. o.
26	Vysoká škola ekonómie a manažmentu verejnej správy v Bratislave
27	Bratislavská vysoká škola práva
28	Vysoká škola v Sládkovičove
29	Vysoká škola medzinárodného podnikania ISM Slovakia v Prešove
30	Stredoeurópska vysoká škola v Skalici
31	Dubnický technologický inštitút v Dubnici nad Váhom
32	Bratislavská medzinárodná škola liberálnych štúdií
33	Vysoká škola bezpečnostného manažérstva v Košiciach
\.


--
-- TOC entry 1883 (class 0 OID 23508)
-- Dependencies: 1389
-- Data for Name: skupinova_sprava; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY skupinova_sprava (id, odosielatel_id, prijemca_id, cas, predmet, text, precitana, odosielatel_kos, prijemca_kos, odosielatel_zmazana, prijemca_zmazana, notifikovat, typ_spravy_id, prijemca_skup) FROM stdin;
5	1	1	2008-05-19 12:14:07.718+02	Oznam	ahoj fakultník	f	f	f	f	f	t	2	typ:Fakultník
\.


--
-- TOC entry 1879 (class 0 OID 23459)
-- Dependencies: 1382
-- Data for Name: smer; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY smer (id, nazov) FROM stdin;
1	Architektúra / stavebníctvo
2	Baníctvo / materiály
3	Bio- vedy
4	Cestovný ruch
5	Chémia / biochémia / farmácia
6	Ekonómia/hospodárstvo
7	Filozofia
8	Fyzika
9	Geológia
10	História
11	Hudba
12	Informatika
13	Kulturológia
14	Linguistika
15	Literatúra
16	Matematika
17	Medicína
18	Mediálna komunikácia
19	Mediálna komunikácia / žurnalizmus
20	Meteorológia
21	Ochrana ž. p. / ekológia / spracovanie odpadov
22	Politológia
23	Poľnohospodárstvo a krajinné hospodárstvo
24	Právo
25	Psychológia
26	Sociológia
27	Spoločenské vedy
28	Technické vedy
29	Teológia
30	Umenie / design
31	Verejná správa
32	Vychovávateľstvo / pedagogika
33	Šport
\.


--
-- TOC entry 1882 (class 0 OID 23488)
-- Dependencies: 1388
-- Data for Name: sprava; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY sprava (id, odosielatel_id, prijemca_id, cas, predmet, text, precitana, odosielatel_kos, prijemca_kos, odosielatel_zmazana, prijemca_zmazana, notifikovat, typ_spravy_id) FROM stdin;
1	10	3	2008-05-13 09:52:13.968+02	<script>alert(1)</script>	<script>alert(1)</script>	f	f	f	f	f	t	1
2	10	1	2008-05-13 09:57:51.171+02	<script>alert(1)</script>	<script>alert(1)</script>	t	f	f	f	f	t	1
3	10	4	2008-05-15 11:33:20.625+02	;';';'	;';';'	f	f	f	f	f	t	1
4	1	2	2008-05-19 12:14:07.718+02	Oznam	ahoj fakultník	f	f	f	f	f	t	2
\.


--
-- TOC entry 1884 (class 0 OID 23523)
-- Dependencies: 1391
-- Data for Name: stat; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY stat (id, nazov) FROM stdin;
6	Afganistan
7	Alandy
8	Albánsko
9	Alžírsko
10	Americká Samoa
11	Americké Panenské ostrovy
12	Andorra
13	Angola
14	Anguilla
15	Antarktída
16	Antigua a Barbuda
17	Argentína
18	Arménsko
19	Aruba
20	Austrália
21	Azerbajdžan
22	Bahamy
23	Bahrajn
24	Bangladéš
25	Barbados
26	Belgicko
27	Belize
28	Benin
29	Bermudy
30	Bhután
31	Bielorusko
32	Bolívia
33	Bosna a Hercegovina
34	Botswana
35	Bouvetov ostrov
36	Brazília
37	Britské indickooceánske teritórium
38	Britské Panenské ostrovy
39	Brunei
40	Bulharsko
41	Burkina Faso
42	Burundi
43	Cookove ostrovy
44	Cyprus
45	Čad
46	Česko
47	Čile
48	Čínska ľudová republika
49	Dánsko
50	Dominika
51	Dominikánska republika
52	Džibutsko
53	Egypt
54	Ekvádor
55	Eritrea
56	Estónsko
57	Etiópia
58	Európska únia
59	Faerské ostrovy
60	Falklandy
61	Fidži
62	Filipíny
63	Fínsko
64	Francúzska Guyana
65	Francúzska Polynézia
66	Francúzske južné územia
67	Francúzsko
68	Gabon
69	Gambia
70	Ghana
71	Gibraltár
72	Grécko
73	Grenada
74	Grónsko
75	Gruzínsko
76	Guadeloupe
77	Guam
78	Guatemala
79	Guinea
80	Guinea-Bissau
81	Guyana
82	Haiti
83	Heard Island and McDonald Islands
84	Holandské Antily
85	Holandsko
86	Honduras
87	Hong Kong
88	Chorvátsko
89	India
90	Indonézia
91	Irak
92	Irán
93	Írsko
94	Island
95	Izrael
96	Jamajka
97	Japonsko
98	Jemen
99	Jordánsko
100	Južná Afrika
101	Južná Kórea
102	Kajmanské ostrovy
103	Kambodža
104	Kamerun
105	Kanada
106	Kapverdy
107	Katar
108	Kazachstan
109	Keňa
110	Kirgizsko
111	Kiribati
112	Kokosové ostrovy
113	Kolumbia
114	Komory
115	Konžská demokratická republika
116	Kostarika
117	Kuba
118	Kuvajt
119	Laos
120	Lesotho
121	Libanon
122	Libéria
123	Líbya
124	Lichtenštajnsko
125	Litva
126	Lotyšsko
127	Luxembursko
128	Macao
129	Macedónsko
130	Madagaskar
131	Maďarsko
132	Malajzia
133	Malawi
134	Maledivy
135	Mali
136	Malta
137	Maroko
138	Marshallove ostrovy
139	Martinik
140	Mauretánia
141	Maurícius
142	Mayotte
143	Mexiko
144	Mikronézia
145	Mjanmarsko
146	Moldavsko
147	Monako
148	Mongolsko
149	Montserrat
150	Mozambik
151	Namíbia
152	Nauru
153	Nemecko
154	Nepál
155	Niger
156	Nigéria
157	Nikaragua
158	Niue
159	Norfolk
160	Nórsko
161	Nová Kaledónia
162	Nový Zéland
163	Omán
164	Pakistan
165	Palau
166	Palestína
167	Panama
168	Papua Nová Guinea
169	Paraguaj
170	Peru
171	Pitcairn
172	Pobrežie Slonoviny
173	Poľsko
174	Portoriko
175	Portugalsko
176	Rakúsko
177	Republika Kongo
178	Réunion
179	Rovníková Guinea
180	Rumunsko
181	Rusko
182	Rwanda
183	Saint Pierre a Miquelon
184	Salvador
185	Samoa
186	San Maríno
187	Saudská Arábia
188	Senegal
189	Severná Kórea
190	Severné Mariany
191	Seychely
192	Sierra Leone
193	Singapur
194	Slovensko
195	Slovinsko
196	Somálsko
197	South Georgia and the South Sandwich Islands
198	Spojené arabské emiráty
199	Spojené kráľovstvo
200	Spojené štáty americké
201	Srbsko a Čierna Hora
202	Srí Lanka
203	Stredoafrická republika
204	Sudán
205	Surinam
206	Svalbard a Jan Mayen
207	Svätá Helena
208	Svätá Lucia
209	Svätý Krištof a Nevis
210	Svätý Tomáš a Princov ostrov
211	Svätý Vincent a Grenadíny
212	Svazijsko
213	Sýria
214	Šalamúnove ostrovy
215	Španielsko
216	Švajčiarsko
217	Švédsko
218	Tadžikistan
219	Taiwan
220	Taliansko
221	Tanzánia
222	Thajsko
223	Togo
224	Tokelau
225	Tonga
226	Trinidad a Tobago
227	Tunisko
228	Turecko
229	Turkmenistan
230	Turks a Caicos
231	Tuvalu
232	Uganda
233	Ukrajina
234	United States Minor Outlying Islands
235	Uruguaj
236	Uzbekistan
237	Vanuatu
238	Vatikán
239	Venezuela
240	Vianočný ostrov
241	Vietnam
242	Východný Timor
243	Wallis a Futuna
244	Zambia
245	Západná Sahara
246	Zimbabwe
\.


--
-- TOC entry 1885 (class 0 OID 23530)
-- Dependencies: 1393
-- Data for Name: studium; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY studium (id, osoba_id, skola_id, smer_id, stupen, osobne_cislo, datum_od, datum_do, prospech, fakulta, odbor, typ_skoly, ziskany_titul) FROM stdin;
1	4	1	1	0	\N	2004-01-01	2008-01-11	\N	Arch	Urbanistika	\N	
\.


--
-- TOC entry 1886 (class 0 OID 23538)
-- Dependencies: 1395
-- Data for Name: tema; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY tema (id, nazov, popis, cas, je_verejna, osoba_id, nadtema) FROM stdin;
\.


--
-- TOC entry 1887 (class 0 OID 23549)
-- Dependencies: 1397
-- Data for Name: typ_osoby; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY typ_osoby (id, typ) FROM stdin;
1	Študent
2	Absolvent
3	Fakultník
4	Administrátor
\.


--
-- TOC entry 1888 (class 0 OID 23556)
-- Dependencies: 1399
-- Data for Name: typ_oznamu; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY typ_oznamu (id, typ) FROM stdin;
1	Aktualita
2	Podujatie
3	Stretnutie
4	Inzerat
\.


--
-- TOC entry 1889 (class 0 OID 23563)
-- Dependencies: 1401
-- Data for Name: typ_registracie; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY typ_registracie (id, typ) FROM stdin;
1	Nová registrácia
2	Obnovenie účtu
\.


--
-- TOC entry 1881 (class 0 OID 23481)
-- Dependencies: 1386
-- Data for Name: typ_spravy; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY typ_spravy (id, typ) FROM stdin;
1	Normálna
2	Skupinová
\.


--
-- TOC entry 1890 (class 0 OID 23570)
-- Dependencies: 1403
-- Data for Name: zamestnanie; Type: TABLE DATA; Schema: alumni; Owner: admin
--

COPY zamestnanie (id, osoba_id, pozicia_odvetvie_id, datum_od, datum_do, nazov_firmy, poznamka) FROM stdin;
1	1	1	2000-01-01	2004-01-01	dfsf	dsgfgfdsg
\.


--
-- TOC entry 1791 (class 2606 OID 23286)
-- Dependencies: 1344 1344
-- Name: adresa_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY adresa
    ADD CONSTRAINT adresa_pkey PRIMARY KEY (id);


--
-- TOC entry 1793 (class 2606 OID 23294)
-- Dependencies: 1346 1346
-- Name: anketa_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY anketa
    ADD CONSTRAINT anketa_pkey PRIMARY KEY (id);


--
-- TOC entry 1837 (class 2606 OID 23473)
-- Dependencies: 1384 1384 1384 1384
-- Name: blacklist_sprava_odosielatel_id_key; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY blacklist_sprava
    ADD CONSTRAINT blacklist_sprava_odosielatel_id_key UNIQUE (odosielatel_konto, prijemca_id, is_skupina);


--
-- TOC entry 1839 (class 2606 OID 23471)
-- Dependencies: 1384 1384
-- Name: blacklist_sprava_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY blacklist_sprava
    ADD CONSTRAINT blacklist_sprava_pkey PRIMARY KEY (id);


--
-- TOC entry 1795 (class 2606 OID 23301)
-- Dependencies: 1348 1348
-- Name: instancia_ankety_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY instancia_ankety
    ADD CONSTRAINT instancia_ankety_pkey PRIMARY KEY (id);


--
-- TOC entry 1799 (class 2606 OID 23323)
-- Dependencies: 1352 1352
-- Name: jazyk_hodnotenie_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY jazyk_hodnotenie
    ADD CONSTRAINT jazyk_hodnotenie_pkey PRIMARY KEY (id);


--
-- TOC entry 1797 (class 2606 OID 23313)
-- Dependencies: 1350 1350
-- Name: jazyk_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY jazyk
    ADD CONSTRAINT jazyk_pkey PRIMARY KEY (id);


--
-- TOC entry 1801 (class 2606 OID 23333)
-- Dependencies: 1354 1354
-- Name: kurz_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY kurz
    ADD CONSTRAINT kurz_pkey PRIMARY KEY (id);


--
-- TOC entry 1803 (class 2606 OID 23343)
-- Dependencies: 1356 1356
-- Name: mozne_odpovede_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY mozne_odpovede
    ADD CONSTRAINT mozne_odpovede_pkey PRIMARY KEY (id);


--
-- TOC entry 1805 (class 2606 OID 23350)
-- Dependencies: 1358 1358
-- Name: obmedzenie_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY obmedzenie
    ADD CONSTRAINT obmedzenie_pkey PRIMARY KEY (id);


--
-- TOC entry 1807 (class 2606 OID 23360)
-- Dependencies: 1360 1360
-- Name: odpoved_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY odpoved
    ADD CONSTRAINT odpoved_pkey PRIMARY KEY (id);


--
-- TOC entry 1809 (class 2606 OID 23367)
-- Dependencies: 1362 1362
-- Name: odvetvie_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY odvetvie
    ADD CONSTRAINT odvetvie_pkey PRIMARY KEY (id);


--
-- TOC entry 1811 (class 2606 OID 23374)
-- Dependencies: 1364 1364
-- Name: operacia_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY operacia
    ADD CONSTRAINT operacia_pkey PRIMARY KEY (id);


--
-- TOC entry 1813 (class 2606 OID 23389)
-- Dependencies: 1366 1366
-- Name: osoba_email_key; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY osoba
    ADD CONSTRAINT osoba_email_key UNIQUE (email);


--
-- TOC entry 1815 (class 2606 OID 23387)
-- Dependencies: 1366 1366
-- Name: osoba_konto_key; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY osoba
    ADD CONSTRAINT osoba_konto_key UNIQUE (konto);


--
-- TOC entry 1817 (class 2606 OID 23385)
-- Dependencies: 1366 1366
-- Name: osoba_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY osoba
    ADD CONSTRAINT osoba_pkey PRIMARY KEY (id);


--
-- TOC entry 1819 (class 2606 OID 23399)
-- Dependencies: 1368 1368
-- Name: otazka_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY otazka
    ADD CONSTRAINT otazka_pkey PRIMARY KEY (id);


--
-- TOC entry 1821 (class 2606 OID 23409)
-- Dependencies: 1370 1370
-- Name: oznam_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY oznam
    ADD CONSTRAINT oznam_pkey PRIMARY KEY (id);


--
-- TOC entry 1823 (class 2606 OID 23417)
-- Dependencies: 1372 1372
-- Name: pozicia_odvetvie_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY pozicia_odvetvie
    ADD CONSTRAINT pozicia_odvetvie_pkey PRIMARY KEY (id);


--
-- TOC entry 1825 (class 2606 OID 23427)
-- Dependencies: 1374 1374
-- Name: prispevok_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY prispevok
    ADD CONSTRAINT prispevok_pkey PRIMARY KEY (id);


--
-- TOC entry 1827 (class 2606 OID 23437)
-- Dependencies: 1376 1376
-- Name: projekt_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY projekt
    ADD CONSTRAINT projekt_pkey PRIMARY KEY (id);


--
-- TOC entry 1829 (class 2606 OID 23449)
-- Dependencies: 1378 1378
-- Name: registracia_email_key; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY registracia
    ADD CONSTRAINT registracia_email_key UNIQUE (email);


--
-- TOC entry 1831 (class 2606 OID 23447)
-- Dependencies: 1378 1378
-- Name: registracia_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY registracia
    ADD CONSTRAINT registracia_pkey PRIMARY KEY (id);


--
-- TOC entry 1833 (class 2606 OID 23456)
-- Dependencies: 1380 1380
-- Name: skola_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY skola
    ADD CONSTRAINT skola_pkey PRIMARY KEY (id);


--
-- TOC entry 1835 (class 2606 OID 23463)
-- Dependencies: 1382 1382
-- Name: smer_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY smer
    ADD CONSTRAINT smer_pkey PRIMARY KEY (id);


--
-- TOC entry 1843 (class 2606 OID 23502)
-- Dependencies: 1388 1388
-- Name: sprava_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY sprava
    ADD CONSTRAINT sprava_pkey PRIMARY KEY (id);


--
-- TOC entry 1845 (class 2606 OID 23527)
-- Dependencies: 1391 1391
-- Name: stat_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY stat
    ADD CONSTRAINT stat_pkey PRIMARY KEY (id);


--
-- TOC entry 1847 (class 2606 OID 23535)
-- Dependencies: 1393 1393
-- Name: studium_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY studium
    ADD CONSTRAINT studium_pkey PRIMARY KEY (id);


--
-- TOC entry 1849 (class 2606 OID 23546)
-- Dependencies: 1395 1395
-- Name: tema_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY tema
    ADD CONSTRAINT tema_pkey PRIMARY KEY (id);


--
-- TOC entry 1851 (class 2606 OID 23553)
-- Dependencies: 1397 1397
-- Name: typ_osoby_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY typ_osoby
    ADD CONSTRAINT typ_osoby_pkey PRIMARY KEY (id);


--
-- TOC entry 1853 (class 2606 OID 23560)
-- Dependencies: 1399 1399
-- Name: typ_oznamu_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY typ_oznamu
    ADD CONSTRAINT typ_oznamu_pkey PRIMARY KEY (id);


--
-- TOC entry 1855 (class 2606 OID 23567)
-- Dependencies: 1401 1401
-- Name: typ_registracie_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY typ_registracie
    ADD CONSTRAINT typ_registracie_pkey PRIMARY KEY (id);


--
-- TOC entry 1841 (class 2606 OID 23485)
-- Dependencies: 1386 1386
-- Name: typ_spravy_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY typ_spravy
    ADD CONSTRAINT typ_spravy_pkey PRIMARY KEY (id);


--
-- TOC entry 1857 (class 2606 OID 23577)
-- Dependencies: 1403 1403
-- Name: zamestnanie_pkey; Type: CONSTRAINT; Schema: alumni; Owner: admin; Tablespace: 
--

ALTER TABLE ONLY zamestnanie
    ADD CONSTRAINT zamestnanie_pkey PRIMARY KEY (id);


--
-- TOC entry 1858 (class 2606 OID 23474)
-- Dependencies: 1384 1816 1366
-- Name: blacklist_sprava_prijemca_id_fkey; Type: FK CONSTRAINT; Schema: alumni; Owner: admin
--

ALTER TABLE ONLY blacklist_sprava
    ADD CONSTRAINT blacklist_sprava_prijemca_id_fkey FOREIGN KEY (prijemca_id) REFERENCES osoba(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 1859 (class 2606 OID 23503)
-- Dependencies: 1840 1386 1388
-- Name: sprava_typ_spravy_id_fkey; Type: FK CONSTRAINT; Schema: alumni; Owner: admin
--

ALTER TABLE ONLY sprava
    ADD CONSTRAINT sprava_typ_spravy_id_fkey FOREIGN KEY (typ_spravy_id) REFERENCES typ_spravy(id) ON UPDATE CASCADE ON DELETE SET DEFAULT;


--
-- TOC entry 1894 (class 0 OID 0)
-- Dependencies: 5
-- Name: alumni; Type: ACL; Schema: -; Owner: admin
--

REVOKE ALL ON SCHEMA alumni FROM PUBLIC;
REVOKE ALL ON SCHEMA alumni FROM "admin";
GRANT ALL ON SCHEMA alumni TO "admin";


--
-- TOC entry 1896 (class 0 OID 0)
-- Dependencies: 4
-- Name: public; Type: ACL; Schema: -; Owner: admin
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM "admin";
GRANT ALL ON SCHEMA public TO "admin";
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2008-05-19 15:11:33

--
-- PostgreSQL database dump complete
--

