using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class EditSurvey : System.Web.UI.Page
{
    private int id;
    private Anketa anketa;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ( ( id = Helper.QStringToInt32( Request["Id"] ) ) != 0 )
        {
            anketa = AnketaDAL.SelectById( id );

            if ( anketa != null )
            {
                    InsertSurvey();
            }
            else
            {
                InsertError();
            }
        }
        else
        {
            InsertError();
        }
    }

    private void InsertError()
    {
        ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
        showError.ID = "UC_EC_NoData";
        showError.ErrorText = "Anketa neexistuje";
        showError.BackText = "Nasp na zoznam ankiet";
        showError.BackUrl = "SurveyList.aspx";
        PH_Control.Controls.Add( showError );
    }

    private void InsertSurvey()
    {
        EditSurveyUC editSurvey = (EditSurveyUC)LoadControl("~/Controls/EditSurveyUC.ascx");
        editSurvey.ID = "UC_RC_Project";
        editSurvey.Data = anketa;
        PH_Control.Controls.Add( editSurvey );
    }
}
