using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        HideError();

        Page.Form.DefaultFocus = TB_Username.ClientID;
        Page.Form.DefaultButton = BN_Login.UniqueID;
    }

    public void HideError()
    {
        LA_Error.Visible = false;
    }

    public void ShowError( string text )
    {
        LA_Error.Text = text;
        LA_Error.Visible = true;
    }

    protected void BN_Login_Click(object sender, EventArgs e)
    {
        string username = TB_Username.Text;
        string password = TB_Password.Text;

        Osoba osoba = OsobaDAL.SelectByKonto( username );

        if ( osoba != null && CryptoManager.VerifyHash( password, "SHA512", osoba.Heslo ) )
        {
            Session["ldap_prihlaseny"] = null;
            if ( !osoba.KontoAktivne )
            {
                ShowError("Konto je zablokovan!");
                return;
            }

            osoba.PoslednaIp = Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
            if ( osoba.PoslednaIp == null ) osoba.PoslednaIp = Request.ServerVariables["REMOTE_ADDR"];

            osoba.PoslednePrihlasenie = DateTime.Now;

            OsobaDAL.Update( osoba );

            TypOsoby typOsoby = TypOsobyDAL.SelectById( osoba.TypOsobyId );

            FormsAuthenticationTicket authTicket = new FormsAuthenticationTicket( 1, username, DateTime.Now, DateTime.Now.AddMinutes( 15 ), false, osoba.Id + "|" + typOsoby.Typ );
            string encryptedTicket = FormsAuthentication.Encrypt( authTicket );
            HttpCookie authCookie = new HttpCookie( FormsAuthentication.FormsCookieName, encryptedTicket );
            Response.Cookies.Add( authCookie );
            string redirectUrl = FormsAuthentication.GetRedirectUrl( username, false );
            Response.Redirect( redirectUrl );
        }
        else if (Ldap.Prihlasenie(username, password))
        {
            
            Session["ldap_prihlaseny"] = username;
            Response.Redirect("Register.aspx");
        }
        else
        {
            Session["ldap_prihlaseny"] = null;
            ShowError("Nesprvne meno alebo heslo!");
        }
    }
}