using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class PossibleSurveys : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        List<InstanciaAnkety> instanciaAnketyList = InstanciaAnketyDAL.Select();
        List<InstanciaAnkety> possibleSurveys = new List<InstanciaAnkety>();

        for( int i = 0; i < instanciaAnketyList.Count; i++ )
        {
            if( DateTime.Now >= instanciaAnketyList[i].DatumOd && DateTime.Now <= instanciaAnketyList[i].DatumDo )
            {
                List<Odpoved> odpovedList = OdpovedDAL.SelectByInstanciaIdOsobaId( instanciaAnketyList[i].Id, ((CustomPrincipal)User).Id );

                if( odpovedList.Count == 0 )
                {
                    possibleSurveys.Add( instanciaAnketyList[i] );
                }
            }
        }

        if( possibleSurveys.Count == 0 )
        {
            ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
            showError.ID = "UC_EC_NoData";
            showError.ErrorText = "Nenali sa iadne beiace ankety na vyplnenie";
            PH_Control.Controls.Add( showError) ;
        }
        else
        {
            for( int i = 0; i < possibleSurveys.Count; i++ )
            {
                SurveyDescriptionUC surveyDescription = (SurveyDescriptionUC)LoadControl("~/Controls/SurveyDescriptionUC.ascx");
                surveyDescription.ID = "UC_SD_Description_" + i.ToString();
                surveyDescription.Data = possibleSurveys[i];
                PH_Control.Controls.Add( surveyDescription ) ;
                PH_Control.Controls.Add( new LiteralControl("<br />") ) ;
            }
        }
    }
}
