using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class PreviewSurvey : System.Web.UI.Page
{
    private int id;
    private Anketa anketa;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ( ( id = Helper.QStringToInt32( Request["Id"] ) ) != 0 )
        {
            anketa = AnketaDAL.SelectById( id );

            if ( anketa != null )
            {
                    InsertSurvey();
            }
            else
            {
                InsertError();
            }
        }
        else
        {
            InsertError();
        }
    }

    private void InsertError()
    {
        ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
        showError.ID = "UC_EC_NoData";
        showError.ErrorText = "Anketa neexistuje";
        PH_Control.Controls.Add( showError );
    }

    private void InsertSurvey()
    {
        List<Otazka> otazkaList = OtazkaDAL.SelectByAnketaId( anketa.Id );
        otazkaList.Sort( new ObjectComparer<Otazka>( "Id", "ASC" ) );

        ViewQuestionUC viewQuestionUC;

        for( int i = 0; i < otazkaList.Count; i++ )
        {
            viewQuestionUC = (ViewQuestionUC)LoadControl("~/Controls/ViewQuestionUC.ascx");
            viewQuestionUC.ID = "UC_VQ_Question_" + i.ToString();
            viewQuestionUC.QuestionId = otazkaList[i].Id;
            PH_Control.Controls.Add( viewQuestionUC );
            PH_Control.Controls.Add( new LiteralControl("<br />") );
        }
    }
}
