using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;

public partial class Register : System.Web.UI.Page
{
    protected string ldap_prihlaseny;

    protected void Page_Load(object sender, EventArgs e)
    {
        ldap_prihlaseny = null;
        Page.Form.DefaultFocus = TB_Email.ClientID;
        Page.Form.DefaultButton = BN_Register.UniqueID;

        if (Session["ldap_prihlaseny"] != null)
        {
            ChB_IsStuba.Checked = false;
            ChB_IsStuba.Visible = false;
            DDL_Type.Visible = false;
            LA_Type.Visible = false;
	        ldap_prihlaseny = (string)Session["ldap_prihlaseny"];
	        Session["ldap_prihlaseny"] = null;
        }
        LA_Heslo.Visible = ChB_IsStuba.Checked;
        TB_Heslo.Visible = ChB_IsStuba.Checked;
        LA_Meno.Visible = ChB_IsStuba.Checked;
        TB_Meno.Visible = ChB_IsStuba.Checked;
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    protected void BN_Register_Click(object sender, EventArgs e)
    {
        HideStatus();

        if( !Page.IsValid ) return;

        string password = TB_Password.Text;
        string email = TB_Email.Text;
        string fisrtname = TB_Firstname.Text;
        string surename = TB_Surename.Text;
        DateTime birthday = DateTime.Parse( TB_Birthday.Text );
        int graduated = Convert.ToInt32( TB_Graduated.Text );
        string is_login = TB_Meno.Text;
        string is_password = TB_Heslo.Text;

        if(ChB_IsStuba.Checked == true)
        {
            if(Ldap.Prihlasenie(is_login, is_password))
            {
                ldap_prihlaseny = is_login;
            }
            else
            {
                ShowError( "Nesprvne autentifikan daje servera is.stuba.sk!" );
                ldap_prihlaseny = TB_Meno.Text;
                return;
            }
        }

        if (ldap_prihlaseny != null)
        {
            if ( OsobaDAL.SelectByKonto( (string)ldap_prihlaseny ) != null )
            {
                ShowError( "Konto so zadanm menom u existuje!" );
                return;
            }

            if ( OsobaDAL.SelectByEmail( email ) != null )
            {
                ShowError( "Konto viazan na dan email u existuje!" );
                return;
            }

            OsobaDAL.Insert( new Osoba( 0, 1, (string)ldap_prihlaseny, true, CryptoManager.ComputeHash( password, "SHA512", null ), fisrtname, surename, email, birthday ) );

            ldap_prihlaseny = null;
            ShowSuccess( "Konto bolo vytvoren!" );
            return;
        }

        Registracia registracia = RegistraciaDAL.SelectByEmail( Helper.ConvertEmail( email ) );
        
        if( registracia == null ) 
        {
            RegistraciaDAL.Insert( new Registracia( 0, Helper.ConvertEmail( email ), CryptoManager.ComputeHash( password, "SHA512", null ), fisrtname, surename, birthday, graduated, Convert.ToInt32( DDL_Type.SelectedValue ) ) );
            ShowSuccess( "Registrcia bola odoslan" );
        }
        else 
        {
            ShowError( "Registrcia pre tento email u existuje!" );
        }
    }
    protected void ChB_IsStuba_CheckedChanged(object sender, EventArgs e)
    {
        LA_Meno.Visible = TB_Meno.Visible = ChB_IsStuba.Checked;
        LA_Heslo.Visible = TB_Heslo.Visible = ChB_IsStuba.Checked;
    }
}
