using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ShowNotice : System.Web.UI.Page
{
    private int id;
    private Oznam oznam;

    protected void Page_Load(object sender, EventArgs e)
    {


        if ( ( id = Helper.QStringToInt32( Request["Id"] ) ) != 0 )
        {
            oznam = OznamDAL.SelectById(id);

            if ( oznam != null )
            {
                if( oznam.OsobaId == ((CustomPrincipal)User).Id || ((CustomPrincipal)User ).IsInRole("Administrtor") ) InsertNotice( true );
                else InsertNotice( false );
            }
            else
            {
                InsertError();
            }
        }
        else
        {
            InsertError();
        }
    }

    private void InsertError()
    {
        ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
        showError.ID = "UC_EC_NoData";
        showError.ErrorText = "Oznam neexistuje";
        PH_Control.Controls.Add( showError );
    }

    private void InsertNotice( bool edit ) 
    {
        if( edit )
        {
            EditNoticeUC editNotice = (EditNoticeUC)LoadControl("~/Controls/EditNoticeUC.ascx");
            editNotice.ID = "UC_RC_Notice";
            editNotice.Data = oznam;
            PH_Control.Controls.Add( editNotice );
        }
        else
        {
            ViewNoticeUC viewNotice = (ViewNoticeUC)LoadControl("~/Controls/ViewNoticeUC.ascx");
            viewNotice.ID = "UC_RC_Notice";
            viewNotice.Data = oznam;
            PH_Control.Controls.Add(viewNotice);
        }
    }
}
