using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class TakeSurvey : System.Web.UI.Page
{
    private int id;
    private Anketa anketa;
    private InstanciaAnkety instanciaAnkety;
    private List<ViewQuestionUC> viewQuestionList;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ( ( id = Helper.QStringToInt32( Request["Id"] ) ) != 0 )
        {
            instanciaAnkety = InstanciaAnketyDAL.SelectById( id );  

            if ( instanciaAnkety != null )
            {
                anketa = AnketaDAL.SelectById( instanciaAnkety.AnketaId );

                InsertSurvey();
                BN_Send.Visible = true;
            }
            else
            {
                InsertError();
                BN_Send.Visible = false;
            }
        }
        else
        {
            InsertError();
            BN_Send.Visible = false;
        }
    }

    private void ShowError( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Red;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void HideStatus()
    {
        LA_Status.Visible = false;
    }

    private void ShowSuccess( string text )
    {
        LA_Status.ForeColor = System.Drawing.Color.Green;
        LA_Status.Text = text;
        LA_Status.Visible = true;
    }

    private void InsertError()
    {
        ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
        showError.ID = "UC_EC_NoData";
        showError.ErrorText = "Anketa neexistuje";
        PH_Control.Controls.Add( showError );
    }

    private void InsertSurvey()
    {
        List<Otazka> otazkaList = OtazkaDAL.SelectByAnketaId( anketa.Id );
        otazkaList.Sort( new ObjectComparer<Otazka>( "Id", "ASC" ) );

        ViewQuestionUC viewQuestionUC;
        viewQuestionList = new List<ViewQuestionUC>();

        for( int i = 0; i < otazkaList.Count; i++ )
        {
            viewQuestionUC = (ViewQuestionUC)LoadControl("~/Controls/ViewQuestionUC.ascx");
            viewQuestionUC.ID = "UC_VQ_Question_" + i.ToString();
            viewQuestionUC.QuestionId = otazkaList[i].Id;
            viewQuestionUC.InstanceId = instanciaAnkety.Id;
            viewQuestionList.Add( viewQuestionUC );
            PH_Control.Controls.Add( viewQuestionUC );
            PH_Control.Controls.Add( new LiteralControl("<br />") );
        }
    }
    protected void BN_Send_Click(object sender, EventArgs e)
    {
        if( User == null || !User.Identity.IsAuthenticated )
        {
            ShowError("Nemono uloi odpovede!");
            return;
        }

        string format = "Otzka {0}nie je sprvne vyplnen!";
        string wrongAnswers = string.Empty;

        for( int i = 0; i < viewQuestionList.Count; i++ )
        {
            if( !viewQuestionList[i].CanSave() )
            {
                if( wrongAnswers != string.Empty ) format = "Otzky {0}nie s sprvne vyplnen!";
                wrongAnswers += (i + 1).ToString() + " ";
            }
        }

        if( wrongAnswers == string.Empty )
        {
            for (int i = 0; i < viewQuestionList.Count; i++)
            {
                viewQuestionList[i].SaveAnswer( ((CustomPrincipal)User).Id );
            }

            //ShowSuccess( "Odpovede ankety boli odoslan" );
            Response.Redirect("PossibleSurveys.aspx");
        }
        else
        {
            ShowError( string.Format( format, wrongAnswers ) );
        }
    }
}