using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class ViewAnswers : System.Web.UI.Page
{
    private int id;
    private int user;
    private Anketa anketa;
    private InstanciaAnkety instanciaAnkety;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ( ( id = Helper.QStringToInt32( Request["Id"] ) ) != 0  && ( user = Helper.QStringToInt32( Request["User"] ) ) != 0)
        {
            instanciaAnkety = InstanciaAnketyDAL.SelectById( id );
            
            if ( instanciaAnkety != null )
            {
                if( OsobaDAL.SelectById( user ) != null )
                {
                    anketa = AnketaDAL.SelectById(instanciaAnkety.AnketaId);

                    InsertSurvey();
                }
                else InsertError();
            }
            else
            {
                InsertError();
            }
        }
        else
        {
            InsertError();
        }
    }

    private void InsertError()
    {
        ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
        showError.ID = "UC_EC_NoData";
        showError.ErrorText = "Anketa neexistuje";
        PH_Control.Controls.Add( showError );
    }

    private void InsertSurvey()
    {
        List<Otazka> otazkaList = OtazkaDAL.SelectByAnketaId( anketa.Id );
        otazkaList.Sort( new ObjectComparer<Otazka>( "Id", "ASC" ) );

        ViewAnswerUC viewAnswerUC;

        for( int i = 0; i < otazkaList.Count; i++ )
        {
            viewAnswerUC = (ViewAnswerUC)LoadControl("~/Controls/ViewAnswerUC.ascx");
            viewAnswerUC.ID = "UC_VA_Answer_" + i.ToString();
            viewAnswerUC.Question = otazkaList[i];
            viewAnswerUC.InstanceId = instanciaAnkety.Id;
            viewAnswerUC.UserId = user;
            PH_Control.Controls.Add( viewAnswerUC );
            PH_Control.Controls.Add( new LiteralControl("<br />") );
        }
    }
}
