using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ViewProject : System.Web.UI.Page
{
    private int id;
    private Projekt projekt;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ( ( id = Helper.QStringToInt32( Request["Id"] ) ) != 0 )
        {
            projekt = ProjektDAL.SelectById(id);

            if ( projekt != null )
            {
                InsertProject();
            }
            else
            {
                InsertError();
            }
        }
        else
        {
            InsertError();
        }
    }

    private void InsertError()
    {
        ShowErrorUC showError = (ShowErrorUC)LoadControl("~/Controls/ShowErrorUC.ascx");
        showError.ID = "UC_EC_NoData";
        showError.ErrorText = "Projekt neexistuje";
        PH_Control.Controls.Add( showError );
    }

    private void InsertProject() 
    {
        ViewProjectUC viewProject = (ViewProjectUC)LoadControl("~/Controls/ViewProjectUC.ascx");
        viewProject.ID = "UC_RC_Project";
        viewProject.Data = projekt;
        PH_Control.Controls.Add(viewProject);
    }
}